local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_dpd",
InitCommand= function(self)
	beat = 0;
	ianDance = 0;
	danceRight = 1;
	
	flashPoint = 0;
	
	ballX = SCREEN_CENTER_X; 
	ballY = SCREEN_CENTER_Y; 
	if math.random(-100, 101) >= 0 then
		ballVelX = 1.5;
	else
		ballVelX = -1.5;
	end
	
	if math.random(-100, 101) >= 0 then
		ballVelY = 1.5;
	else
		ballVelY = -1.5;
	end
	oldBallVelY = -1;
	ballRot = 1;
	rotSpeed = 1;
	
	paddleRadius = 35;
	
	paddleP1X = 30; 
	paddleP1Y = SCREEN_CENTER_Y; 
	paddleP1Movement = -paddleRadius/3;
	p1UpX = paddleP1X;
	p1UpY = paddleP1Y;
	p1Up = 1;
	p1DownX = paddleP1X;
	p1DownY = paddleP1Y;
	p1Down = 1;
	
	p2UpX = paddleP1X;
	p2UpY = paddleP1Y;
	p2Up = 1;
	p2DownX = paddleP1X;
	p2DownY = paddleP1Y;
	p2Down = 1;
	
	paddleP2X = SCREEN_WIDTH - 30; 
	paddleP2Y = SCREEN_CENTER_Y; 
	paddleP2Movement = -paddleRadius/3
	
	p1ModAmount = 0;
	p2ModAmount = 0;
	
	end,
  Def.Sprite{
    Name= "xtl_actor_epd",
  InitCommand= cmd(x,paddleP1X;y,paddleP1Y),
  StepP1MessageCommand= function(self)
			if  paddleP1Y + 50 >= SCREEN_HEIGHT  then
				paddleP1Movement = -paddleRadius/3;
			end
			if paddleP1Y <= 50 then
				paddleP1Movement = paddleRadius/3;
			end
			self:addy(paddleP1Movement);
			paddleP1Y = paddleP1Y + paddleP1Movement;

			end,
  Texture= "bootiemoverp1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_fpd",
  InitCommand= cmd(x,paddleP2X;y,paddleP2Y),
  StepP2MessageCommand= function(self)
			if  paddleP2Y + 50 >= SCREEN_HEIGHT  then
				paddleP2Movement = -paddleRadius/3;
			end
			if paddleP2Y <= 50 then
				paddleP2Movement = paddleRadius/3;
			end
			
			self:addy(paddleP2Movement);
			paddleP2Y = paddleP2Y + paddleP2Movement;
			
			end,
  Texture= "bootiemoverp2.png",
  },
  Def.Sprite{
    Name= "xtl_actor_gpd",
  InitCommand= cmd(x,paddleP2X;y,paddleP2Y),
  StepP2MessageCommand= function(self)

			self:addy(paddleP2Movement);
		
			if paddleP2Movement > 0  and p2Down == 0 then
				self:addx(-100);
				p2Down = 1;
			end
		
			if paddleP2Movement < 0 and p2Down == 1 then
				self:addx(100);
				p2Down = 0;
			end
			

			
			end,
  Texture= "p2Down.png",
  },
  Def.Sprite{
    Name= "xtl_actor_hpd",
  InitCommand= cmd(x,paddleP2X;y,paddleP2Y),
  StepP2MessageCommand= function(self)

			self:addy(paddleP2Movement);
		
			if paddleP2Movement > 0  and p2Up == 1 then
				self:addx(100);
				p2Up = 0;
			end
		
			if paddleP2Movement < 0 and p2Up == 0 then
				self:addx(-100);
				p2Up = 1;
			end
			

			
			end,
  Texture= "p2Up.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ipd",
  InitCommand= cmd(x,paddleP1X;y,paddleP1Y),
  StepP1MessageCommand= function(self)

			self:addy(paddleP1Movement);
		
			if paddleP1Movement > 0  and p1Down == 0 then
				self:addx(100);
				p1Down = 1;
			end
		
			if paddleP1Movement < 0 and p1Down == 1 then
				self:addx(-100);
				p1Down = 0;
			end
			

			
			end,
  Texture= "p1Down.png",
  },
  Def.Sprite{
    Name= "xtl_actor_jpd",
  InitCommand= cmd(x,paddleP1X;y,paddleP1Y),
  StepP1MessageCommand= function(self)

			self:addy(paddleP1Movement);
		
			if paddleP1Movement > 0  and p1Up == 1 then
				self:addx(-100);
				p1Up = 0;
			end
		
			if paddleP1Movement < 0 and p1Up == 0 then
				self:addx(100);
				p1Up = 1;
			end
			

			
			end,
  Texture= "p1Up.png",
  },
  Def.Sprite{
    Name= "xtl_actor_kpd",
  BootyCommand= function(self)
		beat = GAMESTATE:GetSongBeat();
		
		--SECRET
		if (beat < 68 or beat > 106 and beat < 110 or beat > 268) then
			
			if (ianDance < 30 and danceRight == 1) then
				ianDance = ianDance + 1.5;
			else
				danceRight = 0;
			end
			if (ianDance > -30 and danceRight == 0) then
				ianDance = ianDance - 1.5;
			else
				danceRight = 1;
			end
			self:rotationz(ianDance);

		else
		if (ballX - 38 <= paddleP1X)  and (ballX - 38 > paddleP1X + ballVelX)  and (ballY - 43 < paddleP1Y + paddleRadius) and (ballY + 43 > paddleP1Y - paddleRadius) then
			ballVelX = -(ballVelX - math.random(0, .25));
			
			oldBallVelY = ballVelY;
			ballVelY = ballVelY + math.random(-1, 1);
			
			if ballVelY == 0 then
				ballVelY = oldBallVelY;
			end
			
			
			rotSpeed = -(rotSpeed);
			
			if rotSpeed < 0 and rotSpeed > -100 then
				rotSpeed = rotSpeed - 1;
			end
			
			if rotSpeed > 0 and rotSpeed < 100 then
				rotSpeed = rotSpeed + 1;
			end

		end
		if (ballX + 38 >= paddleP2X ) and (ballX + 38 < paddleP2X + ballVelX)  and (ballY - 43 < paddleP2Y + paddleRadius) and (ballY + 43 > paddleP2Y - paddleRadius) then
			ballVelX = -(ballVelX + 1 + math.random(0, .25));
			
			oldBallVelY = ballVelY;
			ballVelY = ballVelY + math.random(-1, 1);
			
			if ballVelY == 0 then
				ballVelY = oldBallVelY;
			end
			
			rotSpeed = -(rotSpeed);
			
			if rotSpeed < 0 and rotSpeed > -100 then
				rotSpeed = rotSpeed - 1;
			end
			
			if rotSpeed > 0 and rotSpeed < 100 then
				rotSpeed = rotSpeed + 1;
			end
		end
		
		
		if (ballX > SCREEN_WIDTH + 10) then
			self:x(SCREEN_CENTER_X);
			self:y(SCREEN_CENTER_Y);
			ballX = SCREEN_CENTER_X;
			ballY = SCREEN_CENTER_Y;
			rotSpeed = 1;
			ballRot = 0;
			if math.random(-100, 101) >= 0 then
				ballVelX = 1.5;
			else
				ballVelX = -1.5;
			end
			
			p2ModAmount = p2ModAmount + 75;
			GAMESTATE:ApplyGameCommand('mod,' .. p2ModAmount .. '% tipsy',2);
			GAMESTATE:ApplyGameCommand('mod,' .. p2ModAmount .. '% drunk',2);
			if math.random(-100, 101) >= 0 then
				ballVelY = 1.5;
			else
				ballVelY = -1.5;
			end
		end
		
		if (ballX < -10) then
			self:x(SCREEN_CENTER_X);
			self:y(SCREEN_CENTER_Y);
			ballX = SCREEN_CENTER_X;
			ballY = SCREEN_CENTER_Y;
			if math.random(-100, 101) >= 0 then
				ballVelX = 1.5;
			else
				ballVelX = -1.5;
			end
	
			p1ModAmount = p1ModAmount + 75;
			GAMESTATE:ApplyGameCommand('mod,' .. p1ModAmount .. '% tipsy',1);
			GAMESTATE:ApplyGameCommand('mod,' .. p1ModAmount .. '% drunk',1);
	
			if math.random(-100, 101) >= 0 then
				ballVelY = 1.5;
			else
				ballVelY = -1.5;
			end
			rotSpeed = 1;
			ballRot = 0;
		end	
		
		if (ballY >= SCREEN_HEIGHT - 50) then
			ballVelY = -ballVelY;
		end
		
		if (ballY <= 50) then
			ballVelY = -ballVelY;
		end	

		
			self:addx(ballVelX);
			self:addy(ballVelY);

			if ballRot >=359 then
				ballRot = 0;
			end
			ballRot = ballRot + rotSpeed;
			self:rotationz(ballRot);			
			ballY = ballY + ballVelY;
			ballX = ballX + ballVelX;
		end
			self:sleep(.01);
			self:queuecommand('Booty');
		end,
  InitCommand= cmd(x,ballX;y,ballY),
  OnCommand= function(self)
			 self:queuecommand('Booty');
			 end,
  Texture= "ball.png",
  },
  Def.Sprite{
    Name= "xtl_actor_lpd",
  HotCommand= function(self)
		
		-- ##############################################################################
		-- It looks like these beat numbers are no longer accurate, after I synced it
		-- You can probably figure out what to change them to, Mike.
		-- hugs,
		-- dan/dbk2
		--THANKS FOR SYNCING THIS DAN :) <3
		-- ##############################################################################
		
		if beat >= 84  and beat <= 105.75 or beat > 109.5 and beat < 172 or beat > 268 then
			if (flashPoint <= .5 and flashUp == 1) then
			flashPoint = flashPoint + .1;
			else
			flashUp = 0;
			end
			
			if (flashPoint > 0 and flashUp == 0) then
			flashPoint = flashPoint - .1;
			else
			flashUp = 1;
			end
			self:diffusealpha(flashPoint);
		end
		self:sleep(.066);
		self:queuecommand('Hot');
		end,
  InitCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;diffusealpha,0),
  OnCommand= function(self)
			self:queuecommand('Hot');
		end,
  Texture= "flashBack.png",
  },
  Def.Quad{
    Name= "xtl_actor_mpd",
  OnCommand= cmd(diffusealpha,0;sleep,1000),
  },
}