local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_qjg",
  Def.Quad{
    Name= "xtl_actor_rjg",
  InitCommand= cmd(draworder,0;hibernate,2;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffusealpha,0),
  OnCommand= cmd(linear,1;diffuse,color('#0e1a19');sleep,62),
  },
  Def.Sprite{
    Name= "xtl_actor_sjg",
  InitCommand= cmd(draworder,1),
  OnCommand= function(self)
					self:x(SCREEN_CENTER_X);
					self:y(SCREEN_CENTER_Y);
					self:sleep(1.5);
					self:linear(1);
					self:diffusealpha(0);
			end;,
  Texture= "psychomantis",
  },
  Def.Quad{
    Name= "xtl_actor_tjg",
  AudioCommand= function(self)
				if Year() >= 2013 and MonthOfYear() >= 1 and DayOfMonth() >= 26 then
					local songname = GAMESTATE:GetCurrentSong():GetSongDir();
					SOUND:PlayOnce(songname..'../Polkamon/everybody/hmm/bonus2.ogg');
				end;
			end;,
  OnCommand= cmd(queuecommand,"Audio"),
  },
  Def.Quad{
    Name= "xtl_actor_ujg",
  InitCommand= cmd(draworder,2;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtoheight,SCREEN_HEIGHT/3 + 3),
  OnCommand= cmd(diffuse,color('#779b94');linear,0.4;zoomtowidth,SCREEN_WIDTH-140+3),
  },
  Def.Quad{
    Name= "xtl_actor_vjg",
  InitCommand= cmd(draworder,3;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(diffuse,color('#0e1a19');linear,0.4;zoomtowidth,SCREEN_WIDTH-140),
  },
  Def.Quad{
    Name= "xtl_actor_wjg",
  InitCommand= cmd(draworder,4;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y + -240;diffuse,color('#779b94')),
  OnCommand= cmd(linear,0.4;zoomtowidth,SCREEN_WIDTH/2.5 + 3;zoomtoheight,SCREEN_HEIGHT/3 + 3),
  },
  Def.Quad{
    Name= "xtl_actor_xjg",
  InitCommand= cmd(draworder,5;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y + -240;diffuse,color('#0e1a19')),
  OnCommand= cmd(linear,0.4;zoomtowidth,SCREEN_WIDTH/2.5;zoomtoheight,SCREEN_HEIGHT/3),
  },
  Def.Quad{
    Name= "xtl_actor_yjg",
  InitCommand= cmd(draworder,6;hibernate,5;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y + -240),
  OnCommand= cmd(diffuse,color('#779b94');linear,0.4;zoomtowidth,SCREEN_WIDTH/2.5 + 3;zoomtoheight,SCREEN_HEIGHT/3;sleep,1),
  },
  Def.Sprite{
    Name= "xtl_actor_zjg",
  InitCommand= cmd(draworder,7;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/2.5 - 2;zoomtoheight,SCREEN_HEIGHT/3 - 2),
  OnCommand= cmd(diffusealpha,0;sleep,0.4;linear,0.4;diffusealpha,1;sleep,100),
  Texture= "channel.png",
  },
  Def.Quad{
    Name= "xtl_actor_akg",
  InitCommand= cmd(draworder,8;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_BOTTOM - SCREEN_HEIGHT/3),
  OnCommand= cmd(sleep,0.6;diffuse,color('#779b94');linear,0.4;zoomtowidth,SCREEN_WIDTH/1.29 + 3;zoomtoheight,SCREEN_HEIGHT/3 + 3),
  },
  Def.Quad{
    Name= "xtl_actor_bkg",
  InitCommand= cmd(draworder,9;hibernate,4;x,SCREEN_CENTER_X;y,SCREEN_BOTTOM - SCREEN_HEIGHT/3),
  OnCommand= cmd(sleep,0.6;diffuse,color('#0e1a19');linear,0.4;zoomtowidth,SCREEN_WIDTH/1.29;zoomtoheight,SCREEN_HEIGHT/3),
  },
  Def.Sprite{
    Name= "xtl_actor_ckg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,6.5;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,10;hibernate,4.5;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "colonel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_dkg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,9;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,11;hibernate,12;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "psychomantis2.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ekg",
  AppearCommand= cmd(linear,0.1;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,2;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,12;hibernate,19.75;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "df.mpg",
  },
  Def.Sprite{
    Name= "xtl_actor_fkg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,1.8;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,13;hibernate,22.2;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "colonel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_gkg",
  AppearCommand= cmd(linear,0.2;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,1.2;linear,0.1;diffusealpha,0),
  InitCommand= cmd(draworder,14;hibernate,24.2;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "kyle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_hkg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,1.8;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,15;hibernate,25.1;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "colonel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ikg",
  AppearCommand= cmd(linear,0.1;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,3.25;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,16;hibernate,26.1;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "homestar.png",
  },
  Def.Sprite{
    Name= "xtl_actor_jkg",
  AppearCommand= cmd(linear,0.1;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,2.8;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,17;hibernate,29.55;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "jd.mpg",
  },
  Def.Sprite{
    Name= "xtl_actor_kkg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,2;linear,0.1;diffusealpha,0),
  InitCommand= cmd(draworder,18;hibernate,33;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "colonel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_lkg",
  AppearCommand= cmd(linear,0.1;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,1.85;linear,0.08;diffusealpha,0),
  InitCommand= cmd(draworder,19;hibernate,35.15;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "jd.mpg",
  },
  Def.Sprite{
    Name= "xtl_actor_mkg",
  AppearCommand= cmd(linear,0.1;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,0.5;linear,0.1;diffusealpha,0),
  InitCommand= cmd(draworder,20;hibernate,37;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "otacon.png",
  },
  Def.Sprite{
    Name= "xtl_actor_nkg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,7;linear,0.1;diffusealpha,0),
  InitCommand= cmd(draworder,21;hibernate,37.85;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "windeu.png",
  },
  Def.Sprite{
    Name= "xtl_actor_okg",
  AppearCommand= cmd(linear,0.1;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,5;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,22;hibernate,45.65;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoom,0),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "colonel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_pkg",
  AppearCommand= cmd(linear,0.1;diffusealpha,1;queuecommand,"Disappear"),
  DisappearCommand= cmd(sleep,10;linear,0.1;zoom,0),
  InitCommand= cmd(draworder,23;hibernate,51;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,-1 * 190;queuecommand,"Appear"),
  Texture= "dbk2.png",
  },
  Def.Sprite{
    Name= "xtl_actor_qkg",
  AppearCommand= cmd(sleep,65;queuecommand,"Disappear"),
  DisappearCommand= cmd(linear,0.3;diffusealpha,0),
  InitCommand= cmd(draworder,24;hibernate,4.5;x,SCREEN_CENTER_X;y,SCREEN_HEIGHT/4;zoomtowidth,SCREEN_WIDTH/6;zoomtoheight,SCREEN_HEIGHT/3),
  OnCommand= cmd(addx,190;queuecommand,"Appear"),
  Texture= "snake.png",
  },
  Def.BitmapText{
    Name= "xtl_actor_rkg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,25),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);
			self:hibernate(5.3);
			self:settext('Colonel, your niece is going to be okay.');
			self:sleep(2.5);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_skg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,26),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);	
			self:hibernate(8.5);
			self:settext('Thanks Snake.  I owe you one.');
			self:sleep(2.5);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_tkg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,27),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);		
			self:hibernate(12.4);
			self:settext('You!');
			self:sleep(1);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_ukg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,28),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);		
			self:hibernate(13.5);
			self:settext('You doubt my power?');
			self:sleep(2.5);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_vkg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,29),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);		
			self:hibernate(16.8);
			self:settext('Now, I will show you why I am...');
			self:sleep(2.75);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_wkg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,30),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);		
			self:hibernate(22.9);
			self:settext('Hey, what\'s your name?');
			self:sleep(1.3);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_xkg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,31),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);		
			self:hibernate(24.3);
			self:settext('KYLE!');
			self:sleep(0.55);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_ykg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,32),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);		
			self:hibernate(25);
			self:settext('Strange codename...');
			self:sleep(1.25);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_zkg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,33),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(1.2);	
			self:hibernate(26.25);
			self:settext('ert+\ny76p; \'01u8jykee;u4p;e\'Rh\nStrong bai5456\'--------++++++gf\n+++++--//==============/*6901ikg');
			self:sleep(2.4);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_alg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,34),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(28.75);
			self:settext('What\s going on?!');
			self:sleep(1.5);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_blg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,35),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(33.1);
			self:settext('You\'re all just a bunch of sadists!');
			self:sleep(1.85);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_clg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,36),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(36.9);
			self:settext('Otacon!');
			self:sleep(0.75);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_dlg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,37),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(37.8);
			self:settext('When I played Xepher on Expert');
			self:sleep(1.25);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_elg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,38),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(39.3);
			self:settext('MY LEG CAME OFF!');
			self:sleep(1);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_flg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,39),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(40.8);
			self:settext('Keep it anyway.\nIt may come in handy...');
			self:sleep(2);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_glg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,40),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(43.1);
			self:settext('I passd with a Q, though.');
			self:sleep(1.8);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_hlg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,41),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(45.7);
			self:settext('This is making my head hurt...');
			self:sleep(2);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_ilg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,42),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);
			self:hibernate(51);
			self:settext('This was really fun to make!\nThanks everyone!');
			self:sleep(2.3);
			self:linear(0.5);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_jlg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,43),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(0.85);			
			self:hibernate(53.5);
			self:settext('Hugs,\ndbk2 / Dan');
			self:sleep(2.3);
			self:linear(0.5);
			self:diffusealpha(0);
		end;,
  },
  Def.BitmapText{
    Name= "xtl_actor_klg",
  Font= ""_eurostile normal",",
  InitCommand= cmd(draworder,44),
  OnCommand= function(self)
			self:x(SCREEN_CENTER_X);
			self:y( SCREEN_BOTTOM - SCREEN_HEIGHT/3);
			self:draworder(20);
			self:diffuse(0.4667,0.6078,0.5803,1);
			self:zoom(1);
			
			self:hibernate(58.33);
			self:settext('D.O.W.N.S. 2013');
			self:sleep(2.5);
			self:linear(1);
			self:diffusealpha(0);
		end;,
  },
}