local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_hch",
  Def.Quad{
    Name= "xtl_actor_ich",
  InitCommand= function(self)
				arrowWidth = 64;
				field_y = 110;
				

				
				-- at least TRY to fix positioning for both 4:3 and 16:9
				-- the values 64 and 118 were found via trial and error...
				if SCREEN_WIDTH/SCREEN_HEIGHT < 1.4 then
					p1_leftX = 64;
					p2_leftX = SCREEN_RIGHT - (64 + (64*3));
				else
					p1_leftX = 118;
					p2_leftX = SCREEN_RIGHT - (118 + (64*3));
				end

				
				
				p1_downX = p1_leftX + arrowWidth;
				p1_upX	 = p1_downX + arrowWidth;
				p1_rightX= p1_upX + arrowWidth;

				p2_downX = p2_leftX + arrowWidth;
				p2_upX	 = p2_downX + arrowWidth;
				p2_rightX= p2_upX + arrowWidth;					
			end,
  OnCommand= cmd(queuecommand,"Wombo"),
  WomboCommand= function(self)
				songname = GAMESTATE:GetCurrentSong():GetSongDir();
				SOUND:PlayOnce(songname..'animations/animation10/splash.ogg');
				SOUND:PlayOnce(songname..'animations/animation10/sounds/sound'..math.random(1,6) ..'.ogg');
			end,
  },
  Def.Sprite{
    Name= "xtl_actor_jch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p1_leftX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_kch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p1_downX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_lch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p1_upX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_mch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p1_rightX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_nch",
  InitCommand= cmd(zoom,0.05),
  OnCommand= function(self)
				self:x(p1_upX - arrowWidth/2);
				self:y(field_y + self:GetHeight()/2);
				self:hibernate(0.12);
				--
				self:linear(0.48);
				self:zoom(1);
				self:diffusealpha(1);
				--
				self:decelerate(1.12);
				self:rotationz(270);
				self:zoom(0.05);
				self:diffusealpha(0);
			end,
  Texture= "fc-wheel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_och",
  InitCommand= cmd(zoom,0.05),
  OnCommand= function(self)
				self:x(p1_upX - arrowWidth/2);
				self:y(field_y + self:GetHeight()/2);
				self:hibernate(0.12);
				--
				self:linear(0.48);
				self:zoom(0.5);
				self:diffusealpha(1);
				--
				self:linear(0.48);
				self:diffusealpha(0);
			end,
  Texture= "pfc.png",
  },
  Def.Sprite{
    Name= "xtl_actor_pch",
  OnCommand= function(self)
				self:x(p1_upX - arrowWidth/2);
				self:y(0);
				self:zoomtoheight(SCREEN_HEIGHT*2);
				self:diffusealpha(0);
				self:hibernate(0.12);
				self:linear(0.96);
				self:diffusealpha(0.6);
				self:addx(-1*(arrowWidth*2));
				self:linear(0.12);
				self:diffusealpha(0);
			end,
  Texture= "glow.png",
  },
  Def.Sprite{
    Name= "xtl_actor_qch",
  InitCommand= function(self)
				self:rotationy(180);
			end,
  OnCommand= function(self)
				self:x(p1_upX - arrowWidth/2);
				self:y(0);
				self:zoomtoheight(SCREEN_HEIGHT*2);
				self:diffusealpha(0);
				self:hibernate(0.12);
				self:linear(0.96);
				self:diffusealpha(0.6);
				self:addx(arrowWidth*2);
				self:linear(0.12);
				self:diffusealpha(0);
			end,
  Texture= "glow.png",
  },
  Def.Quad{
    Name= "xtl_actor_rch",
  OnCommand= function(self)
				self:x(p1_upX - arrowWidth/2);
				self:y(0);
				self:zoomtoheight(SCREEN_HEIGHT*2);
				self:hibernate(0.12);
				self:diffuse(1,1,0,0.35);
				self:linear(0.96);
				self:zoomx(arrowWidth*3.25);
				self:linear(0.12);
				self:diffusealpha(0);
			end,
  },
  Def.Sprite{
    Name= "xtl_actor_sch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p2_leftX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_tch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p2_downX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_uch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p2_upX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_vch",
    Frames= {
      {Frame= 0, Delay= 0.08},
      {Frame= 1, Delay= 0.08},
      {Frame= 2, Delay= 0.08},
      {Frame= 3, Delay= 0.08},
      {Frame= 4, Delay= 0.08},
      {Frame= 5, Delay= 0.08},
  },
  InitCommand= function(self)
				self:animate(0);
			end,
  OnCommand= function(self)
				self:x(p2_rightX);
				self:y(field_y);
				self:animate(1);
				self:sleep(0.48);
				self:queuecommand('Stop');
			end,
  StopCommand= cmd(diffusealpha,0;animate,0),
  Texture= "./fc 6x1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_wch",
  InitCommand= cmd(zoom,0.05),
  OnCommand= function(self)
				self:x(p2_upX - arrowWidth/2);
				self:y(field_y + self:GetHeight()/2);
				self:hibernate(0.12);
				--
				self:linear(0.48);
				self:zoom(1);
				self:diffusealpha(1);
				--
				self:decelerate(1.12);
				self:rotationz(270);
				self:zoom(0.05);
				self:diffusealpha(0);
			end,
  Texture= "fc-wheel.png",
  },
  Def.Sprite{
    Name= "xtl_actor_xch",
  InitCommand= cmd(zoom,0.05),
  OnCommand= function(self)
				self:x(p2_upX - arrowWidth/2);
				self:y(field_y + self:GetHeight()/2);
				self:hibernate(0.12);
				--
				self:linear(0.48);
				self:zoom(0.5);
				self:diffusealpha(1);
				--
				self:linear(0.48);
				self:diffusealpha(0);
			end,
  Texture= "pfc.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ych",
  OnCommand= function(self)
				self:x(p2_upX - arrowWidth/2);
				self:y(0);
				self:zoomtoheight(SCREEN_HEIGHT*2);
				self:diffusealpha(0);
				self:hibernate(0.12);
				self:linear(0.96);
				self:diffusealpha(0.6);
				self:addx(-1*(arrowWidth*2));
				self:linear(0.12);
				self:diffusealpha(0);
			end,
  Texture= "glow.png",
  },
  Def.Sprite{
    Name= "xtl_actor_zch",
  InitCommand= function(self)
				self:rotationy(180);
			end,
  OnCommand= function(self)
				self:x(p2_upX - arrowWidth/2);
				self:y(0);
				self:zoomtoheight(SCREEN_HEIGHT*2);
				self:diffusealpha(0);
				self:hibernate(0.12);
				self:linear(0.96);
				self:diffusealpha(0.6);
				self:addx(arrowWidth*2);
				self:linear(0.12);
				self:diffusealpha(0);
			end,
  Texture= "glow.png",
  },
  Def.Quad{
    Name= "xtl_actor_adh",
  OnCommand= function(self)
				self:x(p2_upX - arrowWidth/2);
				self:y(0);
				self:zoomtoheight(SCREEN_HEIGHT*2);
				self:hibernate(0.12);
				self:diffuse(1,1,0,0.35);
				self:linear(0.96);
				self:zoomx(arrowWidth*3.25);
				self:linear(0.12);
				self:diffusealpha(0);
			end,
  },
}