local xtl_cond_qti_result= GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) and not IsFinalStage()

local xtl_cond_oti_result= not GAMESTATE:PlayerIsUsingModifier(0,'Dark')

local xtl_cond_pti_result= not GAMESTATE:PlayerIsUsingModifier(1,'Dark')

local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_rti",
  Def.Quad{
    Name= "xtl_actor_sti",
  InitCommand= cmd(visible,true),
  OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;ZoomToWidth,SCREEN_WIDTH;sleep,300),
  },
  Def.Quad{
    Name= "xtl_actor_tti",
  InitCommand= cmd(visible,true),
  OnCommand= function(self)
			fgcurcommand = 1;
			
			-- SOUND VARIABLES --
			song = SONGMAN:FindSong(GAMESTATE:GetCurrentSong():GetDisplayFullTitle());
			path = song:GetSongDir();
			
			function FindSpeedMod(pn)
				local s;
				
				if SCREENMAN:GetTopScreen():GetChild('PlayerOptionsP'..pn) then
					s = SCREENMAN:GetTopScreen():GetChild('PlayerOptionsP'..pn):GetText();
				else return;
				end
				
				local f = string.find(s,'x,');
				local speed;
				
				if f then speed = tonumber(string.sub(s,1,f-1)); else speed = 1; end
				speed = speed/4;
				
				if string.sub(s,1,1) == 'C' then return; end
				GAMESTATE:ApplyGameCommand('mod,'..speed..'x',pn);
			end
			
			-- Phase table. First index = beat number, second index = speed of transition.
			curphase = 1;
			curind = 1;
			local m = 4;
			local add = 192;
			phasetable = 	{
								{12*m,4},
								{13*m,4},
								{14*m,4},
								
								{31*m,4},
								{47*m,4},
								{63*m,4},
								{87*m,4},
								{95*m,16},
								{95.25*m,16},
								{95.5*m,16},
								{95.75*m,16},
								{102.5*m,8},
								{103*m,8},
								{103.5*m,16},
								{103.75*m,16},
								{110*m,16},
								{110.25*m,16},
								{110.5*m,8},
								{111*m,4},
								{119*m,4},
								{126.5*m,16},
								{126.75*m,16},
								{127*m,8},
								{127.5*m,8},
								{128*m,4},
								{130*m,4},
								{132*m,4},
								{134*m,8},
								{134.5*m,8},
								{135*m,8},
								{135.5*m,8},
								{136*m,4},
								{137*m,4},
								{138*m,4},
								{139*m,4},
								{140*m,4},
								{141*m,4},
								
								{152.5*m,8},
								{153*m,8},
								{153.5*m,4},
								{154.5*m,8},
								{155*m,8},
								{155.5*m,8},
								{156*m,8},
								{156.5*m,8},
								{157*m,8},
								{157.5*m,4},
								{158.5*m,8},
								{159*m,8},
								{159.5*m,4},
								
								{168.5*m,8},
								{169*m,8},
								{169.5*m,4},
								{170.5*m,8},
								{171*m,8},
								{171.5*m,8},
								{172*m,8},
								{172.5*m,8},
								{173*m,8},
								{173.5*m,4},
								{174.5*m,8},
								{175*m,8},
								{175.5*m,4},
								
								{184.5*m,8},
								{185*m,8},
								{185.5*m,4},
								{186.5*m,8},
								{187*m,8},
								{187.5*m,8},
								{188*m,8},
								{188.5*m,8},
								{189*m,8},
								{189.5*m,4},
								{190.5*m,8},
								{191*m,8},
								{191.5*m,4},
								
								{200.5*m,8},
								{201*m,8},
								{201.5*m,4},
								{202.5*m,8},
								{203*m,8},
								{203.5*m,4},
								
								
								
								{(add+31)*m,4},
								{(add+47)*m,4},
								{(add+63)*m,4},
								{(add+87)*m,4},
								{(add+95)*m,16},
								{(add+95.25)*m,16},
								{(add+95.5)*m,16},
								{(add+95.75)*m,16},
								{(add+102.5)*m,8},
								{(add+103)*m,8},
								{(add+103.5)*m,16},
								{(add+103.75)*m,16},
								{(add+110)*m,16},
								{(add+110.25)*m,16},
								{(add+110.5)*m,8},
								{(add+111)*m,4},
								{(add+119)*m,4},
								{(add+126.5)*m,16},
								{(add+126.75)*m,16},
								{(add+127)*m,8},
								{(add+127.5)*m,8},
								{(add+128)*m,4},
								{(add+130)*m,4},
								{(add+132)*m,4},
								{(add+134)*m,8},
								{(add+134.5)*m,8},
								{(add+135)*m,8},
								{(add+135.5)*m,8},
								{(add+136)*m,4},
								{(add+137)*m,4},
								{(add+138)*m,4},
								{(add+139)*m,4},
								{(add+140)*m,4},
								{(add+141)*m,4},
								
								{(add+152.5)*m,8},
								{(add+153)*m,8},
								{(add+153.5)*m,4},
								{(add+154.5)*m,8},
								{(add+155)*m,8},
								{(add+155.5)*m,8},
								{(add+156)*m,8},
								{(add+156.5)*m,8},
								{(add+157)*m,8},
								{(add+157.5)*m,4},
								{(add+158.5)*m,8},
								{(add+159)*m,8},
								{(add+159.5)*m,4},
								
								{(add+168.5)*m,8},
								{(add+169)*m,8},
								{(add+169.5)*m,4},
								{(add+170.5)*m,8},
								{(add+171)*m,8},
								{(add+171.5)*m,8},
								{(add+172)*m,8},
								{(add+172.5)*m,8},
								{(add+173)*m,8},
								{(add+173.5)*m,4},
								{(add+174.5)*m,8},
								{(add+175)*m,8},
								{(add+175.5)*m,4},
								
								{(add+184.5)*m,8},
								{(add+185)*m,8},
								{(add+185.5)*m,4},
								{(add+186.5)*m,8},
								{(add+187)*m,8},
								{(add+187.5)*m,8},
								{(add+188)*m,8},
								{(add+188.5)*m,8},
								{(add+189)*m,8},
								{(add+189.5)*m,4},
								{(add+190.5)*m,8},
								{(add+191)*m,8},
								{(add+191.5)*m,4},
								
								{(add+200.5)*m,8},
								{(add+201)*m,8},
								{(add+201.5)*m,4},
								{(add+202.5)*m,8},
								{(add+203)*m,8},
								{(add+203.5)*m,4}
								
							};
							
				indicator = {};
					for i,v in ipairs(phasetable) do
						table.insert(indicator,phasetable[i][1]-10.5);
					end
			
			self:queuecommand('Update');
		end,
  Update2Command= function(self)
		self:sleep(0.0166666666);
		self:queuecommand('Update');
		end,
  UpdateCommand= function(self)
		
			if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) and not IsFinalStage() then
				function RandomDiff()
					if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
						local curSong = GAMESTATE:GetCurrentSong();
						local vSteps = curSong:GetStepsByStepsType( STEPS_TYPE_DANCE_SINGLE )
						
						if math.random(1,2) == 1 then
							GAMESTATE:SetCurrentSteps(PLAYER_1,vSteps[1]);
							GAMESTATE:SetCurrentSteps(PLAYER_2,vSteps[2]);
						else
							GAMESTATE:SetCurrentSteps(PLAYER_1,vSteps[2]);
							GAMESTATE:SetCurrentSteps(PLAYER_2,vSteps[1]);
						end
						
						SCREENMAN:SetNewScreen('ScreenGameplay');
					end
				end
				
				function SwitchPhase(speed)
					if math.mod(curphase,2) == 0 then
						GAMESTATE:ApplyGameCommand('mod,*'..tostring(speed)..' 50% Stealth',1);
						GAMESTATE:ApplyGameCommand('mod,*'..tostring(speed)..' No Stealth',2);
						MESSAGEMAN:Broadcast('PhaseEven');
					else
						GAMESTATE:ApplyGameCommand('mod,*'..tostring(speed)..' No Stealth',1);
						GAMESTATE:ApplyGameCommand('mod,*'..tostring(speed)..' 50% Stealth',2);
						MESSAGEMAN:Broadcast('PhaseOdd');
					end
				end
				
				if GAMESTATE:GetSongBeat()>=0 and fgcurcommand == 1 then
					RandomDiff();
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				if GAMESTATE:GetSongBeat()>=1 and fgcurcommand == 2 and GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
					GAMESTATE:ApplyGameCommand('mod,Overhead, No Boost, No Brake, No Wave, No Expand, No Bumpy, No Boomerang, No Drunk, No Dizzy, No Mini, No Flip, No Invert, No Tornado, No Tipsy, No Beat,  No Hidden, No Sudden, No Reverse, No Split, No Cross, No Alternate, No Centered, No Blink, No Stealth, No Dark, No Blind, No Cover,1x,C400');
					
					GAMESTATE:ApplyGameCommand('mod,50% Stealth',1);
					GAMESTATE:ApplyGameCommand('mod,No Stealth',2)
					
					
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(SCREEN_CENTER_X);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):x(SCREEN_CENTER_X);
					
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):x(-160);
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):x(-160);
					
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Combo'):x(160);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Judgment'):x(160);
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				
				-- PHASES --
				if curphase <= table.getn(phasetable) and GAMESTATE:GetSongBeat()>=phasetable[curphase][1] then
					SwitchPhase(phasetable[curphase][2]);
					curphase = curphase + 1;
				end
				
				if curind <= table.getn(indicator) and GAMESTATE:GetSongBeat()>=indicator[curind] then
					for i=1,9 do
						if _G['ind'..i]:GetY() == SCREEN_BOTTOM+50 then
							_G['ind'..i]:linear(1.35);
							_G['ind'..i]:y(SCREEN_TOP-50);
							_G['ind'..i]:sleep(0.01);
							_G['ind'..i]:y(SCREEN_BOTTOM+50);
							break;
						end
					end
						
					curind = curind + 1;
				end
			else
				for i = 1,2 do
					FindSpeedMod(i);
				end
			end
			
			
			self:queuecommand('Update2');
		end,
  },
  Def.ActorFrame{
    Name= "xtl_actor_uti",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind1 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_vti",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_wti",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_xti",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind2 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_yti",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_zti",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_aui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind3 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_bui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_cui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_dui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind4 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_eui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_fui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_gui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind5 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_hui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_iui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_jui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind6 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_kui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_lui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_mui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind7 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_nui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_oui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_pui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind8 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_qui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_rui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  Def.ActorFrame{
    Name= "xtl_actor_sui",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_BOTTOM+50); ind9 = self; end,
    optional_actor(xtl_cond_oti_result,
    Def.Quad{
      Name= "xtl_actor_tui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -500;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
    optional_actor(xtl_cond_pti_result,
    Def.Quad{
      Name= "xtl_actor_uui",
    OnCommand= cmd(x,SCREEN_CENTER_X + -140;ZoomToWidth,100;ZoomToHeight,5;rainbow),
    }),
  },
  optional_actor(xtl_cond_qti_result,
  Def.ActorFrame{
    Name= "xtl_actor_vui",
  OnCommand= cmd(x,SCREEN_CENTER_X-175;y,SCREEN_CENTER_Y+100),
    Def.BitmapText{
      Name= "xtl_actor_wui",
    Font= "Common normal,",
    OnCommand= cmd(zoomx,0.5;zoomy,0.75),
    Text= "Your Note,",
    },
    Def.Sprite{
      Name= "xtl_actor_xui",
    OnCommand= cmd(y,SCREEN_CENTER_Y + -190),
    Texture= "litarrow",
    },
    Def.Sprite{
      Name= "xtl_actor_yui",
    OnCommand= cmd(y,SCREEN_CENTER_Y + -190;blend,"BlendMode_Add"),
    PhaseEvenMessageCommand= function(self)
				self:linear(0.5/phasetable[curphase][2]);
				self:diffusealpha(1);
			end,
    PhaseOddMessageCommand= function(self)
				self:linear(0.5/phasetable[curphase][2]);
				self:diffusealpha(0);
			end,
    Texture= "whitearrow",
    },
  }),
  optional_actor(xtl_cond_qti_result,
  Def.ActorFrame{
    Name= "xtl_actor_zui",
  OnCommand= cmd(x,SCREEN_CENTER_X+175;y,SCREEN_CENTER_Y+100),
    Def.BitmapText{
      Name= "xtl_actor_avi",
    Font= "Common normal,",
    OnCommand= cmd(zoomx,0.5;zoomy,0.75),
    Text= "Your Note,",
    },
    Def.Sprite{
      Name= "xtl_actor_bvi",
    OnCommand= cmd(y,SCREEN_CENTER_Y + -190),
    Texture= "litarrow",
    },
    Def.Sprite{
      Name= "xtl_actor_cvi",
    OnCommand= cmd(y,SCREEN_CENTER_Y + -190;diffusealpha,0;blend,"BlendMode_Add"),
    PhaseEvenMessageCommand= function(self)
				self:linear(0.5/phasetable[curphase][2]);
				self:diffusealpha(0);
			end,
    PhaseOddMessageCommand= function(self)
				self:linear(0.5/phasetable[curphase][2]);
				self:diffusealpha(1);
			end,
    Texture= "whitearrow",
    },
  }),
}