local xtl_cond_zvi_result= GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2)

local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_awi",
  Def.Quad{
    Name= "xtl_actor_bwi",
  InitCommand= cmd(visible,true),
  OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;ZoomToWidth,SCREEN_WIDTH;sleep,300),
  },
  optional_actor(xtl_cond_zvi_result,
  Def.Quad{
    Name= "xtl_actor_cwi",
  InitCommand= cmd(visible,true),
  OnCommand= function(self)
			fgcurcommand = 1;
			
			-- SOUND VARIABLES --
			song = SONGMAN:FindSong(GAMESTATE:GetCurrentSong():GetDisplayFullTitle());
			path = song:GetSongDir();
			
			p1scoreprev = 0;
			p2scoreprev = 0;
			p1score = 0;
			p2score = 0;
			
			tracking = 0;
			
			curcheckpoint = 1;
			checkpointtable = {16,48,80,144,176,224,256,320,352};
			
			checkpointend = 1;
			checkpointendtable = {40,72,136,168,200,248,312,344,376};
			
			
			
			self:queuecommand('Update');
		end,
  Update2Command= function(self)
		self:sleep(0.0166666666);
		self:queuecommand('Update');
		end,
  UpdateCommand= function(self)
		
			if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) and not IsFinalStage() then
		
				function RandomDiff()
					if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
						local curSong = GAMESTATE:GetCurrentSong();
						local vSteps = curSong:GetStepsByStepsType( STEPS_TYPE_DANCE_SINGLE )
						
						local r1 = math.random(1,table.getn(vSteps));
						local r2 = math.random(1,table.getn(vSteps));
						while r1 == r2 do
							r2 = math.random(1,table.getn(vSteps));	-- ensure that the charts are different
						end
						
						GAMESTATE:SetCurrentSteps(PLAYER_1,vSteps[r1]);
						GAMESTATE:SetCurrentSteps(PLAYER_2,vSteps[r2]);
						
						SCREENMAN:SetNewScreen('ScreenGameplay');
					end
				end
				
				
				
				
				function CrashSound()
					SOUND:PlayOnce( path..'lua/hit.ogg' );
				end
				
				function EnableTracking()
					p1scoreprev = SCREENMAN:GetTopScreen():GetChild('ScoreP1'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP1'):GetText();
					p2scoreprev = SCREENMAN:GetTopScreen():GetChild('ScoreP2'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP2'):GetText();
					
					p1scoreprev = tonumber(string.sub(p1scoreprev,1,string.len(p1scoreprev) - 1));
					p2scoreprev = tonumber(string.sub(p2scoreprev,1,string.len(p2scoreprev) - 1));
					
					tracking = 1;
					MESSAGEMAN:Broadcast('CheckpointStart');
				end
				
				function DisableTracking()
					if math.floor(p1score*100+0.5)/100 > math.floor(p2score*100+0.5)/100 then
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):accelerate(0.15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(150);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):decelerate(0.15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(-150);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):sleep(0.15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):linear(0.35);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(200);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(720);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):decelerate(0.7);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(-200);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(1440);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):sleep(0.01);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationy(0);
						MESSAGEMAN:Broadcast('CarCrash');
						MESSAGEMAN:Broadcast('WinnerP1');
				elseif math.floor(p2score*100+0.5)/100 > math.floor(p1score*100+0.5)/100 then
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):accelerate(0.15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(-150);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):decelerate(0.15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(150);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):sleep(0.15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):linear(0.35);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(-200);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(-720);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):decelerate(0.7);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(200);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(-1440);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):sleep(0.01);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationy(0);
						MESSAGEMAN:Broadcast('CarCrash');
						MESSAGEMAN:Broadcast('WinnerP2');
					else
						MESSAGEMAN:Broadcast('Tie');
					end
					tracking = 0;
				end
				
				
				
				
				
				
				
			
				if GAMESTATE:GetSongBeat()>=0 and fgcurcommand == 1 then
					RandomDiff();
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				if GAMESTATE:GetSongBeat()>=1 and fgcurcommand == 2 and GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
					screen = SCREENMAN:GetTopScreen();
					poop = {screen,stats,backdrop};
					
					SCREENMAN:GetTopScreen():GetChild('Overlay'):hidden(1);
					SCREENMAN:GetTopScreen():GetChild('Underlay'):hidden(1);
					
					SCREENMAN:GetTopScreen():addx(SCREEN_CENTER_X);
					SCREENMAN:GetTopScreen():addy(SCREEN_CENTER_Y);
					
					SCREENMAN:GetTopScreen():GetChild('SongBackground'):addx(-SCREEN_CENTER_X);
					SCREENMAN:GetTopScreen():GetChild('SongBackground'):addy(-SCREEN_CENTER_Y);
					SCREENMAN:GetTopScreen():GetChild('SongForeground'):addx(-SCREEN_CENTER_X);
					SCREENMAN:GetTopScreen():GetChild('SongForeground'):addy(-SCREEN_CENTER_Y);
					
					if GAMESTATE:IsHumanPlayer(PLAYER_1) then
						SCREENMAN:GetTopScreen():GetChild('LifeP1'):hidden(1);
						SCREENMAN:GetTopScreen():GetChild('ScoreP1'):hidden(1);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):rotationx(-15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addx(-10-SCREEN_CENTER_X);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):skewx(0.5);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):addy(50-SCREEN_CENTER_Y);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):skewx(-0.5);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):skewx(-0.5);
						SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):addx(20);
					end
					
					if GAMESTATE:IsHumanPlayer(PLAYER_2) then
						SCREENMAN:GetTopScreen():GetChild('LifeP2'):hidden(1);
						SCREENMAN:GetTopScreen():GetChild('ScoreP2'):hidden(1);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):rotationx(-15);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):skewx(0.4);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addx(-120-SCREEN_CENTER_Y);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):addy(50-SCREEN_CENTER_Y);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Judgment'):skewx(-0.4);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Judgment'):addx(20);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Combo'):skewx(-0.4);
						SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Combo'):addx(25);
						
					end
					
					GAMESTATE:ApplyGameCommand('mod,*10000 Reverse,*10000 150% Incoming');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				if GAMESTATE:GetSongBeat()>=10-0.25 and fgcurcommand == 3 then
					SOUND:PlayOnce( path..'lua/3.ogg' );
					MESSAGEMAN:Broadcast('Three');
					fgcurcommand = fgcurcommand + 1;
				end
				if GAMESTATE:GetSongBeat()>=12-0.25 and fgcurcommand == 4 then
					SOUND:PlayOnce( path..'lua/2.ogg' );
					MESSAGEMAN:Broadcast('Two');
					fgcurcommand = fgcurcommand + 1;
				end
				if GAMESTATE:GetSongBeat()>=14-0.25 and fgcurcommand == 5 then
					SOUND:PlayOnce( path..'lua/1.ogg' );
					MESSAGEMAN:Broadcast('One');
					fgcurcommand = fgcurcommand + 1;
				end
				if GAMESTATE:GetSongBeat()>=16-0.25 and fgcurcommand == 6 then
					SOUND:PlayOnce( path..'lua/doit.ogg' );
					MESSAGEMAN:Broadcast('DoIt');
					
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):bob();
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectmagnitude(25,0,50);
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):effectperiod(4);
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):bob();
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):effectmagnitude(-25,0,0);
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Judgment'):effectperiod(4);
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):bob();
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):effectmagnitude(-25,0,0);
					SCREENMAN:GetTopScreen():GetChild('PlayerP1'):GetChild('Combo'):effectperiod(4);
					
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):bob();
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectmagnitude(-10,0,-50);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):effectperiod(4);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Judgment'):bob();
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Judgment'):effectmagnitude(10,0,0);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Judgment'):effectperiod(4);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Combo'):bob();
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Combo'):effectmagnitude(10,0,0);
					SCREENMAN:GetTopScreen():GetChild('PlayerP2'):GetChild('Combo'):effectperiod(4);
					
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				
				if GAMESTATE:GetSongBeat()>=64 and fgcurcommand == 7 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(3);
						v:rotationz(15*multi);
						v:decelerate(3);
						v:rotationz(30*multi);
						v:sleep(5.419);
						v:accelerate(3);
						v:rotationz(15*multi);
						v:decelerate(3);
						v:rotationz(0*multi);
					end
					
					move1 = 3;
					move2 = 30;
					move3 = 5.419;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				if GAMESTATE:GetSongBeat()>=120 and fgcurcommand == 8 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(1);
						v:rotationz(-25*multi);
						v:decelerate(1);
						v:rotationz(-50*multi);
						v:sleep(1.806);
						v:accelerate(1);
						v:rotationz(-25*multi);
						v:decelerate(1);
						v:rotationz(0*multi);
					end
					
					move1 = 1;
					move2 = -50;
					move3 = 1.806;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=140 and fgcurcommand == 9 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(3);
						v:rotationz(25*multi);
						v:decelerate(3);
						v:rotationz(50*multi);
						v:sleep(1.548);
						v:accelerate(3);
						v:rotationz(25*multi);
						v:decelerate(3);
						v:rotationz(0*multi);
					end
					
					move1 = 3;
					move2 = 50;
					move3 = 1.548;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=188 and fgcurcommand == 10 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(1.5);
						v:rotationz(15*multi);
						v:decelerate(1.5);
						v:rotationz(30*multi);
						v:sleep(1.742);
						v:accelerate(1.5);
						v:rotationz(15*multi);
						v:decelerate(1.5);
						v:rotationz(0*multi);
					end
					
					move1 = 1.5;
					move2 = 30;
					move3 = 1.742;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=228 and fgcurcommand == 11 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(0.9);
						v:rotationz(-30*multi);
						v:decelerate(0.9);
						v:rotationz(-60*multi);
						v:sleep(0.271);
						v:accelerate(0.9);
						v:rotationz(-30*multi);
						v:decelerate(0.9);
						v:rotationz(0*multi);
					end
					
					move1 = 0.9;
					move2 = -60;
					move3 = 0.271;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=252 and fgcurcommand == 12 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(1.25);
						v:rotationz(-20*multi);
						v:decelerate(1.25);
						v:rotationz(-40*multi);
						v:sleep(0.807);
						v:accelerate(1.25);
						v:rotationz(-30*multi);
						v:decelerate(1.25);
						v:rotationz(0*multi);
					end
					
					move1 = 1.25;
					move2 = -40;
					move3 = 0.807;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=284 and fgcurcommand == 13 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(1.25);
						v:rotationz(-25*multi);
						v:decelerate(1.25);
						v:rotationz(-50*multi);
						v:sleep(0.807);
						v:accelerate(1.25);
						v:rotationz(-25*multi);
						v:decelerate(1.25);
						v:rotationz(0*multi);
					end
					
					move1 = 1.25;
					move2 = -50;
					move3 = 0.807;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=296 and fgcurcommand == 14 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(1.25);
						v:rotationz(30*multi);
						v:decelerate(1.25);
						v:rotationz(60*multi);
						v:sleep(0.806);
						v:accelerate(1.25);
						v:rotationz(30*multi);
						v:decelerate(1.25);
						v:rotationz(0*multi);
					end
					
					move1 = 1.25;
					move2 = 60;
					move3 = 0.806;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=314 and fgcurcommand == 15 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(0.5);
						v:rotationz(30*multi);
						v:decelerate(0.5);
						v:rotationz(60*multi);
						v:sleep(0.904);
						v:accelerate(0.5);
						v:rotationz(30*multi);
						v:decelerate(0.5);
						v:rotationz(0*multi);
					end
					
					move1 = 0.5;
					move2 = 60;
					move3 = 0.904;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=356 and fgcurcommand == 16 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(0.4);
						v:rotationz(30*multi);
						v:decelerate(0.4);
						v:rotationz(60*multi);
						v:sleep(0.335);
						v:accelerate(0.4);
						v:rotationz(30*multi);
						v:decelerate(0.4);
						v:rotationz(0*multi);
					end
					
					move1 = 0.4;
					move2 = 60;
					move3 = 0.335;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=370 and fgcurcommand == 17 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(0.7);
						v:rotationz(-40*multi);
						v:decelerate(0.7);
						v:rotationz(-80*multi);
						v:sleep(0.103);
						v:accelerate(0.7);
						v:rotationz(-80*multi);
						v:decelerate(0.7);
						v:rotationz(0*multi);
					end
					
					move1 = 0.7;
					move2 = -80;
					move3 = 0.103;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				if GAMESTATE:GetSongBeat()>=384 and fgcurcommand == 18 then
					for i,v in ipairs(poop) do
						local multi;
						if i == 1 then multi = 1; else multi = -1; end
						
						v:accelerate(1.5);
						v:rotationz(25*multi);
						v:decelerate(1.5);
						v:rotationz(50*multi);
						v:sleep(0.775);
						v:accelerate(1.5);
						v:rotationz(25*multi);
						v:decelerate(1.5);
						v:rotationz(0*multi);
					end
					
					move1 = 1.5;
					move2 = 50;
					move3 = 0.775;
					mountains:queuecommand('BgMove');
					
					fgcurcommand = fgcurcommand + 1;
				end
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				if tracking == 1 then
					p1score = SCREENMAN:GetTopScreen():GetChild('ScoreP1'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP1'):GetText();
					p1score = tonumber(string.sub(p1score,1,string.len(p1score) - 1));
					p1score = p1score - p1scoreprev;
					
					p2score = SCREENMAN:GetTopScreen():GetChild('ScoreP2'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP2'):GetText();
					p2score = tonumber(string.sub(p2score,1,string.len(p2score) - 1));
					p2score = p2score - p2scoreprev;
					
					MESSAGEMAN:Broadcast('UpdateScores');
				end
				
				
				
				
				
				-- CHECKPOINTS --
				if curcheckpoint <= table.getn(checkpointtable) and GAMESTATE:GetSongBeat()>=checkpointtable[curcheckpoint] then
					EnableTracking();
					curcheckpoint = curcheckpoint + 1;
				end
				
				if checkpointend <= table.getn(checkpointendtable) and GAMESTATE:GetSongBeat()>=checkpointendtable[checkpointend] then
					DisableTracking();
					checkpointend = checkpointend + 1;
				end
				
				
				
			end
			
			
			
			
			self:queuecommand('Update2');
		end,
  }),
  optional_actor(xtl_cond_zvi_result,
  Def.ActorFrame{
    Name= "xtl_actor_dwi",
  OnCommand= function(self) self:x(SCREEN_CENTER_X); self:y(SCREEN_CENTER_Y); stats = self; end,
    Def.ActorFrame{
      Name= "xtl_actor_ewi",
    OnCommand= cmd(x,-SCREEN_CENTER_X;y,-SCREEN_CENTER_Y),
      Def.ActorFrame{
        Name= "xtl_actor_fwi",
      OnCommand= cmd(x,SCREEN_CENTER_X),
      WinnerP1MessageCommand= cmd(),
      WinnerP2MessageCommand= cmd(),
        Def.BitmapText{
          Name= "xtl_actor_gwi",
        Font= "Common Normal,",
        OnCommand= cmd(x,SCREEN_CENTER_X + -470;y,SCREEN_CENTER_Y-220;diffuse,color('0.25'),1,0.25,1),
        ResetScoreCommand= function(self) self:stopeffect(); self:settext('0.00'); end,
        StallCommand= cmd(sleep,3;queuecommand,"ResetScore"),
        Text= "0.00,",
        UpdateScoresMessageCommand= function(self)
						--self:settext(math.floor(p1score*100+0.5)/100);
						--i'm fixing this because i'm the full gay
						self:settext(string.format('%.2f',p1score))
						if p1score >= p2score then
							self:diffuse(0.25,1,0.25,1);
						else
							self:diffuse(1,0.25,0.25,1);
						end
					end,
        WinnerP1MessageCommand= cmd(finishtweening;pulse;effectperiod,0.5;effectmagnitude,1.5,1,0;queuecommand,"Stall"),
        WinnerP2MessageCommand= cmd(finishtweening;vibrate;effectmagnitude,5,5,0;queuecommand,"Stall"),
        },
        Def.BitmapText{
          Name= "xtl_actor_hwi",
        Font= "Common Normal,",
        OnCommand= cmd(x,SCREEN_CENTER_X + -170;y,SCREEN_CENTER_Y-220;diffuse,color('0.25'),1,0.25,1),
        ResetScoreCommand= function(self) self:stopeffect(); self:settext('0.00'); end,
        StallCommand= cmd(sleep,3;queuecommand,"ResetScore"),
        Text= "0.00,",
        UpdateScoresMessageCommand= function(self)
						--self:settext(math.floor(p2score*100+0.5)/100);
						--look my nigger >:)
						self:settext(string.format('%.2f',p2score))
						if p2score >= p1score then
							self:diffuse(0.25,1,0.25,1);
						else
							self:diffuse(1,0.25,0.25,1);
						end
					end,
        WinnerP1MessageCommand= cmd(finishtweening;vibrate;effectmagnitude,5,5,0;queuecommand,"Stall"),
        WinnerP2MessageCommand= cmd(finishtweening;pulse;effectperiod,0.5;effectmagnitude,1.5,1,0;queuecommand,"Stall"),
        },
      },
      Def.BitmapText{
        Name= "xtl_actor_iwi",
      Font= "Common Normal,",
      OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_TOP+20;zoom,0;rainbow),
      ShowTextCommand= cmd(bounceend,0.3;zoom,1;sleep,2;bouncebegin,0.3;zoom,0),
      Text= ",",
      TieMessageCommand= function(self) self:sleep(0.2); self:settext('Tie!'); self:queuecommand('ShowText'); end,
      WinnerP1MessageCommand= function(self) self:sleep(0.2); self:settext('Player 1 wins!'); self:queuecommand('ShowText'); end,
      WinnerP2MessageCommand= function(self) self:sleep(0.2); self:settext('Player 2 wins!'); self:queuecommand('ShowText'); end,
      },
      Def.Quad{
        Name= "xtl_actor_jwi",
      CheckpointStartMessageCommand= function(self)
					self:diffuse(0,1,0,1);
					self:decelerate(0.49);
					self:cropleft(0);
					self:cropright(0);
					self:linear((checkpointendtable[checkpointend] - checkpointtable[curcheckpoint])*0.48387 - 0.5);
					self:cropleft(0.5);
					self:cropright(0.5);
					self:diffuse(1,0,0,1);
				end,
      OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_TOP+20;ZoomToWidth,200;ZoomToHeight,10;cropleft,0.5;cropright,0.5),
      },
      Def.ActorFrame{
        Name= "xtl_actor_kwi",
      OnCommand= cmd(x,SCREEN_RIGHT;y,SCREEN_TOP;zoom,0.6),
        Def.Sprite{
          Name= "xtl_actor_lwi",
        OnCommand= cmd(horizalign,right;vertalign,top;blend,"BlendMode_Add"),
        Texture= "map",
        },
        Def.Quad{
          Name= "xtl_actor_mwi",
        OnCommand= cmd(x,SCREEN_CENTER_X + -441;y,SCREEN_CENTER_Y + -130;zoom,10;fadetop,0.1;fadebottom,0.1;faderight,0.1;fadeleft,0.1;diffuse,color('#000000')),
        },
        Def.Quad{
          Name= "xtl_actor_nwi",
        OnCommand= cmd(x,SCREEN_CENTER_X + -441;y,SCREEN_CENTER_Y + -130;zoom,10;fadetop,0.1;fadebottom,0.1;faderight,0.1;fadeleft,0.1;diffuseblink;effectperiod,0.25;effectcolor1,#0000FF00;effectcolor2,#0000FFFF;sleep,7.7;queuecommand,"Path"),
        PathCommand= cmd(linear,23;addy,-90;
					linear,5;addx,10;addy,-8;
					linear,5;addx,15;addy,-3;
					linear,5;addx,12;
					linear,12;addx,36;addy,32;
					linear,3;addx,5;
					linear,3;addx,3;addy,-5;
					linear,5;addx,3;addy,-22;
					linear,5;addx,10;addy,-5;
					linear,5;addx,11;addy,5;
					linear,2;addx,3;addy,2;
					linear,10;addy,53;
					linear,5;addx,-14;addy,6;
					linear,2;addx,-4;
					linear,10;addx,-62;addy,-37;
					linear,5;addx,-10;
					linear,5;addx,-2;addy,12;
					linear,5;addx,3;addy,10;
					linear,5;addx,4;addy,7;
					linear,10;addx,60;addy,36;
					linear,2;addx,4;
					linear,5;addx,14;addy,-12;
					linear,2;addx,8;
					linear,5;addx,3;addy,20;
					linear,2;addx,-4;addy,6;
					linear,18;addx,-72;
					linear,2;addx,-2;addy,-4;
					linear,5;addx,-2;addy,-18;
					linear,2;addx,-11;addy,-2;
					linear,5;addx,-2;addy,24;
					linear,2;addx,-4;addy,4;
					linear,2;addx,-6;
					linear,2;addx,-9;addy,-6;
					linear,2;addy,-5),
        },
      },
    },
  }),
  optional_actor(xtl_cond_zvi_result,
  Def.BitmapText{
    Name= "xtl_actor_owi",
  DoItMessageCommand= function(self) self:settext('DO IT!'); self:queuecommand('Show'); end,
  Font= "Common Normal,",
  OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-100;zoom,0),
  OneMessageCommand= function(self) self:settext('1'); self:queuecommand('Show'); end,
  ShowCommand= cmd(sleep,0.05;diffusealpha,1;zoom,3;linear,0.7;diffusealpha,0;zoom,0),
  ThreeMessageCommand= function(self) self:settext('3'); self:queuecommand('Show'); end,
  TwoMessageCommand= function(self) self:settext('2'); self:queuecommand('Show'); end,
  }),
  optional_actor(xtl_cond_zvi_result,
  Def.ActorFrame{
    Name= "xtl_actor_pwi",
  CarCrashMessageCommand= cmd(sleep,0.1;queuecommand,"Crash"),
  CrashMessageCommand= function() CrashSound(); end,
  }),
}