local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_fhk",
InitCommand= cmd(playcommand,"SetupNN"),
SetupNNCommand= function(self)
			NN_SECONDS_PER_BEAT = 60.0 / 144.0;
			
			-- 'Listen up, this next part's important.
			-- The neural network receives known stimulus only up until beat 192.
			-- All future decisions must be made without assistance.
			-- You're on your own.'
			--
			-- Now, for today's weather.
			-- 		Mineday:	20% chance of precipitation
			--		Tuesday:	30% chance of precipitation
			--		Wednesday:	40% chance of precipitation
			--		Thursday:	10% chance of precipitation			
			NN_SECONDS_PER_COUNT = 2;
			NN_SECONDS_WARMUP = 4;
			NN_COUNT = 5;
			NN_SECONDS_COOLDOWN = 0.2;
			NN_PARAMETER = math.random(0, 99);
			NN_RXN = 0;
			NN_DANGER = 192;
			
			-- For converting the probability distribution into another uniform distribution.
			function NN_Rerange(orig_lo, orig_hi, nu_lo, nu_hi, rerange_param)
				return ((rerange_param - orig_lo) / (orig_hi - orig_lo)) * (nu_hi - nu_lo) + nu_lo;
			end
			
			-- Decide when it all goes down.
			
			NN_RXN_HOLDOFF = (NN_SECONDS_PER_COUNT * NN_COUNT + NN_SECONDS_WARMUP) / NN_SECONDS_PER_BEAT;
			
			if NN_PARAMETER < 20 then			-- 192 to 223.75
				NN_RXN = NN_Rerange(0, 20,
									192 + NN_RXN_HOLDOFF, 223.75,
									NN_PARAMETER);
			elseif NN_PARAMETER < 50 then		-- 223.75 to 229.5
				NN_RXN = NN_Rerange(20, 50,
									223.75, 229.5,
									NN_PARAMETER);
			elseif NN_PARAMETER < 90 then		-- 236[+] to 301 (would be 236 to 301, but
												-- Tuesday night is serious business)
				NN_RXN = NN_Rerange(50, 90,
									236 + NN_RXN_HOLDOFF, 301,
									NN_PARAMETER);
			else								-- Thursday
				NN_RXN = 9999;
			end
			
			-- Actually, do none of that if one or more players isn't on Challenge difficulty
			if GAMESTATE:IsPlayerEnabled(0) then
				-- Trace('wow P1 '..tostring(GAMESTATE:GetCurrentSteps(0):GetDifficulty())..' modo');
				if GAMESTATE:GetCurrentSteps(0):GetDifficulty() ~= 4 then
					NN_RXN = 9999;
				end
			end
			if GAMESTATE:IsPlayerEnabled(1) then
				-- Trace('wow P2 '..tostring(GAMESTATE:GetCurrentSteps(1):GetDifficulty())..' modo');
				if GAMESTATE:GetCurrentSteps(1):GetDifficulty() ~= 4 then
					NN_RXN = 9999;
				end
			end
			
			-- Gotta /end/ at that time, not start on it
			NN_RXN_START = NN_RXN * NN_SECONDS_PER_BEAT - NN_SECONDS_WARMUP - NN_SECONDS_PER_COUNT * NN_COUNT;
			
			-- FG setup			
			self:x(SCREEN_CENTER_X);
			self:y(SCREEN_CENTER_Y);
		end,
  Def.Sprite{
    Name= "xtl_actor_ghk",
  ChickenSilkCommand= function(self)				
					self:z(0);				-- between overlay and steps
					if (GAMESTATE:IsPlayerEnabled(0)) then
						GAMESTATE:ApplyGameCommand('mod, *16 dark', 1);
						GAMESTATE:ApplyGameCommand('mod, *16 blind', 1);
					end
					if (GAMESTATE:IsPlayerEnabled(1)) then
						GAMESTATE:ApplyGameCommand('mod, *16 dark', 2);
						GAMESTATE:ApplyGameCommand('mod, *16 blind', 2);
					end	
					-- Trace('Just set z for first blaq');
				end,
  HeyyyLovelyCommand= function(self)				
					if (GAMESTATE:IsPlayerEnabled(0)) then
						GAMESTATE:ApplyGameCommand('mod, *16 no dark', 1);
						GAMESTATE:ApplyGameCommand('mod, *16 no blind', 1);
					end
					if (GAMESTATE:IsPlayerEnabled(1)) then
						GAMESTATE:ApplyGameCommand('mod, *16 no dark', 2);
						GAMESTATE:ApplyGameCommand('mod, *16 no blind', 2);
					end	
				end,
  OnCommand= function(self)
					self:queuecommand('HeyyyLovely');
					self:diffuse(0,0,0,0);
					self:stretchto(-SCREEN_WIDTH / 2, -SCREEN_HEIGHT / 2, SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2);
					self:sleep(NN_DANGER * NN_SECONDS_PER_BEAT - NN_SECONDS_COOLDOWN);
					--self:sleep(0.5);
					self:queuecommand('ChickenSilk');
					self:accelerate(NN_SECONDS_COOLDOWN);
					self:diffusealpha(1);
					
					-- Keep alive.
					self:sleep(1000);
				end,
  Texture= "blaq",
  },
  Def.Sprite{
    Name= "xtl_actor_hhk",
  CountdownCommand= function(self)
					self:diffuse(255,0,0,1);
					self:linear(NN_SECONDS_PER_COUNT * NN_COUNT);
					self:rotationz(-360*NN_COUNT);
				end,
  ExclamationCommand= function(self)
					self:diffuse(255,0,0,0);
					self:sleep(NN_SECONDS_WARMUP);
				end,
  InitCommand= function(self)	
					self:diffusealpha(0);
					self:sleep(NN_RXN_START);
					--self:sleep(1);
					self:queuecommand('PartyBeefs');
					self:queuecommand('Exclamation');
					self:queuecommand('Countdown');
					self:queuecommand('ToffeeNubs');
				end,
  PartyBeefsCommand= function(self)
					self:z(4);			-- between darkness layer and steps
					Trace('Just set z for ring');
				end,
  Texture= "ring",
  ToffeeNubsCommand= function(self)
					self:decelerate(NN_SECONDS_COOLDOWN);
					self:diffusealpha(0);
					self:sleep(1000);
				end,
  },
  Def.Sprite{
    Name= "xtl_actor_ihk",
    Frames= {
      {Frame= 0, Delay= 1},
      {Frame= 1, Delay= 1},
      {Frame= 2, Delay= 1},
      {Frame= 3, Delay= 1},
      {Frame= 4, Delay= 1},
      {Frame= 5, Delay= 1},
  },
  CountdownCommand= function(self)
					self:diffuse(255,0,0,1);
					for NN_second = NN_COUNT,1,-1 do
						self:decelerate(NN_SECONDS_PER_COUNT / 2);
						self:diffusealpha(0.7);
						self:decelerate(NN_SECONDS_PER_COUNT / 2);
						self:diffusealpha(1);
					end
				end,
  ExclamationCommand= function(self)
					self:diffuse(255,0,0,0);					
					self:decelerate(NN_SECONDS_WARMUP);
					self:diffusealpha(1);
				end,
  OnCommand= function(self)
					self:diffusealpha(0);
					self:animate(0);
					self:setstate(5);
					self:sleep(NN_RXN_START);
					--self:sleep(1);
					self:queuecommand('PartyBeefs');
					self:queuecommand('Exclamation');
					self:queuecommand('Countdown');
					self:queuecommand('ToffeeNubs');
				end,
  PartyBeefsCommand= function(self)
					self:z(4);			-- between darkness layer and steps
					Trace('Just set z for numbers.sprite');
				end,
  Texture= "./number_sheet 6x1",
  ToffeeNubsCommand= function(self)
					self:decelerate(NN_SECONDS_COOLDOWN);
					self:diffusealpha(0);
					--self:hidden(1);
					self:sleep(1000);
				end,
  },
  Def.Sprite{
    Name= "xtl_actor_jhk",
  OnCommand= function(self)
					self:diffusealpha(0);
					Trace('Just set z for second blaq');
					self:stretchto(-SCREEN_WIDTH / 2, -SCREEN_HEIGHT / 2, SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2);
					self:sleep(NN_RXN * NN_SECONDS_PER_BEAT);
					self:z(100);			-- over everything
					-- self:sleep(1 + NN_SECONDS_WARMUP + NN_SECONDS_PER_COUNT * NN_COUNT);
					self:accelerate(NN_SECONDS_COOLDOWN);
					self:diffusealpha(1);
					self:queuecommand('Precipitate');
					-- self:hidden(1);
				end,
  PrecipitateCommand= function(self)
					-- It's time.
					
					if (GAMESTATE:IsPlayerEnabled(0)) then
						GAMESTATE:ApplyGameCommand('mod, *16 no dark', 1);
						GAMESTATE:ApplyGameCommand('mod, *16 no blind', 1);
					end
					if (GAMESTATE:IsPlayerEnabled(1)) then
						GAMESTATE:ApplyGameCommand('mod, *16 no dark', 2);
						GAMESTATE:ApplyGameCommand('mod, *16 no blind', 2);
					end	
				
					SCREENMAN:SetNewScreen( GetGameplayNextScreen() );
				end,
  Texture= "blaq",
  },
  Def.Quad{
    Name= "xtl_actor_khk",
  File= blank,
  OnCommand= function(self)
					self:hidden(1);
					self:stretchto(-SCREEN_WIDTH / 2, -SCREEN_HEIGHT / 2, SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2);
					self:queuecommand('Rearrange');
					
					-- Keep alive.
					self:sleep(1000);
				end,
  RearrangeCommand= function(self)			
					-- this next little part unashamedly stolen from Sujeet's Bad Apple!! file
					SCREENMAN:GetTopScreen():SetDrawByZPosition(true);			
					SCREENMAN:GetTopScreen():GetChild('SongBackground'):z(0);
					SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(1);			
					SCREENMAN:GetTopScreen():GetChild('Overlay'):z(2);
					Trace('Just set z for TopScreen children');
					
					-- Love is a Danger Zone in my Heart as Black as Night
					-- follow for more soft gothic thoughts
					if GAMESTATE:IsPlayerEnabled(0) then
					   SCREENMAN:GetTopScreen():GetChild('PlayerP1'):z(5);
					end
					if GAMESTATE:IsPlayerEnabled(1) then
					   SCREENMAN:GetTopScreen():GetChild('PlayerP2'):z(5);
					end
				end,
  },
}