local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_bjk",
  Def.Sprite{
    Name= "xtl_actor_cjk",
  DisplayGuidesCommand= cmd(diffusealpha,1),
  OnCommand= cmd(diffusealpha,0;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT),
  PowerGloveInitMessageCommand= function(self)
			if powglov.IN_EDITOR and powglov.DEBUG then
				self:queuecommand('DisplayGuides')
			end
		end,
  Texture= "guides.png",
  },
  Def.Quad{
    Name= "xtl_actor_djk",
  OnCommand= cmd(diffusealpha,0),
  PushSectionEndedMessageCommand= function(self)
			for i=1,2,1 do
				if powglov.players[i] then
					if powglov.IN_EDITOR then
						local cur_beat = GAMESTATE:GetSongBeat()

						if cur_beat > 252 then
							powglov.push_gloves[i]:hurrytweening(0.1)
							powglov.players[i]:hurrytweening(0.1)
						end
					end

					local dist = 32
					powglov.players[i]:accelerate(0.469*2)
					powglov.players[i]:addx(dist * powglov.outward_x(i))
				end
			end
		end,
  PushSectionStartedMessageCommand= function(self)
			-- this to be its own separate loop because the loop below selects
			-- both indexes for power level calulations
			if powglov.IN_EDITOR then
				for i=1,2,1 do
					if not powglov.power_level[i] then
						powglov.power_level[i] = powglov.calc_power_level(i, 3)
					end
				end
			end

			for i=1,2,1 do
				if powglov.players[i] and powglov.push_gloves[i] then
					local dist = 32
					local max_squish_dist = SCREEN_WIDTH / 4 - 40
					local squish_percent_dist = powglov.power_level[powglov.opposite_player_idx(i)] / 100
					local squish_percent_dist_2 = squish_percent_dist * squish_percent_dist
					local squish_dist = max_squish_dist * squish_percent_dist
					local squish_dist_2 = (squish_percent_dist * squish_percent_dist) * max_squish_dist

					powglov.push_gloves[i]:decelerate(0.469/4)
					powglov.push_gloves[i]:addx(powglov.inward_x(i) * (dist*2))
					powglov.push_gloves[i]:sleep(0.469*3/4)
					powglov.push_gloves[i]:accelerate(0.469*15)
					powglov.push_gloves[i]:addx(powglov.inward_x(i) * squish_dist_2 * 2)
					powglov.push_gloves[i]:linear(0.469*16)
					powglov.push_gloves[i]:addx(-powglov.inward_x(i) * squish_dist_2 * 2)
					powglov.push_gloves[i]:decelerate(0.469*16)
					powglov.push_gloves[i]:addx(powglov.inward_x(i) * squish_dist_2 * 2)
					powglov.push_gloves[i]:accelerate(0.469*12)
					powglov.push_gloves[i]:addx(-powglov.inward_x(i) * squish_dist_2 * 2)
					powglov.push_gloves[i]:accelerate(0.469*2)
					powglov.push_gloves[i]:addx(-powglov.inward_x(i) * dist * 2)

					powglov.players[i]:decelerate(0.469/4)
					powglov.players[i]:addx(dist * powglov.inward_x(i))
					powglov.players[i]:sleep(0.469*3/4)

					powglov.players[i]:accelerate(0.469*15)
					powglov.players[i]:zoomx(1 - squish_percent_dist_2)
					powglov.players[i]:addx(powglov.inward_x(i) * squish_dist_2)

					powglov.players[i]:linear(0.469*16)
					powglov.players[i]:zoomx(1)
					powglov.players[i]:addx(-powglov.inward_x(i) * squish_dist_2)

					powglov.players[i]:decelerate(0.469*16)
					powglov.players[i]:zoomx(1 - squish_percent_dist_2)
					powglov.players[i]:addx(powglov.inward_x(i) * squish_dist_2)

					powglov.players[i]:accelerate(0.469*12)
					powglov.players[i]:zoomx(1)
					powglov.players[i]:addx(-powglov.inward_x(i) * squish_dist_2)

					powglov.players[i]:accelerate(0.469*2)
					powglov.players[i]:zoomx(1)
				end
			end
		end,
  },
  Def.Sprite{
    Name= "xtl_actor_ejk",
  OnCommand= cmd(horizalign,right;x,SCREEN_LEFT;y,SCREEN_CENTER_Y),
  PowerGloveInitMessageCommand= function(self) powglov.push_gloves[1] = self end,
  Texture= "../fx/powerglove_push.png",
  },
  Def.Sprite{
    Name= "xtl_actor_fjk",
  OnCommand= cmd(rotationz,180;horizalign,right;x,SCREEN_RIGHT;y,SCREEN_CENTER_Y),
  PowerGloveInitMessageCommand= function(self) powglov.push_gloves[2] = self end,
  Texture= "../fx/powerglove_push.png",
  },
  Def.Quad{
    Name= "xtl_actor_gjk",
  HideScoresCommand= function(self)
			for i=1,2,1 do
				local el = SCREENMAN:GetTopScreen():GetChild('ScoreP'..i)

				if el then
					el:decelerate(0.45)
					el:zoomy(2)
					el:rotationx(90+360)
				end

				local life = SCREENMAN:GetTopScreen():GetChild('LifeP'..i)

				if life then
					life:decelerate(0.45)
					life:zoomy(2)
					life:rotationy(90+360)
				end

				local overlay = SCREENMAN:GetTopScreen():GetChild('Overlay')
				if overlay then
					overlay:linear(0.25)
					overlay:zoomx(4)
					overlay:addy(-SCREEN_HEIGHT)
				end
			end
		end,
  OnCommand= cmd(diffusealpha,0;sleep,29.543;queuecommand,"HideScores"),
  PushSectionEndedMessageCommand= function(self)
			for i=1,2,1 do
				if powglov.power_meter_text[i] then
					local dist = 32
					powglov.power_meter_text[i]:decelerate(0.469/4)
					powglov.power_meter_text[i]:addx(dist * powglov.outward_x(i))
				end
			end
		end,
  PushSectionStartedMessageCommand= function(self)
			for i=1,2,1 do
				if powglov.power_meter_text[i] then
					local dist = 32
					powglov.power_meter_text[i]:decelerate(0.469/4)
					powglov.power_meter_text[i]:addx(dist * powglov.inward_x(i))
				end
			end
		end,
  ScoresRevealedMessageCommand= function(self)
			for i=1,2,1 do
				if powglov.players[i] then
					local score = SCREENMAN:GetTopScreen():GetChild('ScoreP'..i)

					-- hack: no score in editor, use something similar in stature
					if powglov.IN_EDITOR then
						score = powglov.power_meter_text[i]
					end

					if score then
						score:sleep(0)
						score:y(SCREEN_CENTER_Y)
						score:x(SCREEN_CENTER_X + powglov.outward_x(i) * SCREEN_WIDTH / 4)
						score:zoom(26)
						score:rotationx(0)
						score:rotationz(360 * 18)
						score:decelerate(0.469*6)
						score:zoom(1.25)
						score:rotationz(0)
						score:sleep(0)
						score:effectclock('bgm')
						score:wag()
					end
				end
			end
		end,
  },
  Def.Quad{
    Name= "xtl_actor_hjk",
  OnCommand= cmd(diffusealpha,0;sleep,44.309;queuecommand,"ResetHallway";sleep,15.246;queuecommand,"ResetHallway"),
  ResetHallwayCommand= function(self) GAMESTATE:ApplyGameCommand('mod,*12 No Hallway') end,
  },
  Def.Quad{
    Name= "xtl_actor_ijk",
  OnCommand= cmd(diffusealpha,0),
  ScoreTrackingStartedMessageCommand= function(self)
			local charge_round_idx = powglov.charge_round_idx()

			for i=1,2,1 do
				local meter_text = powglov.power_meter_text[i]

				if charge_round_idx < 3 then
					meter_text:queuecommand('StartEffect')
				end
				meter_text:decelerate(0.5)
				meter_text:y(SCREEN_BOTTOM - 235)
			end
		end,
  ScoreTrackingStoppedMessageCommand= function(self)
			local charge_round_idx = powglov.charge_round_idx()

			for i=1,2,1 do
				local meter_text = powglov.power_meter_text[i]
				local xdelta = powglov.inward_x(i) * SCREEN_WIDTH / 2
				if charge_round_idx > 2 then
					xdelta = xdelta + (powglov.outward_x(i) * 64)
				end

				-- xx: ughhhhhhhhh this code is bad
				meter_text:queuecommand('StopEffect')
				meter_text:zoom(2)
				meter_text:sleep(0.469)
				meter_text:decelerate(0.469/2)
				meter_text:y(60)
				meter_text:addx(xdelta)
				meter_text:zoom(2)
				meter_text:sleep(0.469/2)
				meter_text:queuecommand('StartEffect')
				meter_text:zoom(1)
				if charge_round_idx < 3 then
					meter_text:sleep(0.469*14)
				else
					meter_text:sleep(0.469*61)
				end
				meter_text:queuecommand('StopEffect')
				if charge_round_idx >= 3 then
					meter_text:linear(0.469/2)
				end
				meter_text:zoom(2)
				meter_text:decelerate(0.469/2)
				meter_text:addy(-SCREEN_HEIGHT/4)
				meter_text:sleep(0)
				meter_text:y(SCREEN_BOTTOM+120)
				meter_text:addx(-xdelta)
				meter_text:zoom(1)
			end
		end,
  },
  Def.BitmapText{
    Name= "xtl_actor_jjk",
  Font= "_eurostile normal,",
  InitCommand= cmd(draworder,9999),
  LogUpdateMessageCommand= function(self)
			local log_text = 'Log\n-----\n'
			local n = powglov.log_messages_n
			for i=1,n,1 do
				log_text = log_text..powglov.log_messages[i]..'\n'
			end

			self:settext(log_text)
		end,
  OnCommand= cmd(shadowlength,1;diffusealpha,1;vertalign,top;horizalign,right;x,SCREEN_RIGHT;y,SCREEN_TOP;zoom,0.5),
  PowerGloveInitMessageCommand= function(self)
			powglov.message_log = self

			if not powglov.DEBUG then
				self:hidden(1)
			end
		end,
  Text= "Log::-----::,",
  },
  Def.Quad{
    Name= "xtl_actor_kjk",
  EndPunchP1MessageCommand= function(self)
			if powglov.players[1] then
				GAMESTATE:ApplyGameCommand('mod,*12 No Hallway', 1)
			end
		end,
  EndPunchP2MessageCommand= function(self)
			if powglov.players[2] then
				GAMESTATE:ApplyGameCommand('mod,*12 No Hallway', 2)
			end
		end,
  OnCommand= cmd(diffusealpha,0),
  PunchP1MessageCommand= function(self)
			if powglov.players[1] then
				powglov.punch_player(1)

				GAMESTATE:ApplyGameCommand('mod,*4 500% Hallway', 1)
			end
		end,
  PunchP2MessageCommand= function(self)
			if powglov.players[2] then
				powglov.punch_player(2)

				GAMESTATE:ApplyGameCommand('mod,*4 500% Hallway', 2)
			end
		end,
  },
  Def.Sprite{
    Name= "xtl_actor_ljk",
  OnCommand= cmd(diffusealpha,0;x,SCREEN_CENTER_X-SCREEN_WIDTH/4;y,SCREEN_CENTER_Y;texcoordvelocity,0,-5),
  ScoreTrackingStartedMessageCommand= cmd(diffusealpha,1;decelerate,0.600;diffusealpha,0),
  Texture= "charge_indicator.png",
  },
  Def.Sprite{
    Name= "xtl_actor_mjk",
  OnCommand= cmd(diffusealpha,0;x,SCREEN_CENTER_X+SCREEN_WIDTH/4;y,SCREEN_CENTER_Y;texcoordvelocity,0,-5),
  ScoreTrackingStartedMessageCommand= cmd(diffusealpha,1;decelerate,0.600;diffusealpha,0),
  Texture= "charge_indicator.png",
  },
  Def.Quad{
    Name= "xtl_actor_njk",
  AppearCommand= cmd(decelerate,0.469/4;diffusealpha,1),
  DisappearCommand= cmd(decelerate,0.469/2;diffusealpha,0),
  InitCommand= cmd(draworder,100),
  OnCommand= cmd(diffuse,color('0.6'),0.1,0.8,0.9;fadetop,0.45;fadebottom,0.45;fadeleft,0.3;faderight,0.3;
			zoomtoheight,30;x,SCREEN_CENTER_X-SCREEN_WIDTH/4;y,SCREEN_BOTTOM+50),
  PowerGloveInitMessageCommand= function(self) powglov.power_meter[1] = self end,
  StepP1MessageCommand= function(self)
			powglov.update_power_meter(1)
		end,
  },
  Def.Quad{
    Name= "xtl_actor_ojk",
  AppearCommand= cmd(decelerate,0.469/4;diffusealpha,1),
  DisappearCommand= cmd(decelerate,0.469/2;diffusealpha,0),
  InitCommand= cmd(draworder,100),
  OnCommand= cmd(diffuse,color('0.6'),0.1,0.8,0.9;fadetop,0.45;fadebottom,0.45;fadeleft,0.3;faderight,0.3;
			zoomtoheight,30;x,SCREEN_CENTER_X+SCREEN_WIDTH/4;y,SCREEN_BOTTOM+50),
  PowerGloveInitMessageCommand= function(self) powglov.power_meter[2] = self end,
  StepP2MessageCommand= function(self)
			powglov.update_power_meter(2)
		end,
  },
  Def.BitmapText{
    Name= "xtl_actor_pjk",
  Font= "_eurostile normal,",
  InitCommand= cmd(draworder,110),
  OnCommand= cmd(diffusealpha,1;shadowlength,0;diffuse,color('0.9'),0.9,0.9,1;x,SCREEN_CENTER_X-SCREEN_WIDTH/4;y,SCREEN_BOTTOM+50),
  PowerGloveInitMessageCommand= function(self) powglov.power_meter_text[1] = self end,
  StartEffectCommand= cmd(pulse;effectperiod,1;effectmagnitude,2,1.05,1.5;effectclock,bgm),
  StopEffectCommand= cmd(effectmagnitude,1,1,1),
  Text= "0%,",
  },
  Def.BitmapText{
    Name= "xtl_actor_qjk",
  Font= "_eurostile normal,",
  InitCommand= cmd(draworder,110),
  OnCommand= cmd(diffusealpha,1;shadowlength,0;diffuse,color('0.9'),0.9,0.9,1;x,SCREEN_CENTER_X+SCREEN_WIDTH/4;y,SCREEN_BOTTOM+50),
  PowerGloveInitMessageCommand= function(self) powglov.power_meter_text[2] = self end,
  StartEffectCommand= cmd(pulse;effectperiod,1;effectmagnitude,2,1.05,1.5;effectclock,bgm),
  StopEffectCommand= cmd(effectmagnitude,1,1,1),
  Text= "0%,",
  },
  Def.Sprite{
    Name= "xtl_actor_rjk",
  EndPunchP1MessageCommand= cmd(finishtweening),
  InitCommand= cmd(draworder,130),
  OnCommand= cmd(diffusealpha,1;vertalign,bottom;x,SCREEN_CENTER_X-SCREEN_WIDTH/4;y,SCREEN_TOP),
  PowerGloveInitMessageCommand= function(self) powglov.power_gloves[1] = self end,
  PunchP1MessageCommand= function(self)
			local dist = powglov.punch_dist[1]

			--- todo: break out into function
			self:linear(0.234 / 2)
			self:addy(dist)
			self:sleep(0)
			self:vibrate()
			self:sleep(0.234 / 2)
			self:queuecommand('StopEffect')
			self:accelerate(0.234)
			self:addy(-dist)
		end,
  StopEffectCommand= cmd(effectmagnitude,0,0,0),
  Texture= "powerglove.png",
  },
  Def.Sprite{
    Name= "xtl_actor_sjk",
  EndPunchP2MessageCommand= cmd(finishtweening),
  InitCommand= cmd(draworder,130),
  OnCommand= cmd(diffusealpha,1;vertalign,bottom;zoomx,-1;x,SCREEN_CENTER_X+SCREEN_WIDTH/4;y,SCREEN_TOP),
  PowerGloveInitMessageCommand= function(self) powglov.power_gloves[2] = self end,
  PunchP2MessageCommand= function(self)
			local dist = powglov.punch_dist[2]

			self:linear(0.234 / 2)
			self:addy(dist)
			self:sleep(0)
			self:vibrate()
			self:sleep(0.234 / 2)
			self:queuecommand('StopEffect')
			self:accelerate(0.234)
			self:addy(-dist)
		end,
  StopEffectCommand= cmd(effectmagnitude,0,0,0),
  Texture= "powerglove.png",
  },
  Def.BitmapText{
    Name= "xtl_actor_tjk",
  Font= "_eurostile normal,",
  InitCommand= cmd(draworder,125),
  OnCommand= cmd(diffusealpha,1;x,SCREEN_CENTER_X;y,SCREEN_BOTTOM+50;sleep,26.271;
			decelerate,0.250;y,SCREEN_CENTER_Y;
				pulse;effectperiod,1;effectmagnitude,0.7,1.05,1.5;effectclock,bgm;
			sleep,2.812-0.469;queuecommand,"StopEffect";sleep,0.469;
			linear,0.250;addy,-SCREEN_HEIGHT),
  StopEffectCommand= cmd(stopeffect),
  Text= "Step accurately::to build power!,",
  },
  Def.Quad{
    Name= "xtl_actor_ujk",
  InitCommand= cmd(draworder,100),
  OnCommand= cmd(diffuse,color('0'),0,0,0;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;
		sleep,26.262;linear,1;diffusealpha,0.4;sleep,2.812-0.469*1.5;linear,0.15;diffusealpha,0),
  },
  Def.Sprite{
    Name= "xtl_actor_vjk",
  InitCommand= cmd(draworder,121;shadowlength,0;fadebottom,0.01),
  OnCommand= cmd(diffusealpha,0;fadetop,0.01;fadebottom,0;texcoordvelocity,1,0;vertalign,bottom;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y+1;
		sleep,26.262;
		linear,1;diffusealpha,1;
		sleep,2.812-1.25;
		linear,0.25;diffusealpha,0),
  Texture= "directions_bg_top.png",
  },
  Def.Sprite{
    Name= "xtl_actor_wjk",
  InitCommand= cmd(draworder,120;shadowlength,0),
  OnCommand= cmd(diffusealpha,0;texcoordvelocity,-1,0;vertalign,top;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;
		sleep,26.262;
		linear,1;diffusealpha,1;
		sleep,2.812-1.25;
		linear,0.25;diffusealpha,0),
  Texture= "directions_bg_bottom.png",
  },
  Def.Quad{
    Name= "xtl_actor_xjk",
  InitCommand= cmd(queuecommand,"RegisterPackage"),
  OnCommand= cmd(diffusealpha,0;sleep,9999),
  RegisterPackageCommand= function(self)
			local P =	{ }
			powglov =	P
			local scr =	SCREENMAN:GetTopScreen()

			--- game vars
			powglov.p1_power =				0
			powglov.p2_power =				0
			powglov.log_messages_n =		0
			powglov.log_messages_max =		8
			powglov.log_messages =			{ }
			powglov.players =				{scr:GetChild('PlayerP1'), scr:GetChild('PlayerP2')}
			powglov.start_score =			{false, false}
			powglov.power_level =			{false, false}
			powglov.power_meter =			{false, false}
			powglov.power_meter_text =		{false, false}
			powglov.power_gloves =			{false, false}
			powglov.punch_dist =			{false, false}
			powglov.push_gloves =			{false, false}
			powglov.punched_player_idx =	false
			powglov.charge_winner_idx =		false
			powglov.punched_beat =			false
			powglov.message_log =			false
			powglov.push_section_started =	false
			powglov.score_tracking_started = false
			powglov.are_scores_revealed =	false

			-- chart constants for 'build power' sections
			-- ~> edit when editing chart
			powglov.DP_PERCENTS = {
				3.9946, -- m17-m20.75:  24 steps + 6 rolls = 150 DP = ~3.9946% total DP
				3.8356, -- m25-m28.50:  25 steps + 3 rolls = 140 DP = ~3.8356% total DP
				16.990, -- m33-m48.50: 140 steps + 0 rolls = 700 DP = ~16.990% total DP
			}
			powglov.DEBUG = false
			powglov.IN_EDITOR = false
			-- hides ui, players and sets no bg darkening
			powglov.INSPECT_BACKGROUND = false

			-- this flag will indicate to helper functions to return generated
			-- values while in the editor since score is not available
			if GAMESTATE:IsSideJoined(1) and not SCREENMAN:GetTopScreen():GetChild('ScoreP1') then
				powglov.IN_EDITOR = true
			end

			-- helper functions
			function powglov.reveal_scores()
				if powglov.scores_revealed() then return end

				powglov.are_scores_revealed = true

				powglov.log('sending ScoresRevealed message')
				MESSAGEMAN:Broadcast('ScoresRevealed')
			end

			function powglov.scores_revealed()
				return powglov.are_scores_revealed
			end

			function powglov.update_power_meter(player_idx)
				local charge_round_idx = powglov.charge_round_idx()

				if charge_round_idx and powglov.is_score_tracking_started() then
					if powglov.power_meter[player_idx] then
						local level = math.floor(powglov.calc_power_level(player_idx, charge_round_idx))

						powglov.power_meter[player_idx]:decelerate(0.1)
						powglov.power_meter[player_idx]:zoomtowidth(math.floor(3.5 * level))
					end
				end
			end

			function powglov.log(msg)
				if not msg then return end
				if not powglov.DEBUG then return end

				local cur_beat = GAMESTATE:GetSongBeat()
				if not cur_beat then return end

				powglov.log_messages_n = powglov.log_messages_n + 1

				local log_msg = 'b'..string.format('%.2f', cur_beat)
				log_msg = log_msg..': '
				log_msg = log_msg..msg
				table.insert(powglov.log_messages, powglov.log_messages_n, log_msg)

				if powglov.log_messages_n > powglov.log_messages_max then
					table.remove(powglov.log_messages, 1)
					powglov.log_messages_n = powglov.log_messages_n - 1
				end

				MESSAGEMAN:Broadcast('LogUpdate')
			end

			function powglov.set_charging_winner()
				if powglov.power_level[1] > powglov.power_level[2] then
					powglov.charge_winner_idx = 1
				elseif powglov.power_level[2] > powglov.power_level[1] then
					powglov.charge_winner_idx = 2
				else -- you're all losers
					powglov.charge_winner_idx = 0
				end

				powglov.log('charge winner is '..tostring(powglov.charge_winner_idx))
			end

			function powglov.punch_player(player_idx)
				local dist = powglov.punch_dist[player_idx]
				-- targets are approx 137px from top

				-- xx: this always returns 1, and the math is all fucked up
				--- todo: unfuck the math
				local height = self:GetHeight()
				local total = math.floor((dist - 137) - height)
				local field = powglov.players[player_idx]

				--powglov.log('total squish distance (p'..player_idx..'): '..tostring(total))

				-- this works kind of, ehhhh
				if total > 0 then
					field:linear(0.234 / 2)
					field:zoomy(height / total)
					field:sleep(0.234 / 2)
					field:stopeffect()
					field:accelerate(0.230)
					field:zoomy(height)
				end
			end

			function powglov.opposite_player_idx(player_idx)
				if player_idx == 1 then return 2 end
				if player_idx == 2 then return 1 end

				return nil
			end

			function powglov.is_punching_started()
				if powglov.punched_beat then return true end

				return false
			end

			function powglov.reset_punching()
				powglov.punched_player_idx = false
				powglov.charge_winner_idx = false
				powglov.punched_beat = false
				powglov.punch_dist = {false, false}

				powglov.log('punch sequence reset')
			end

			function powglov.start_punching(init_beat)
				if powglov.charge_winner_idx == false then
					return
				end

				powglov.log('charge_winner_idx is '..tostring(powglov.charge_winner_idx))

				if powglov.charge_winner_idx == 0 then
					powglov.punched_player_idx = math.floor(math.random() + 0.5) + 1
				else
					powglov.punched_player_idx = powglov.charge_winner_idx
				end
				powglov.punched_beat = init_beat

				local dist_max = SCREEN_HEIGHT * 3 / 4
				for i=1,2,1 do
					local glove = powglov.power_gloves[i]
					local dist = dist_max * (powglov.power_level[i] / 100)
					powglov.punch_dist[powglov.opposite_player_idx(i)] = dist
				end
			end

			function powglov.do_punching()
				local player_idx = powglov.punched_player_idx
				powglov.punched_beat = powglov.punched_beat + 1

				MESSAGEMAN:Broadcast('PunchP'..player_idx)
				MESSAGEMAN:Broadcast('EndPunchP'..powglov.opposite_player_idx(player_idx))

				powglov.punched_player_idx = powglov.opposite_player_idx(powglov.punched_player_idx)
			end

			function powglov.is_score_tracking_started()
				for i=1,2,1 do
					if powglov.players[i] and powglov.score_tracking_started then
						return true
					end
				end

				return false
			end

			function powglov.get_live_score(player_idx)
				local el = SCREENMAN:GetTopScreen():GetChild('ScoreP'..player_idx)

				if not el or not powglov.players[player_idx] or powglov.IN_EDITOR then
					return 0
				end

				local score = el:GetChild('ScoreDisplayPercentage Percent')
					:GetChild('PercentP'..player_idx):GetText()
				score = string.gsub(score, '%%', '')
				score = math.floor(score * 100) / 100
				score = string.format('%.2f', score)

				return score
			end

			function powglov.start_score_tracking()
				local pl = powglov.players

				for i=1,2,1 do
					if pl[i] then
						powglov.start_score[i] = powglov.get_live_score(i)
					end
				end

				powglov.score_tracking_started = true

				powglov.log('sending ScoreTrackingStarted message')
				MESSAGEMAN:Broadcast('ScoreTrackingStarted')
			end

			function powglov.reset_score_tracking()
				local pl = powglov.players

				for i=1,2,1 do
					if pl[i] then
						powglov.start_score[i] = false
					end
				end

				powglov.score_tracking_started = false

				powglov.log('sending ScoreTrackingReset message')
				MESSAGEMAN:Broadcast('ScoreTrackingReset')
			end

			function powglov.stop_score_tracking()
				powglov.score_tracking_started = false

				powglov.log('sending ScoreTrackingStopped message')
				MESSAGEMAN:Broadcast('ScoreTrackingStopped')
			end

			-- insert power level joke here
			function powglov.record_power_level(dp_percent_index)
				local pl = powglov.players

				for i=1,2,1 do
					local level = powglov.calc_power_level(i, dp_percent_index)
					powglov.power_level[i] = level
				end
			end

			function powglov.calc_power_level(player_idx, dp_percent_index)
				if powglov.IN_EDITOR or not powglov.players[player_idx] then
					-- this should allow reasonable values without two players
					return math.random(75, 100)
				end

				local live_score = powglov.get_live_score(player_idx)
				local start_score = powglov.start_score[player_idx]

				return (live_score - start_score)
					/ powglov.DP_PERCENTS[dp_percent_index] * 100
			end

			function powglov.calc_power_level_percent(player_idx, dp_percent_index)
				return string.format('%.2f', powglov.calc_power_level(player_idx, dp_percent_index))..'%'
			end

			function powglov.charge_round_idx()
				local charge_idx = false
				local cur_beat = GAMESTATE:GetSongBeat()

				if (cur_beat >= 63 and cur_beat < 96) then
					charge_idx = 1
				elseif (cur_beat >= 96 and cur_beat < 127) then
					charge_idx = 2
				elseif (cur_beat >= 128 and cur_beat < 192) then
					charge_idx = 3
				end

				--powglov.log('returning charge_idx = '..tostring(charge_idx))

				return charge_idx
			end

			function powglov.is_score_tracking_reset()
				for i=1,2,1 do
					if powglov.players[i] and not powglov.score_tracking_started and not powglov.start_score[i] then
						return true
					end
				end

				return false
			end

			function powglov.start_push_section()
				if powglov.push_section_started then return end

				powglov.push_section_started = true
				powglov.log('sending PushSectionStarted message')
				MESSAGEMAN:Broadcast('PushSectionStarted')
			end

			function powglov.end_push_section()
				if not powglov.push_section_started then return end

				powglov.push_section_started = false
				powglov.log('sending PushSectionEnded message')
				MESSAGEMAN:Broadcast('PushSectionEnded')
			end

			function powglov.outward_x(player_idx)
				local direction = false

				if player_idx == 1 then
					direction = -1
				elseif player_idx == 2 then
					direction = 1
				end

				return direction
			end

			function powglov.inward_x(player_idx)
				local direction = false

				if player_idx == 1 then
					direction = 1
				elseif player_idx == 2 then
					direction = -1
				end

				return direction
			end

			powglov.log('sending PowerGloveInit message')
			MESSAGEMAN:Broadcast('PowerGloveInit')
		end,
  },
  Def.Quad{
    Name= "xtl_actor_yjk",
  GoCommand= function(self)
			if not (powglov.IN_EDITOR and powglov.INSPECT_BACKGROUND) then return end

			for i=1,2,1 do
				if powglov.players[i] then
					powglov.players[i]:x(-9999)
				end
			end

			-- this doesn't seem to work
			--GAMESTATE:ApplyGameCommand('mod,*1024 -1000% Cover')
		end,
  OnCommand= cmd(diffusealpha,0;queuecommand,"Go";sleep,9999),
  },
  Def.Quad{
    Name= "xtl_actor_zjk",
  LoopBranchCommand= function(self)
			local cur_beat = GAMESTATE:GetSongBeat()

			-- start: track power levels
			-- end: punching (if applicable)
			if (cur_beat >= 63 and cur_beat < 78) or (cur_beat >= 96 and cur_beat < 110) or (cur_beat >= 128 and cur_beat < 190) then
				if not powglov.is_score_tracking_started() then
					powglov.start_score_tracking()
					powglov.log('score tracking started')

					for i=1,2,1 do
						if powglov.players[i] then
							powglov.power_meter_text[i]:settext('0.00%')
							local pm = powglov.power_meter[i]

							pm:queuecommand('Appear')
							pm:decelerate(0.5-0.469/4)
							pm:y(SCREEN_BOTTOM - 235)
						end
					end
				else
					local charge_idx = powglov.charge_round_idx()

					powglov.power_meter_text[1]:settext(powglov.calc_power_level_percent(1, charge_idx))
					powglov.power_meter_text[2]:settext(powglov.calc_power_level_percent(2, charge_idx))
				end

				if powglov.is_punching_started() then
					powglov.reset_punching()
				end
			-- end: track power levels (record)
			elseif (cur_beat >= 78 and cur_beat < 80) or (cur_beat >= 110 and cur_beat < 112) or (cur_beat >= 190 and cur_beat < 192) then
				if powglov.is_score_tracking_started() then
					local charge_round_idx = powglov.charge_round_idx()

					powglov.record_power_level(charge_round_idx)
					powglov.set_charging_winner()
					powglov.stop_score_tracking()

					for i=1,2,1 do
						if powglov.players[i] then
							local pm = powglov.power_meter[i]

							pm:sleep(0.469*0.85)
							--pm:decelerate(0.469/4)
							--pm:y(-60)

							pm:queuecommand('Disappear')

							pm:sleep(0)
							pm:y(SCREEN_BOTTOM+120)
						end
					end
				end
			-- start: punching, set charging winner
			elseif (cur_beat >= 80 and cur_beat < 96) or (cur_beat >= 112 and cur_beat < 127) then
				if not powglov.is_score_tracking_reset() then
					powglov.reset_score_tracking()
				end
				local charge_round_idx = powglov.charge_round_idx()

				if charge_round_idx then
					if not powglov.punched_beat and charge_round_idx < 3 then
						local init_beat = false
						if charge_round_idx == 1 then
							init_beat = 80
						elseif charge_round_idx == 2 then
							init_beat = 112
						end

						powglov.log('ending charge round '..charge_round_idx)
						powglov.start_punching(init_beat)
					end

					local end_beat = false
					if charge_round_idx == 1 then
						end_beat = 95
					elseif charge_round_idx == 2 then
						end_beat = 127
					end

					if charge_round_idx < 3 and powglov.punched_beat and cur_beat >= powglov.punched_beat and cur_beat < end_beat then
						powglov.do_punching()
					end
				end
			elseif (cur_beat >= 192 and cur_beat < 249) then
				if not powglov.push_section_started then
					powglov.start_push_section()
				end
			elseif (cur_beat >= 252 and cur_beat < 254) then
				if powglov.push_section_started then
					powglov.end_push_section()

					GAMESTATE:ApplyGameCommand('mod,*20 No Bumpy')
				end
			elseif (cur_beat >= 320 and cur_beat < 328) then
				powglov.reveal_scores()
			end

			--- todo: clean up magic numbers
			--- todo: do something with the power meter bar
			--- todo: safely delete package on song end
			--- todo: round mod beats to pretty values

			self:sleep(0.0166666) -- 60 fps
			self:queuecommand('LoopBranch')
		end,
  OnCommand= cmd(diffusealpha,0),
  PowerGloveInitMessageCommand= cmd(queuecommand,"LoopBranch"),
  },
  Def.ActorFrame{
    Name= "xtl_actor_akk",
    Def.Quad{
      Name= "xtl_actor_bkk",
    ModsLoopCommand= function(self)
				local cur_beat = GAMESTATE:GetSongBeat()
				
				if powglov.beats_table_n > 0 then
					for i = powglov.beats_table_n, 1, -1 do
						if cur_beat >= powglov.beats_table[i]['BEAT'] then
							GAMESTATE:ApplyGameCommand('mod,' .. powglov.beats_table[i]['MODS'])
						else
							powglov.beats_table_n = i
							break
						end
					end

					self:sleep(0.01666)
					self:queuecommand('ModsLoop')
				end
			end,
    OnCommand= cmd(diffusealpha,0),
    PowerGloveInitMessageCommand= cmd(queuecommand,"RegisterPackage"),
    RegisterPackageCommand= function(self)
				powglov.beats_table = {
					{ ['BEAT'] = 324.00, ['MODS'] = '*1.5 200% Hallway, *2 200% Mini, -400% Centered' },
					{ ['BEAT'] = 320.00, ['MODS'] = '*6 250% Space, *200 901% Bumpy, 38% Flip, *3 85% Stealth, *12 -250% Mini, *200 Blind, Tornado, Centered, *4 500% Tipsy, *6 Dark' },
					{ ['BEAT'] = 319.51, ['MODS'] = '*3.5 No Flip, No Mini' },
					{ ['BEAT'] = 319.50, ['MODS'] = '*1024 No Beat' },
					{ ['BEAT'] = 319.38, ['MODS'] = '*4.5 Flip, No Mini' },
					{ ['BEAT'] = 319.00, ['MODS'] = '*6.5 200% Flip, *2 200% Mini' },
					{ ['BEAT'] = 318.51, ['MODS'] = '*3.5 No Flip, No Mini' },
					{ ['BEAT'] = 318.38, ['MODS'] = '*4.5 Flip, No Mini' },
					{ ['BEAT'] = 318.01, ['MODS'] = '*8 No Stealth, *60 No Dizzy, *6 No Brake, *32 No Drunk' },
					{ ['BEAT'] = 318.00, ['MODS'] = '*6.5 200% Flip, *2 200% Mini' },
					{ ['BEAT'] = 317.50, ['MODS'] = '*4 Stealth, *60 -314% Dizzy, *3 125% Brake, *6 -100% Drunk' },
					{ ['BEAT'] = 317.01, ['MODS'] = '*8 No Stealth, *60 No Dizzy, *6 No Brake, *32 No Drunk' },
					{ ['BEAT'] = 316.50, ['MODS'] = '*4 Stealth, *60 314% Dizzy, *3 125% Brake, *6 Drunk' },
					{ ['BEAT'] = 315.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 315.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 314.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 313.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 313.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 312.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 311.51, ['MODS'] = '*6.5 No Hallway' },
					{ ['BEAT'] = 311.00, ['MODS'] = '*6.5 200% Hallway' },
					{ ['BEAT'] = 310.51, ['MODS'] = '*6.5 No Distant' },
					{ ['BEAT'] = 310.01, ['MODS'] = '*6.5 200% Distant' },
					{ ['BEAT'] = 309.50, ['MODS'] = '*60 No Bumpy, *2.5 No Boost, *6 No Tipsy' },
					{ ['BEAT'] = 309.01, ['MODS'] = '*60 -750% Bumpy, *2.5 200% Boost, *6 400% Tipsy' },
					{ ['BEAT'] = 309.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 308.25, ['MODS'] = '*2 No Alternate, *2 No Reverse' },
					{ ['BEAT'] = 308.00, ['MODS'] = '*2 -100% Alternate, *2 Reverse' },
					{ ['BEAT'] = 308.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 307.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 307.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 306.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 305.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 305.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 304.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 303.76, ['MODS'] = '*6 No Tornado, No Flip, *64 No Bumpy, *18 No Hallway' },
					{ ['BEAT'] = 303.51, ['MODS'] = '*7 No Mini, *4 -100% Tornado, Flip, *64 -1000% Bumpy, *16 250% Hallway' },
					{ ['BEAT'] = 303.25, ['MODS'] = '*3 200% Mini, *6 No Tornado, *1.5 No Flip, *2.25 No Invert, *64 No Bumpy, *18 No Hallway' },
					{ ['BEAT'] = 303.00, ['MODS'] = '*7 No Mini, *4 100% Tornado, *1.5 75% Flip, *2.25 -125% Invert, *64 1000% Bumpy, *16 250% Hallway' },
					{ ['BEAT'] = 302.75, ['MODS'] = '*3 200% Mini, *6 No Tornado, *2 No Flip, *64 No Bumpy, *18 No Hallway' },
					{ ['BEAT'] = 302.51, ['MODS'] = '*7 No Mini, *4 -90% Tornado, *2 Flip, *64 -1000% Bumpy, *16 250% Hallway' },
					{ ['BEAT'] = 301.75, ['MODS'] = '*5 No Centered, *12 No Tornado' },
					{ ['BEAT'] = 301.50, ['MODS'] = '*5 Centered, *8 Tornado' },
					{ ['BEAT'] = 301.50, ['MODS'] = '*32 No Tipsy' },
					{ ['BEAT'] = 301.01, ['MODS'] = '*8 No Stealth, *60 No Dizzy, *6 No Brake, *32 No Drunk, *8 150% Tipsy' },
					{ ['BEAT'] = 300.50, ['MODS'] = '*4 Stealth, *60 314% Dizzy, *3 125% Brake, *6 Drunk' },
					{ ['BEAT'] = 299.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 299.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 298.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 297.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 297.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 296.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 295.51, ['MODS'] = '*6.5 No Hallway' },
					{ ['BEAT'] = 295.00, ['MODS'] = '*6.5 200% Hallway' },
					{ ['BEAT'] = 294.51, ['MODS'] = '*6.5 No Distant' },
					{ ['BEAT'] = 294.01, ['MODS'] = '*6.5 200% Distant' },
					{ ['BEAT'] = 293.50, ['MODS'] = '*60 No Bumpy, *2.5 No Boost, *6 No Tipsy' },
					{ ['BEAT'] = 293.01, ['MODS'] = '*60 750% Bumpy, *2.5 200% Boost, *6 400% Tipsy' },
					{ ['BEAT'] = 293.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 292.25, ['MODS'] = '*2 No Alternate' },
					{ ['BEAT'] = 292.00, ['MODS'] = '*2 Alternate' },
					{ ['BEAT'] = 292.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 291.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 291.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 290.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 289.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 289.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 288.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 287.76, ['MODS'] = '*10 No Brake' },
					{ ['BEAT'] = 287.63, ['MODS'] = '*8 No Stealth, *6 No Dark' },
					{ ['BEAT'] = 287.51, ['MODS'] = '*8 200% Brake' },
					{ ['BEAT'] = 287.51, ['MODS'] = '*80 75% Stealth, *6 90% Dark' },
					{ ['BEAT'] = 287.50, ['MODS'] = '*1024 150% Beat' },
					{ ['BEAT'] = 287.38, ['MODS'] = '*80 Stealth, *6 80% Dark' },
					{ ['BEAT'] = 287.25, ['MODS'] = '*80 75% Stealth, *200 No Invert, *6 90% Dark' },
					{ ['BEAT'] = 286.88, ['MODS'] = '*80 95% Stealth, *200 Invert, *6 75% Dark' },
					{ ['BEAT'] = 286.75, ['MODS'] = '*80 75% Stealth, *200 Invert, *6 90% Dark' },
					{ ['BEAT'] = 286.63, ['MODS'] = '*80 Stealth, *6 80% Dark' },
					{ ['BEAT'] = 286.51, ['MODS'] = '*80 75% Stealth, *6 90% Dark, *3 No Boost' },
					{ ['BEAT'] = 286.26, ['MODS'] = '*20 No Drunk, *3 No Mini, No Flip, *3 200% Boost' },
					{ ['BEAT'] = 286.01, ['MODS'] = '*120 450% Drunk, *5 -150% Mini, *6 25% Flip' },
					{ ['BEAT'] = 286.01, ['MODS'] = '*8 No Stealth, *60 No Dizzy, *6 No Brake' },
					{ ['BEAT'] = 285.50, ['MODS'] = '*4 Stealth, *60 314% Dizzy, *3 125% Brake' },
					{ ['BEAT'] = 285.01, ['MODS'] = '*8 No Stealth, *60 No Dizzy, *6 No Brake' },
					{ ['BEAT'] = 284.50, ['MODS'] = '*4 Stealth, *60 314% Dizzy, *3 125% Brake' },
					{ ['BEAT'] = 283.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 283.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 283.51, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 283.26, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 283.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 283.00, ['MODS'] = '*5 120% Tornado' },
					{ ['BEAT'] = 282.75, ['MODS'] = '*9 No Invert' },
					{ ['BEAT'] = 282.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 282.51, ['MODS'] = '*9 Invert' },
					{ ['BEAT'] = 281.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 281.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 281.50, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 281.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 281.01, ['MODS'] = '*5 120% Tornado' },
					{ ['BEAT'] = 280.50, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 280.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 280.00, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 279.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 279.51, ['MODS'] = '*7 No Mini, *4 -100% Tornado' },
					{ ['BEAT'] = 279.25, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 279.00, ['MODS'] = '*7 No Mini, *4 100% Tornado' },
					{ ['BEAT'] = 278.75, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 278.51, ['MODS'] = '*7 No Mini, *4 -90% Tornado' },
					{ ['BEAT'] = 278.26, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 278.00, ['MODS'] = '*7 No Mini, *4 -80% Tornado' },
					{ ['BEAT'] = 277.50, ['MODS'] = '*12 No Dizzy, *4 No Brake, *3 150% Mini, *2 No Flip' },
					{ ['BEAT'] = 277.01, ['MODS'] = '*12 314% Dizzy, *4 Brake, *3 150% Mini, *2 -100% Flip' },
					{ ['BEAT'] = 277.01, ['MODS'] = '*9 No Tipsy' },
					{ ['BEAT'] = 276.76, ['MODS'] = '*9 1500% Tipsy' },
					{ ['BEAT'] = 276.76, ['MODS'] = 'No Reverse' },
					{ ['BEAT'] = 276.25, ['MODS'] = 'Reverse' },
					{ ['BEAT'] = 276.25, ['MODS'] = '*9 No Tipsy' },
					{ ['BEAT'] = 276.00, ['MODS'] = '*9 -1500% Tipsy' },
					{ ['BEAT'] = 275.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 275.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 275.51, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 275.26, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 275.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 275.00, ['MODS'] = '*5 120% Tornado' },
					{ ['BEAT'] = 274.75, ['MODS'] = '*9 No Invert' },
					{ ['BEAT'] = 274.51, ['MODS'] = '*9 Invert' },
					{ ['BEAT'] = 274.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 273.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 273.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 273.50, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 273.26, ['MODS'] = '*9 No Invert' },
					{ ['BEAT'] = 273.01, ['MODS'] = '*9 Invert' },
					{ ['BEAT'] = 273.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 272.26, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 272.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 272.00, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 271.76, ['MODS'] = '*6 No Tornado, No Flip, *64 No Bumpy, *18 No Hallway' },
					{ ['BEAT'] = 271.51, ['MODS'] = '*7 No Mini, *4 -100% Tornado, Flip, *64 -1000% Bumpy, *16 250% Hallway' },
					{ ['BEAT'] = 271.25, ['MODS'] = '*3 200% Mini, *6 No Tornado, *1.5 No Flip, *2.25 No Invert, *64 No Bumpy, *18 No Hallway' },
					{ ['BEAT'] = 271.00, ['MODS'] = '*7 No Mini, *4 100% Tornado, *1.5 75% Flip, *2.25 -125% Invert, *64 1000% Bumpy, *16 250% Hallway' },
					{ ['BEAT'] = 270.75, ['MODS'] = '*3 200% Mini, *6 No Tornado, *2 No Flip, *64 No Bumpy, *18 No Hallway' },
					{ ['BEAT'] = 270.51, ['MODS'] = '*7 No Mini, *4 -90% Tornado, *2 Flip, *64 -1000% Bumpy, *16 250% Hallway' },
					{ ['BEAT'] = 270.26, ['MODS'] = '*3 200% Mini, *6 No Tornado, *2 No Invert' },
					{ ['BEAT'] = 270.00, ['MODS'] = '*7 No Mini, *4 -80% Tornado, *2 Invert' },
					{ ['BEAT'] = 270.00, ['MODS'] = 'No Wave' },
					{ ['BEAT'] = 269.50, ['MODS'] = '*6 100% Wave, *8 150% Mini' },
					{ ['BEAT'] = 269.01, ['MODS'] = '*8 No Stealth, *60 No Dizzy, *6 No Brake' },
					{ ['BEAT'] = 268.50, ['MODS'] = '*4 Stealth, *60 314% Dizzy, *3 125% Brake' },
					{ ['BEAT'] = 267.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 267.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 267.51, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 267.26, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 267.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 267.00, ['MODS'] = '*5 120% Tornado' },
					{ ['BEAT'] = 266.75, ['MODS'] = '*9 No Invert' },
					{ ['BEAT'] = 266.51, ['MODS'] = '*9 Invert' },
					{ ['BEAT'] = 266.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 265.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 265.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 265.50, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 265.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 265.01, ['MODS'] = '*5 120% Tornado' },
					{ ['BEAT'] = 264.50, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 264.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 264.00, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 263.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 263.51, ['MODS'] = '*7 No Mini, *4 -100% Tornado' },
					{ ['BEAT'] = 263.25, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 263.00, ['MODS'] = '*7 No Mini, *4 100% Tornado' },
					{ ['BEAT'] = 262.75, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 262.51, ['MODS'] = '*7 No Mini, *4 -90% Tornado' },
					{ ['BEAT'] = 262.26, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 262.00, ['MODS'] = '*7 No Mini, *4 -80% Tornado' },
					{ ['BEAT'] = 261.50, ['MODS'] = '*12 No Dizzy, *4 No Brake, *3 150% Mini, *2 No Flip' },
					{ ['BEAT'] = 261.01, ['MODS'] = '*12 314% Dizzy, *4 Brake, *3 150% Mini, *2 -100% Flip' },
					{ ['BEAT'] = 261.01, ['MODS'] = '*9 No Tipsy' },
					{ ['BEAT'] = 260.76, ['MODS'] = '*9 1500% Tipsy' },
					{ ['BEAT'] = 260.76, ['MODS'] = 'No Reverse' },
					{ ['BEAT'] = 260.25, ['MODS'] = 'Reverse' },
					{ ['BEAT'] = 260.25, ['MODS'] = '*9 No Tipsy' },
					{ ['BEAT'] = 260.00, ['MODS'] = '*9 -1500% Tipsy' },
					{ ['BEAT'] = 259.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 259.51, ['MODS'] = '*4.5 No Distant' },
					{ ['BEAT'] = 259.51, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 259.26, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 259.00, ['MODS'] = '*6 200% Distant' },
					{ ['BEAT'] = 259.00, ['MODS'] = '*5 120% Tornado' },
					{ ['BEAT'] = 258.75, ['MODS'] = '*9 No Invert' },
					{ ['BEAT'] = 258.51, ['MODS'] = '*9 Invert' },
					{ ['BEAT'] = 258.51, ['MODS'] = '*9 No Hallway' },
					{ ['BEAT'] = 257.76, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 257.50, ['MODS'] = '*4 200% Hallway' },
					{ ['BEAT'] = 257.50, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 257.26, ['MODS'] = '*9 No Invert' },
					{ ['BEAT'] = 257.01, ['MODS'] = '*9 Invert' },
					{ ['BEAT'] = 257.01, ['MODS'] = '*8 No Distant' },
					{ ['BEAT'] = 256.26, ['MODS'] = '*6 No Tornado' },
					{ ['BEAT'] = 256.00, ['MODS'] = '*3 200% Distant' },
					{ ['BEAT'] = 256.00, ['MODS'] = '*5 -120% Tornado' },
					{ ['BEAT'] = 256.00, ['MODS'] = '*7 No Mini' },
					{ ['BEAT'] = 255.76, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 255.51, ['MODS'] = '*1024 225% Beat' },
					{ ['BEAT'] = 255.51, ['MODS'] = '*7 No Mini, *4 -100% Tornado' },
					{ ['BEAT'] = 255.25, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 255.00, ['MODS'] = '*7 No Mini, *4 100% Tornado' },
					{ ['BEAT'] = 254.75, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 254.51, ['MODS'] = '*7 No Mini, *4 -90% Tornado' },
					{ ['BEAT'] = 254.26, ['MODS'] = '*3 200% Mini, *6 No Tornado' },
					{ ['BEAT'] = 254.00, ['MODS'] = '*7 No Mini, *4 -80% Tornado' },
					{ ['BEAT'] = 253.50, ['MODS'] = '*28 No Bumpy' },
					{ ['BEAT'] = 253.12, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 253.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 252.87, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 252.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 252.62, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 252.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 252.37, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 252.25, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 252.12, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 252.00, ['MODS'] = '200% Mini, No Dizzy' },
					{ ['BEAT'] = 252.00, ['MODS'] = '*1.5 No Wave, No Hallway' },
					{ ['BEAT'] = 252.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 251.87, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 251.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 251.63, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 251.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 251.38, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 251.25, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 251.13, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 251.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 250.88, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 250.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 250.63, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 250.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 250.38, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 250.25, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 250.13, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 250.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 249.88, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 249.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 249.63, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 249.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 249.38, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 249.26, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 249.13, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 249.01, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 248.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 248.00, ['MODS'] = '*4 No Reverse' },
					{ ['BEAT'] = 248.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 247.51, ['MODS'] = '*4 No Stealth, *1024 Reverse' },
					{ ['BEAT'] = 247.00, ['MODS'] = '*4 Stealth, No Reverse' },
					{ ['BEAT'] = 246.51, ['MODS'] = '*4 No Stealth, *1024 No Reverse' },
					{ ['BEAT'] = 246.00, ['MODS'] = '*4 Stealth, Reverse' },
					{ ['BEAT'] = 240.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 240.00, ['MODS'] = '*4 Reverse' },
					{ ['BEAT'] = 240.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 237.50, ['MODS'] = '*28 No Bumpy' },
					{ ['BEAT'] = 237.12, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 237.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 236.87, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 236.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 236.62, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 236.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 236.37, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 236.25, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 236.12, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 236.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 235.87, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 235.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 235.63, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 235.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 235.38, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 235.25, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 235.13, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 235.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 234.88, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 234.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 234.63, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 234.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 234.38, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 234.25, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 234.13, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 234.00, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 233.88, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 233.75, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 233.63, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 233.50, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 233.38, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 233.26, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 233.13, ['MODS'] = '*80 -750 Bumpy' },
					{ ['BEAT'] = 233.01, ['MODS'] = '*80 750% Bumpy' },
					{ ['BEAT'] = 232.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 232.00, ['MODS'] = '*4 No Reverse' },
					{ ['BEAT'] = 232.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 231.51, ['MODS'] = '*4 No Stealth, *1024 Reverse' },
					{ ['BEAT'] = 231.00, ['MODS'] = '*4 Stealth, No Reverse' },
					{ ['BEAT'] = 230.51, ['MODS'] = '*4 No Stealth, *1024 No Reverse' },
					{ ['BEAT'] = 230.00, ['MODS'] = '*4 Stealth, Reverse' },
					{ ['BEAT'] = 224.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 224.00, ['MODS'] = '*4 Reverse' },
					{ ['BEAT'] = 224.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 216.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 216.00, ['MODS'] = '*4 No Reverse' },
					{ ['BEAT'] = 216.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 215.51, ['MODS'] = '*4 No Stealth, *1024 Reverse' },
					{ ['BEAT'] = 215.00, ['MODS'] = '*4 Stealth, No Reverse' },
					{ ['BEAT'] = 214.51, ['MODS'] = '*4 No Stealth, *1024 No Reverse' },
					{ ['BEAT'] = 214.00, ['MODS'] = '*4 Stealth, Reverse' },
					{ ['BEAT'] = 208.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 208.00, ['MODS'] = '*4 Reverse' },
					{ ['BEAT'] = 208.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 200.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 200.00, ['MODS'] = '*4 No Reverse' },
					{ ['BEAT'] = 200.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 199.51, ['MODS'] = '*4 No Stealth, *1024 Reverse' },
					{ ['BEAT'] = 199.00, ['MODS'] = '*4 Stealth, No Reverse' },
					{ ['BEAT'] = 198.51, ['MODS'] = '*4 No Stealth, *1024 No Reverse' },
					{ ['BEAT'] = 198.00, ['MODS'] = '*4 Stealth, Reverse' },
					{ ['BEAT'] = 192.50, ['MODS'] = '*6 No Mini, *1.5 No Flip' },
					{ ['BEAT'] = 192.00, ['MODS'] = '*4 Reverse' },
					{ ['BEAT'] = 192.00, ['MODS'] = '*6 -80% Mini, *1.5 Flip' },
					{ ['BEAT'] = 192.00, ['MODS'] = '*2 110% Wave, 20% Hallway' },
					{ ['BEAT'] = 191.20, ['MODS'] = '*4 No Brake' },
					{ ['BEAT'] = 191.00, ['MODS'] = '*12 200% Brake' },
					{ ['BEAT'] = 190.63, ['MODS'] = '*2 No Flip, *1.5 No Reverse, *2 No Centered, *5 No Stealth' },
					{ ['BEAT'] = 190.00, ['MODS'] = '*2 50% Flip, Reverse, *2 200% Centered, *3 Stealth, *4 No Mini' },
					{ ['BEAT'] = 190.00, ['MODS'] = 'No Brake' },
					{ ['BEAT'] = 189.67, ['MODS'] = '*60 No Drunk' },
					{ ['BEAT'] = 189.34, ['MODS'] = '*60 -200% Drunk' },
					{ ['BEAT'] = 189.01, ['MODS'] = '*60 200% Drunk' },
					{ ['BEAT'] = 188.67, ['MODS'] = '*60 No Drunk' },
					{ ['BEAT'] = 188.34, ['MODS'] = '*60 -200% Drunk' },
					{ ['BEAT'] = 188.01, ['MODS'] = '*60 200% Drunk' },
					{ ['BEAT'] = 187.67, ['MODS'] = '*60 No Drunk' },
					{ ['BEAT'] = 187.34, ['MODS'] = '*60 -200% Drunk' },
					{ ['BEAT'] = 187.01, ['MODS'] = '*60 200% Drunk' },
					{ ['BEAT'] = 186.67, ['MODS'] = '*60 No Drunk' },
					{ ['BEAT'] = 186.34, ['MODS'] = '*60 -200% Drunk' },
					{ ['BEAT'] = 186.01, ['MODS'] = '*60 200% Drunk' },
					{ ['BEAT'] = 185.67, ['MODS'] = '*60 No Drunk' },
					{ ['BEAT'] = 185.34, ['MODS'] = '*60 -200% Drunk' },
					{ ['BEAT'] = 185.01, ['MODS'] = '*60 200% Drunk' },
					{ ['BEAT'] = 184.67, ['MODS'] = '*60 No Drunk' },
					{ ['BEAT'] = 184.34, ['MODS'] = '*60 -200% Drunk' },
					{ ['BEAT'] = 184.00, ['MODS'] = '*60 200% Drunk' },
					{ ['BEAT'] = 184.00, ['MODS'] = '*0.2 Brake, *0.07 Flip' },
					{ ['BEAT'] = 184.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 183.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 183.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 183.25, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 183.00, ['MODS'] = 'No Hallway, No Boost' },
					{ ['BEAT'] = 183.00, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 182.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 181.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 181.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 181.25, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 181.00, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 180.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 179.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 179.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 179.25, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 179.00, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 178.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 177.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 177.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 177.26, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 177.01, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 176.00, ['MODS'] = '*0.3 -150% Mini, Dizzy' },
					{ ['BEAT'] = 174.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 173.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 173.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 173.26, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 173.01, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 170.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 169.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 169.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 169.26, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 169.01, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 166.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 165.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 165.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 165.26, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 165.01, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 162.00, ['MODS'] = '*16 No Drunk' },
					{ ['BEAT'] = 161.75, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 161.50, ['MODS'] = '*32 300% Drunk' },
					{ ['BEAT'] = 161.26, ['MODS'] = '*32 -300% Drunk' },
					{ ['BEAT'] = 161.01, ['MODS'] = '*16 300% Drunk' },
					{ ['BEAT'] = 160.00, ['MODS'] = '*4 No Tipsy, *3 No Dark, *1024 No Blind' },
					{ ['BEAT'] = 128.00, ['MODS'] = 'Mini' },
					{ ['BEAT'] = 128.00, ['MODS'] = 'Tipsy, Dark, *1024 Blind' },
					{ ['BEAT'] = 128.00, ['MODS'] = '80% Hallway, 70% Boost' },
					{ ['BEAT'] = 111.50, ['MODS'] = '*1024 No Beat' },
					{ ['BEAT'] = 110.00, ['MODS'] = '*2 No Dizzy, *3 No RandomVanish, *4 No Wave, *2 No Drunk' },
					{ ['BEAT'] = 108.00, ['MODS'] = '*7 No Hallway, *2.5 No Centered' },
					{ ['BEAT'] = 107.51, ['MODS'] = '*7 350% Hallway, *1.5 -100% Centered' },
					{ ['BEAT'] = 107.00, ['MODS'] = '*7 No Space, *2 No Centered' },
					{ ['BEAT'] = 106.51, ['MODS'] = '*7 350% Space, *2 -100% Centered' },
					{ ['BEAT'] = 104.00, ['MODS'] = '*7 No Hallway, *2.5 No Centered' },
					{ ['BEAT'] = 103.51, ['MODS'] = '*7 350% Hallway, *1.5 -100% Centered' },
					{ ['BEAT'] = 103.00, ['MODS'] = '*7 No Space, *2 No Centered' },
					{ ['BEAT'] = 102.51, ['MODS'] = '*7 350% Space, *2 -100% Centered' },
					{ ['BEAT'] = 100.00, ['MODS'] = '*7 No Hallway, *2.5 No Centered' },
					{ ['BEAT'] = 99.51, ['MODS'] = '*7 350% Hallway, *1.5 -100% Centered' },
					{ ['BEAT'] = 99.00, ['MODS'] = '*7 No Space, *2 No Centered' },
					{ ['BEAT'] = 98.51, ['MODS'] = '*7 350% Space, *2 -100% Centered' },
					{ ['BEAT'] = 96.00, ['MODS'] = '50% Dizzy, *2 60% RandomVanish, *2 -80% Wave, *2 No Tornado, *2 No Wave, 75% Drunk' },
					{ ['BEAT'] = 95.51, ['MODS'] = '*1024 200% Beat' },
					{ ['BEAT'] = 79.51, ['MODS'] = '*1024 No Beat' },
					{ ['BEAT'] = 78.01, ['MODS'] = '*2 No Dizzy, *3 No RandomVanish, *4 No Wave, *2 No Drunk' },
					{ ['BEAT'] = 76.00, ['MODS'] = '*7 No Hallway, *2.5 No Centered' },
					{ ['BEAT'] = 75.51, ['MODS'] = '*7 350% Hallway, *1.5 -100% Centered' },
					{ ['BEAT'] = 75.00, ['MODS'] = '*7 No Space, *2 No Centered' },
					{ ['BEAT'] = 74.51, ['MODS'] = '*7 350% Space, *2 -100% Centered' },
					{ ['BEAT'] = 72.00, ['MODS'] = '*7 No Hallway, *2.5 No Centered' },
					{ ['BEAT'] = 71.51, ['MODS'] = '*7 350% Hallway, *1.5 -100% Centered' },
					{ ['BEAT'] = 71.00, ['MODS'] = '*7 No Space, *2 No Centered' },
					{ ['BEAT'] = 70.51, ['MODS'] = '*7 350% Space, *2 -100% Centered' },
					{ ['BEAT'] = 68.00, ['MODS'] = '*7 No Hallway, *2.5 No Centered' },
					{ ['BEAT'] = 67.51, ['MODS'] = '*7 350% Hallway, *1.5 -100% Centered' },
					{ ['BEAT'] = 67.00, ['MODS'] = '*7 No Space, *2 No Centered' },
					{ ['BEAT'] = 66.51, ['MODS'] = '*7 350% Space, *2 -100% Centered' },
					{ ['BEAT'] = 63.50, ['MODS'] = '*1024 200% Beat' },
					{ ['BEAT'] = 63.00, ['MODS'] = '*2 No Mini, 50% Dizzy, *2 60% RandomVanish, *2 -80% Wave, *2 No Tornado, *3 No Wave, 75% Drunk, *2.5 No Bumpy' },
					{ ['BEAT'] = 62.00, ['MODS'] = '*3 150% Wave'},
					{ ['BEAT'] = 58.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 58.00, ['MODS'] = '*14 50% Stealth' },
					{ ['BEAT'] = 56.00, ['MODS'] = '*0.25 200% Mini' },
					{ ['BEAT'] = 56.00, ['MODS'] = 'No Wave, No Drunk' },
					{ ['BEAT'] = 56.00, ['MODS'] = '125% Tornado' },
					{ ['BEAT'] = 55.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 55.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 55.38, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 55.25, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 54.88, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 54.75, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 54.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 54.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 54.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 54.00, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 53.50, ['MODS'] = '*80 No Beat' },
					{ ['BEAT'] = 53.01, ['MODS'] = '*6 No Space' },
					{ ['BEAT'] = 52.00, ['MODS'] = '*6 125% Space' },
					{ ['BEAT'] = 51.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 51.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 51.51, ['MODS'] = '*80 -500% Beat' },
					{ ['BEAT'] = 51.38, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 51.25, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 50.88, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 50.75, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 50.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 50.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 50.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 50.00, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 49.50, ['MODS'] = '*80 No Beat' },
					{ ['BEAT'] = 49.01, ['MODS'] = '*8 No Hallway' },
					{ ['BEAT'] = 48.00, ['MODS'] = '*8 125% Hallway' },
					{ ['BEAT'] = 48.00, ['MODS'] = '*3 150% Wave, 75% Drunk, *2 150% Bumpy' },
					{ ['BEAT'] = 48.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 47.95, ['MODS'] = '*80 39.02% Mini' },
					{ ['BEAT'] = 47.89, ['MODS'] = '*80 76.54% Mini' },
					{ ['BEAT'] = 47.83, ['MODS'] = '*80 111.12% Mini' },
					{ ['BEAT'] = 47.77, ['MODS'] = '*80 141.43% Mini' },
					{ ['BEAT'] = 47.70, ['MODS'] = '*80 166.30% Mini' },
					{ ['BEAT'] = 47.64, ['MODS'] = '*80 184.78% Mini' },
					{ ['BEAT'] = 47.58, ['MODS'] = '*80 196.16% Mini' },
					{ ['BEAT'] = 47.51, ['MODS'] = '*80 200.00% Mini' },
					{ ['BEAT'] = 47.50, ['MODS'] = '*80 -500% Beat' },
					{ ['BEAT'] = 47.45, ['MODS'] = '*80 196.16% Mini' },
					{ ['BEAT'] = 47.39, ['MODS'] = '*80 184.78% Mini' },
					{ ['BEAT'] = 47.33, ['MODS'] = '*80 166.30% Mini' },
					{ ['BEAT'] = 47.26, ['MODS'] = '*80 141.43% Mini' },
					{ ['BEAT'] = 47.20, ['MODS'] = '*80 111.12% Mini' },
					{ ['BEAT'] = 47.14, ['MODS'] = '*80 76.54% Mini' },
					{ ['BEAT'] = 47.07, ['MODS'] = '*80 39.02% Mini' },
					{ ['BEAT'] = 47.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 47.00, ['MODS'] = '*30 No Dizzy' },
					{ ['BEAT'] = 46.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 46.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 46.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 46.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 46.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 46.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 46.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 46.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 46.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 46.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 46.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 46.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 46.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 46.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 46.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 46.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 46.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 45.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 44.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 44.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 44.00, ['MODS'] = '*250 No Dizzy' },
					{ ['BEAT'] = 43.95, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 43.89, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 43.83, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 43.77, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 43.70, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 43.64, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 43.58, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 43.51, ['MODS'] = '*80 100.00% Mini' },
					{ ['BEAT'] = 43.45, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 43.39, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 43.33, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 43.26, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 43.20, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 43.14, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 43.07, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 43.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 42.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 42.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 42.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 42.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 42.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 42.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 42.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 42.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 42.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 42.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 42.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 42.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 42.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 42.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 42.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 42.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 42.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 41.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 40.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 40.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 40.00, ['MODS'] = '*250 No Dizzy' },
					{ ['BEAT'] = 39.95, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 39.89, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 39.83, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 39.77, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 39.70, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 39.64, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 39.58, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 39.51, ['MODS'] = '*80 100.00% Mini' },
					{ ['BEAT'] = 39.45, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 39.39, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 39.33, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 39.26, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 39.20, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 39.14, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 39.07, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 39.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 38.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 38.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 38.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 38.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 38.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 38.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 38.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 38.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 38.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 38.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 38.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 38.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 38.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 38.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 38.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 38.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 38.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 37.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 36.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 36.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 36.00, ['MODS'] = '*250 No Dizzy' },
					{ ['BEAT'] = 35.95, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 35.89, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 35.83, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 35.77, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 35.70, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 35.64, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 35.58, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 35.51, ['MODS'] = '*80 100.00% Mini' },
					{ ['BEAT'] = 35.45, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 35.39, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 35.33, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 35.26, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 35.20, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 35.14, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 35.07, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 35.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 34.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 34.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 34.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 34.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 34.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 34.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 34.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 34.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 34.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 34.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 34.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 34.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 34.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 34.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 34.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 34.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 34.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 33.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 32.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 31.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 31.51, ['MODS'] = '*14 99% Stealth' },
					{ ['BEAT'] = 31.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 31.00, ['MODS'] = '*14 90% Stealth' },
					{ ['BEAT'] = 31.00, ['MODS'] = '*3 No Wave, *2.5 No Drunk, *2.5 No Bumpy' },
					{ ['BEAT'] = 30.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 30.00, ['MODS'] = '*14 80% Stealth' },
					{ ['BEAT'] = 28.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 28.50, ['MODS'] = '*14 70% Stealth' },
					{ ['BEAT'] = 27.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 27.00, ['MODS'] = '*14 60% Stealth' },
					{ ['BEAT'] = 26.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 26.00, ['MODS'] = '*14 50% Stealth' },
					{ ['BEAT'] = 25.50, ['MODS'] = '*80 No Beat' },
					{ ['BEAT'] = 25.01, ['MODS'] = '*6 No Space' },
					{ ['BEAT'] = 24.00, ['MODS'] = '*6 -125% Space' },
					{ ['BEAT'] = 23.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 23.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 23.50, ['MODS'] = '*80 -500% Beat' },
					{ ['BEAT'] = 23.38, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 23.25, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 22.88, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 22.75, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 22.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 22.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 22.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 22.00, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 21.50, ['MODS'] = '*80 No Beat' },
					{ ['BEAT'] = 21.01, ['MODS'] = '*6 No Space' },
					{ ['BEAT'] = 20.00, ['MODS'] = '*6 125% Space' },
					{ ['BEAT'] = 19.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 19.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 19.51, ['MODS'] = '*80 -500% Beat' },
					{ ['BEAT'] = 19.38, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 19.25, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 18.88, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 18.75, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 18.63, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 18.51, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 18.13, ['MODS'] = '*14 No Stealth' },
					{ ['BEAT'] = 18.00, ['MODS'] = '*14 85% Stealth' },
					{ ['BEAT'] = 17.50, ['MODS'] = '*80 No Beat' },
					{ ['BEAT'] = 17.01, ['MODS'] = '*8 No Hallway' },
					{ ['BEAT'] = 16.00, ['MODS'] = '*8 125% Hallway' },
					{ ['BEAT'] = 16.00, ['MODS'] = '*3 150% Wave, 75% Drunk, *2 150% Bumpy' },
					{ ['BEAT'] = 16.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 15.95, ['MODS'] = '*80 39.02% Mini' },
					{ ['BEAT'] = 15.89, ['MODS'] = '*80 76.54% Mini' },
					{ ['BEAT'] = 15.83, ['MODS'] = '*80 111.12% Mini' },
					{ ['BEAT'] = 15.77, ['MODS'] = '*80 141.43% Mini' },
					{ ['BEAT'] = 15.70, ['MODS'] = '*80 166.30% Mini' },
					{ ['BEAT'] = 15.64, ['MODS'] = '*80 184.78% Mini' },
					{ ['BEAT'] = 15.58, ['MODS'] = '*80 196.16% Mini' },
					{ ['BEAT'] = 15.51, ['MODS'] = '*80 200.00% Mini' },
					{ ['BEAT'] = 15.50, ['MODS'] = '*80 -500% Beat' },
					{ ['BEAT'] = 15.45, ['MODS'] = '*80 196.16% Mini' },
					{ ['BEAT'] = 15.39, ['MODS'] = '*80 184.78% Mini' },
					{ ['BEAT'] = 15.33, ['MODS'] = '*80 166.30% Mini' },
					{ ['BEAT'] = 15.26, ['MODS'] = '*80 141.43% Mini' },
					{ ['BEAT'] = 15.20, ['MODS'] = '*80 111.12% Mini' },
					{ ['BEAT'] = 15.14, ['MODS'] = '*80 76.54% Mini' },
					{ ['BEAT'] = 15.07, ['MODS'] = '*80 39.02% Mini' },
					{ ['BEAT'] = 15.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 15.00, ['MODS'] = '*30 No Dizzy' },
					{ ['BEAT'] = 14.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 14.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 14.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 14.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 14.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 14.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 14.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 14.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 14.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 14.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 14.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 14.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 14.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 14.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 14.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 14.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 14.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 13.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 12.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 12.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 12.00, ['MODS'] = '*250 No Dizzy' },
					{ ['BEAT'] = 11.95, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 11.89, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 11.83, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 11.77, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 11.70, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 11.64, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 11.58, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 11.51, ['MODS'] = '*80 100.00% Mini' },
					{ ['BEAT'] = 11.45, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 11.39, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 11.33, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 11.26, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 11.20, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 11.14, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 11.07, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 11.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 10.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 10.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 10.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 10.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 10.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 10.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 10.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 10.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 10.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 10.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 10.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 10.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 10.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 10.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 10.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 10.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 10.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 9.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 8.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 8.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 8.00, ['MODS'] = '*250 No Dizzy' },
					{ ['BEAT'] = 7.95, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 7.89, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 7.83, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 7.77, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 7.70, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 7.64, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 7.58, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 7.51, ['MODS'] = '*80 100.00% Mini' },
					{ ['BEAT'] = 7.45, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 7.39, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 7.33, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 7.26, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 7.20, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 7.14, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 7.07, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 7.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 6.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 6.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 6.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 6.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 6.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 6.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 6.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 6.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 6.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 6.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 6.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 6.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 6.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 6.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 6.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 6.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 6.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 5.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 4.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = 4.00, ['MODS'] = '*80 No Mini' },
					{ ['BEAT'] = 4.00, ['MODS'] = '*250 No Dizzy' },
					{ ['BEAT'] = 3.95, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 3.89, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 3.83, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 3.77, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 3.70, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 3.64, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 3.58, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 3.51, ['MODS'] = '*80 100.00% Mini' },
					{ ['BEAT'] = 3.45, ['MODS'] = '*80 98.08% Mini' },
					{ ['BEAT'] = 3.39, ['MODS'] = '*80 92.39% Mini' },
					{ ['BEAT'] = 3.33, ['MODS'] = '*80 83.15% Mini' },
					{ ['BEAT'] = 3.26, ['MODS'] = '*80 70.72% Mini' },
					{ ['BEAT'] = 3.20, ['MODS'] = '*80 55.56% Mini' },
					{ ['BEAT'] = 3.14, ['MODS'] = '*80 38.27% Mini' },
					{ ['BEAT'] = 3.07, ['MODS'] = '*80 19.51% Mini' },
					{ ['BEAT'] = 3.01, ['MODS'] = '*80 0.01% Mini' },
					{ ['BEAT'] = 2.95, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 2.88, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 2.82, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 2.76, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 2.70, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 2.63, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 2.57, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 2.51, ['MODS'] = '*80 -100.00% Mini' },
					{ ['BEAT'] = 2.44, ['MODS'] = '*80 -98.08% Mini' },
					{ ['BEAT'] = 2.38, ['MODS'] = '*80 -92.39% Mini' },
					{ ['BEAT'] = 2.32, ['MODS'] = '*80 -83.15% Mini' },
					{ ['BEAT'] = 2.26, ['MODS'] = '*80 -70.72% Mini' },
					{ ['BEAT'] = 2.19, ['MODS'] = '*80 -55.56% Mini' },
					{ ['BEAT'] = 2.13, ['MODS'] = '*80 -38.27% Mini' },
					{ ['BEAT'] = 2.07, ['MODS'] = '*80 -19.51% Mini' },
					{ ['BEAT'] = 2.00, ['MODS'] = '*250 -1256% Dizzy' },
					{ ['BEAT'] = 2.00, ['MODS'] = '*80 -0.00% Mini' },
					{ ['BEAT'] = 1.01, ['MODS'] = '*6 No Hallway, *1.5 No Mini, *0.25 No Reverse, *0.15 No Flip' },
					{ ['BEAT'] = 0.00, ['MODS'] = '*6 600% Hallway, *1.5 Mini, *0.25 Reverse, *0.15 Flip' },
					{ ['BEAT'] = -1.00, ['MODS'] = 'Overhead'}
				}

				powglov.beats_table_n = table.getn(powglov.beats_table)

				powglov.log('starting mods loop')
				self:queuecommand('ModsLoop')
			end,
    },
  },
}