local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_mlk",
  Def.Quad{
    Name= "xtl_actor_nlk",
  InitCommand= cmd(visible,true),
  OnCommand= cmd(sleep,0.1;sleep,0.35928;queuecommand,"PrepareChartFirst";sleep,0.35928;queuecommand,"PrepareChartSecond";sleep,0.71856;sleep,1.4371*3;queuecommand,"RunChart"),
  PrepareChartFirstCommand= function(self)
            
            -- Here is our chart in DWI format.  It should be easier to parse than the SM format.
            RawChartData = '00000000 00000000 00000000 00000000 00000000 42868246 40802060 80024282 46482646 (8006008020040020) 48264060 (4006004080020080) 40006824 60028002 (6080204060000042) 46284682 40602080 (2006004020080060) 82464080 (2006008020040080) (2060206040204242) 40062008 46864002 82482686 28468020 40008000 20604000 60802040 20806004 82646824 (2080604020408026) (2000008040000064) 66882244 68242046 48262084 68286042 82464000 08268028 02462826 04282046 26408000 (0026262080004060) 04246026 04682462 (8040608020406464) 60026424 80206080 24242008 (6020602060002828) (2000000000000084) 60000000 (0400002080060040) 82642468 20000462 60000284 28682462 80402080 60802040 82642080 20408020 64248020 60802040 82648040 20806080 (2420464062604840) 60086002 82682004 64826004 24826824 62846824 60000000 28468000 24286284 60802080 60026424 82682428 (6002008040060080) 24286020 (8004006080020040) 60002682 40062008 (2060802040000028) 28626424 80206040 (2008006020060040) 82642080 (2004006020080020) (6040604020806824) 60000000 00000000 00000000'
        end,
  PrepareChartSecondCommand= function(self)
            -- Set up a large table.
            TableChart = {{'N'}}
            
            -- Add to it by reading the raw data.
            local measure = 1
            for i = 1, string.len(RawChartData), 1 do
                
                -- Separate the chart into measures, and initialize a new subtable for each.
                if string.sub(RawChartData,i,i) == ' ' then
                    measure = measure + 1
                    TableChart[measure] = {}
                    TableChart[measure][1] = '8th'
                    
                -- Make sure to set a flag to let Lua know that this measure contains 16ths.
                elseif string.sub(RawChartData,i,i) == '(' then
                    TableChart[measure][1] = '16th'
                
                -- Now we write in the notes, skipping over the closed parenthesis character.
                elseif string.sub(RawChartData,i,i) ~= ')' then
                    table.insert(TableChart[measure], string.sub(RawChartData,i,i))
                end
            end
            
            -- Quantize 8th measures to 16th measures here.
            measure = 1
            for i = 1, table.getn(TableChart), 1 do
                if TableChart[i][1] == '8th' then
                    for j = 10, 3, -1 do
                        table.insert(TableChart[i], j, '0')
                    end
                    TableChart[i][1] = '16th'
                end
            end
            
            -- This is our note variable, to determine which actor we send commands to.
            -- Dodges around MESSAGEMAN:Broadcast() usage.
            CurrentNoteActor = 0
            
            -- A table to hold our note actors in.
            NoteActors = {}
            
            -- A beat timing variable.  Used as 16th notes.  Multiply SM's beat by 4 to get this.
            TimingBeat = 88
            
            -- Also some quality of life globals.
            SixteenthBeat = 0.08982
            EighthBeat = 0.17964
            OneBeat = 0.35928
            TwoBeats = 0.71856
            
        end,
  RunChartCommand= function(self)
            
            -- Here we go, boys and girls.
            
            if TimingBeat <= 1424 then
                
                -- StepMania is anal about this, and will pretty much run everything before actor commands.
                TimingBeat = TimingBeat+1
                CurrentNoteActor = CurrentNoteActor+1
                
                -- Set the measure by flooring a division of TimingBeat by 16.
                measure = math.floor(TimingBeat/16)
                
                -- Set the note inside the measure, there are 16 in each.
                noteInMeasure = math.mod(TimingBeat,16) + 1
                
                -- Read the number and apply commands to actors.
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:diffusealpha(1)
                
                -- Important part: check the number entry to see what direction the arrow faces.  Apply rotationz.
                if TableChart[measure][noteInMeasure+1] == '4' then
                    NoteActors[math.mod(CurrentNoteActor,32) + 1]:rotationz(90)
                elseif TableChart[measure][noteInMeasure+1] == '2' then
                    NoteActors[math.mod(CurrentNoteActor,32) + 1]:rotationz(0)
                elseif TableChart[measure][noteInMeasure+1] == '8' then
                    NoteActors[math.mod(CurrentNoteActor,32) + 1]:rotationz(180)
                elseif TableChart[measure][noteInMeasure+1] == '6' then
                    NoteActors[math.mod(CurrentNoteActor,32) + 1]:rotationz(-90)
                else
                    NoteActors[math.mod(CurrentNoteActor,32) + 1]:diffusealpha(0)
                end
                
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:linear(TwoBeats)
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:addx(-480)
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:linear(EighthBeat)
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:diffusealpha(0)
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:sleep(0)
                NoteActors[math.mod(CurrentNoteActor,32) + 1]:addx(480)
                
                -- Only continue looping if there's more chart to read!
                
                self:sleep(SixteenthBeat)
                self:queuecommand('RunChart')
            end
            
        end,
  },
  Def.Sprite{
    Name= "xtl_actor_olk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.0;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_plk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.02;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_qlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.04;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_rlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.06;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_slk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.10;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_tlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.12;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ulk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.14;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_vlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.16;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_wlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.20;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_xlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.22;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ylk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.24;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_zlk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.26;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_amk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.30;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_bmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.32;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_cmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.34;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_dmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.36;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_emk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.4;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_fmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.42;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_gmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.44;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_hmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.46;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_imk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.50;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_jmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.52;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_kmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.54;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_lmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.56;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_mmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.60;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_nmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.62;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_omk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.64;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_pmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.66;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_qmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.70;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "4th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_rmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.72;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_smk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.74;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "8th 4x4.png",
  },
  Def.Sprite{
    Name= "xtl_actor_tmk",
  InitCommand= cmd(x,SCREEN_CENTER_X+352;y,SCREEN_CENTER_Y+120),
  OnCommand= cmd(sleep,1.76;queuecommand,"Prepare"),
  PrepareCommand= function(self)
            table.insert(NoteActors, self)
        end,
  Texture= "16th 4x4.png",
  },
}