local xtl_cond_urk_result= GAMESTATE:IsPlayerEnabled(PLAYER_1)

local xtl_cond_vrk_result= GAMESTATE:IsPlayerEnabled(PLAYER_2)

local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_wrk",
InitCommand= function(self)
    -- LUA style comments have two dashes
    -- I like to declare variables global to the file here
    tempo = 174.560;
    beat_length = 60/tempo;
    end,
  Def.BitmapText{
    Name= "xtl_actor_xrk",
  Font= ""_eurostile normal",",
  InitCommand= function(self)
        self:zoomto(1935, 120);
        self:diffusealpha(0);
        self:x(SCREEN_WIDTH + 1290/2);
        self:y(400);
      end,
  OnCommand= function(self)
        self:diffusealpha(1.5);
        self:diffusealpha(0.6);
        self:rainbow(1);
        self:linear(beat_length * 11);
        self:addx(-1290 - SCREEN_WIDTH)
      end,
  Text= "BILL BILL BILL BILL BILL BILL BILL BILL BILL BILL BILL BILL BILL,",
  },
  Def.BitmapText{
    Name= "xtl_actor_yrk",
  Font= ""_eurostile normal",",
  InitCommand= function(self)
        self:zoomto(160, 40);
        self:diffusealpha(0);
        self:x(SCREEN_CENTER_X);
        self:y(SCREEN_CENTER_Y);
      end,
  OnCommand= function(self)
        self:sleep(beat_length * 6);

        self:sleep(0);
        self:diffusealpha(1);
        self:diffusealpha(1);
        self:rainbow(1);

        self:sleep(beat_length * 0.5);
        self:zoomto(240, 60);
        self:sleep(beat_length * 0.5);
        self:zoomto(320, 80);
        self:rotationz(-30);
        self:sleep(beat_length * 0.5);

        self:sleep(0);
        self:diffusealpha(0);
      end,
  Text= "BILL,",
  },
  optional_actor(xtl_cond_urk_result,
  Def.Quad{
    Name= "xtl_actor_zrk",
  MoveCommand= function(self)
        -- This must be its own command because p1_actor won't be defined by
        --   time OnCommand is queued 
        local p1_actor = SCREENMAN:GetTopScreen():GetChild('PlayerP1');

        -- Left
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(-5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(-5);

        -- Left
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(-5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(-5);

        -- Right
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(5);

        -- Right
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(5);

        -- Left
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(-5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(-5);

        -- Left
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(-5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(-5);

        -- In place
        p1_actor:decelerate(beat_length*0.25);
        p1_actor:addy(10);
        p1_actor:accelerate(beat_length*0.25);
        p1_actor:addy(-10);

        p1_actor:decelerate(beat_length*0.25);
        p1_actor:addy(10);
        p1_actor:accelerate(beat_length*0.25);
        p1_actor:addy(-10);

        p1_actor:decelerate(beat_length*0.25);
        p1_actor:addy(10);
        p1_actor:accelerate(beat_length*0.25);
        p1_actor:addy(-10);

        -- Right
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(5);

        -- Right
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(5);

        -- Left
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(-5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(-5);

        -- Right
        p1_actor:decelerate(beat_length*0.5);
        p1_actor:addy(20);
        p1_actor:addx(5);
        p1_actor:accelerate(beat_length*0.5);
        p1_actor:addy(-20);
        p1_actor:addx(5);
      end,
  OnCommand= cmd(queuecommand,"Move"),
  }),
  optional_actor(xtl_cond_vrk_result,
  Def.Quad{
    Name= "xtl_actor_ask",
  MoveCommand= function(self)
        -- This must be its own command because p2_actor won't be defined by
        --   time OnCommand is queued 
        local p2_actor = SCREENMAN:GetTopScreen():GetChild('PlayerP2');

        -- Not Left
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(-5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(-5 * -1);

        -- Not Left
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(-5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(-5 * -1);

        -- Not Right
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(5 * -1);

        -- Not Right
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(5 * -1);

        -- Not Left
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(-5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(-5 * -1);

        -- Not Left
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(-5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(-5 * -1);

        -- In place
        p2_actor:decelerate(beat_length*0.25);
        p2_actor:addy(10);
        p2_actor:accelerate(beat_length*0.25);
        p2_actor:addy(-10);

        p2_actor:decelerate(beat_length*0.25);
        p2_actor:addy(10);
        p2_actor:accelerate(beat_length*0.25);
        p2_actor:addy(-10);

        p2_actor:decelerate(beat_length*0.25);
        p2_actor:addy(10);
        p2_actor:accelerate(beat_length*0.25);
        p2_actor:addy(-10);

        -- Not Right
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(5 * -1);

        -- Not Right
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(5 * -1);

        -- Not Left
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(-5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(-5 * -1);

        -- Not Right
        p2_actor:decelerate(beat_length*0.5);
        p2_actor:addy(20);
        p2_actor:addx(5 * -1);
        p2_actor:accelerate(beat_length*0.5);
        p2_actor:addy(-20);
        p2_actor:addx(5 * -1);
      end,
  OnCommand= cmd(queuecommand,"Move"),
  }),
  Def.ActorFrame{
    Name= "xtl_actor_bsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*0;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= SCREEN_CENTER_X,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_csk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_dsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*1;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_esk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_fsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*2;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_gsk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_hsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*3;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_isk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_jsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*4;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_ksk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_lsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*5;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_msk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_nsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*6;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_osk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_psk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*6.5;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_qsk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_rsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*7;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_ssk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_tsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*7.5;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_usk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_vsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*8;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_wsk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_xsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*9;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_ysk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_zsk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*10;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_atk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_btk",
  InitCommand= function(self)
        self:fov(90);
        self:visible(0);
      end,
  OnCommand= cmd(sleep,beat_length*11;queuecommand,"Rotate"),
  RotateCommand= function(self)
        self:visible(1);
        self:linear(beat_length * 13 * math.random());
        self:rotationz(40 * (math.random() - 0.5));
      end,
  VanishX= 320,
  VanishY= -100,
    Def.Sprite{
      Name= "xtl_actor_ctk",
    InitCommand= function(self)
            self:zoomx(20 * math.random());
            self:zoomz(SCREEN_HEIGHT*2);
            self:x(320 + 320 * (math.random() - 0.5));
            self:y(0);
            self:rotationx(-90);
            self:diffuse(math.random(), math.random(), math.random(), 0.8);
            self:blend('add');
          end,
    Texture= "pixel.png",
    },
  },
}