local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_quk",
  Def.ActorFrame{
    Name= "xtl_actor_ruk",
  InitCommand= cmd(draworder,50),
    Def.Sprite{
      Name= "xtl_actor_suk",
    DayMessageCommand= cmd(bounceend,0.5;y,SCREEN_CENTER_Y-128),
    InitCommand= cmd(draworder,2;x,SCREEN_CENTER_X-120;y,SCREEN_CENTER_Y-128),
    NightMessageCommand= cmd(bouncebegin,0.5;y,SCREEN_BOTTOM+128),
    OnCommand= cmd(),
    StormMessageCommand= cmd(bouncebegin,0.5;y,SCREEN_TOP-128),
    Texture= "sun",
    },
    Def.Sprite{
      Name= "xtl_actor_tuk",
    DayMessageCommand= cmd(bouncebegin,0.5;y,SCREEN_BOTTOM+128),
    InitCommand= cmd(draworder,2;x,SCREEN_CENTER_X+120;y,SCREEN_BOTTOM+128),
    NightMessageCommand= cmd(bounceend,0.5;y,SCREEN_CENTER_Y-128),
    OnCommand= cmd(),
    Texture= "moon",
    },
    Def.Quad{
      Name= "xtl_actor_uuk",
    DayMessageCommand= cmd(linear,0.5;diffuse,color('#97ccff');diffusebottomedge,#d3dcfd),
    InitCommand= cmd(draworder,1;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;ZoomToWidth,SCREEN_WIDTH;ZoomToHeight,SCREEN_HEIGHT;diffuse,color('#97ccff');diffusebottomedge,#d3dcfd),
    NightMessageCommand= cmd(linear,0.5;diffuse,color('#222244FF');diffusebottomedge,#442244FF),
    OnCommand= cmd(),
    StormMessageCommand= cmd(linear,1;diffuse,color('#444444FF');diffusebottomedge,#444466FF),
    },
    Def.Sprite{
      Name= "xtl_actor_vuk",
    DayMessageCommand= cmd(linear,0.5;diffuse,color('#FFFFFFFF')),
    InitCommand= cmd(draworder,50;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-120;zoomx,3;customtexturerect,0,0,3,1;texcoordvelocity,0.25,0),
    NightMessageCommand= cmd(linear,0.5;diffuse,color('#666666FF')),
    OnCommand= cmd(),
    StormMessageCommand= cmd(linear,1;diffuse,color('#666666FF')),
    Texture= "_tex backcloud.png",
    },
    Def.Sprite{
      Name= "xtl_actor_wuk",
    DayMessageCommand= cmd(linear,0.5;diffuse,color('#FFFFFFFF')),
    FactoryMessageCommand= cmd(linear,20;y,SCREEN_CENTER_Y;bob;effectmagnitude,0,10,0),
    InitCommand= cmd(draworder,51;horizalign,left;x,SCREEN_LEFT;y,SCREEN_TOP-512),
    NightMessageCommand= cmd(linear,0.5;diffuse,color('#666666FF')),
    OnCommand= cmd(),
    Texture= "factory.png",
    },
  },
  Def.Sprite{
    Name= "xtl_actor_xuk",
  DayMessageCommand= cmd(linear,0.5;diffuse,color('#FFFFFFFF')),
  InitCommand= cmd(draworder,100;x,SCREEN_CENTER_X;y,SCREEN_BOTTOM-64;ZoomToWidth,SCREEN_WIDTH;customtexturerect,0,0,1,1;texcoordvelocity,0.425,0),
  NightMessageCommand= cmd(linear,0.5;diffuse,color('#666666FF')),
  OnCommand= cmd(),
  StormMessageCommand= cmd(linear,1;diffuse,color('#666666FF')),
  Texture= "_tex forecloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_yuk",
    Frames= {
      {Frame= 0, Delay= 0.05},
      {Frame= 1, Delay= 0.05},
      {Frame= 2, Delay= 0.05},
      {Frame= 3, Delay= 0.05},
      {Frame= 4, Delay= 0.05},
      {Frame= 5, Delay= 0.05},
      {Frame= 6, Delay= 0.05},
      {Frame= 7, Delay= 0.05},
      {Frame= 8, Delay= 0.05},
      {Frame= 9, Delay= 0.05},
  },
  DayMessageCommand= cmd(linear,0.5;diffuse,color('#FFFFFFFF')),
  InitCommand= cmd(draworder,200;x,SCREEN_CENTER_X-640;y,SCREEN_CENTER_Y+128),
  NightMessageCommand= cmd(linear,0.5;diffuse,color('#666666FF')),
  OnCommand= cmd(sleep,1;decelerate,2;addx,480;accelerate,0.5;addx,-80;decelerate,0.5;addx,-80),
  StormMessageCommand= cmd(linear,1;diffuse,color('#666666FF')),
  Texture= "./chickun 4x3.png",
  },
  Def.Sprite{
    Name= "xtl_actor_zuk",
  InitCommand= cmd(draworder,199),
  Texture= "arrows",
  },
  Def.ActorFrame{
    Name= "xtl_actor_avk",
  InitCommand= cmd(draworder,500),
    Def.Sprite{
      Name= "xtl_actor_bvk",
    DayMessageCommand= cmd(linear,0.5;diffusealpha,0),
    InitCommand= cmd(draworder,99;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;ZoomToWidth,SCREEN_WIDTH*1.25;ZoomToHeight,SCREEN_HEIGHT;diffuse,color('#FFFFFF50');fadebottom,0.25;cropbottom,1;croptop,0.1;fadetop,0.25),
    OnCommand= cmd(),
    StormMessageCommand= cmd(sleep,0.5;customtexturerect,0,0,1,0.5;texcoordvelocity,0.5,-2;linear,0.5;cropbottom,-0.25),
    Texture= "rain.png",
    },
    Def.Sprite{
      Name= "xtl_actor_cvk",
    DayMessageCommand= cmd(diffusealpha,0),
    InitCommand= cmd(draworder,98;y,SCREEN_TOP+32;zoomy,2.25;vertalign,top;blend,"BlendMode_Add";diffuse,color('1'),1,1,1;cropbottom,1;fadetop,0.05),
    OnCommand= cmd(),
    StormMessageCommand= cmd(sleep,1;queuecommand,"Update"),
    Texture= "lightning",
    UpdateCommand= function(self)
                if _CQ.ChartPosition < 304 then
                    SOUND:PlayOnce(_CQ.FilePath .. '/kfc/sound/thunder.ogg')
                    
                    self:queuemessage('Lightning')
                    self:x(math.random(120,520))
                    self:cropbottom(1)
                    self:diffuse(1,1,1,1)
                    self:linear(0.1)
                    self:cropbottom(-0.05)
                    self:diffuse(1,0.9,1,1)
                    self:linear(0.25)
                    self:diffuse(0.7,0.6,0.7,1)
                    self:linear(0.25)
                    self:diffuse(0.7,0.6,0.7,0)
                    
                    self:sleep(math.random(4,7))
                    self:queuecommand('Update')
                end
            end,
    },
    Def.Quad{
      Name= "xtl_actor_dvk",
    InitCommand= cmd(draworder,9999;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;ZoomToWidth,SCREEN_WIDTH;ZoomToHeight,SCREEN_HEIGHT;diffuse,color('#FFFFFF00')),
    LightningMessageCommand= cmd(diffuse,color('#FFFFFFFF');sleep,0.025;diffuse,color('#FFFFFF00');sleep,0.05;diffuse,color('#FFFFFFFF');sleep,0.025;linear,0.1;diffuse,color('#FFFFFF00')),
    OnCommand= cmd(),
    },
    Def.Sprite{
      Name= "xtl_actor_evk",
    DayMessageCommand= cmd(linear,0.5;diffusealpha,0),
    InitCommand= cmd(draworder,100;diffuse,color('#666666FF');x,SCREEN_CENTER_X;y,SCREEN_BOTTOM+128;bob;effectmagnitude,0,20,0),
    OnCommand= cmd(),
    StormMessageCommand= cmd(decelerate,1;y,SCREEN_TOP+32),
    Texture= "cloud.png",
    },
    Def.Sprite{
      Name= "xtl_actor_fvk",
    DayMessageCommand= cmd(linear,0.5;diffusealpha,0),
    InitCommand= cmd(draworder,102;diffuse,color('#666666FF');x,SCREEN_CENTER_X-240;y,SCREEN_BOTTOM+128;bob;effectmagnitude,0,20,0;effectoffset,0.33),
    OnCommand= cmd(),
    StormMessageCommand= cmd(sleep,0.1;decelerate,1;y,SCREEN_TOP+32),
    Texture= "cloud.png",
    },
    Def.Sprite{
      Name= "xtl_actor_gvk",
    DayMessageCommand= cmd(linear,0.5;diffusealpha,0),
    InitCommand= cmd(draworder,101;diffuse,color('#666666FF');x,SCREEN_CENTER_X+240;y,SCREEN_BOTTOM+128;bob;effectmagnitude,0,20,0;effectoffset,0.66),
    OnCommand= cmd(),
    StormMessageCommand= cmd(sleep,0.2;decelerate,1;y,SCREEN_TOP+32),
    Texture= "cloud.png",
    },
    Def.Sprite{
      Name= "xtl_actor_hvk",
    FadeGhostsMessageCommand= cmd(stoptweening;linear,0.5;diffusealpha,0),
    GhostMessageCommand= cmd(decelerate,2;x,SCREEN_CENTER_X;queuecommand,"Update"),
    InitCommand= cmd(draworder,200;x,SCREEN_RIGHT+128;y,SCREEN_CENTER_Y;diffusealpha,0.5;bob;effectmagnitude,0,30,0;effectperiod,3),
    OnCommand= cmd(),
    Texture= "rarighost.png",
    UpdateCommand= function(self)
                local nX = math.random(100,540)
                local nY = math.random(240,400)
                
                self:accelerate(0.25)
                if nX >= self:GetX() then
                    self:zoomx(-1)
                else
                    self:zoomx(1)
                end
                
                self:decelerate(4.5)
                self:x(nX)
                self:y(nY)
                
                self:sleep(1)
                self:queuecommand('Update')
            end,
    },
    Def.Sprite{
      Name= "xtl_actor_ivk",
    FadeGhostsMessageCommand= cmd(stoptweening;sleep,0.5;linear,0.5;diffusealpha,0),
    InitCommand= cmd(draworder,201;x,SCREEN_RIGHT+128;y,SCREEN_CENTER_Y;diffusealpha,0.5;bob;effectmagnitude,0,30,0;effectperiod,3),
    OnCommand= cmd(),
    SecondGhostMessageCommand= cmd(decelerate,3;x,SCREEN_CENTER_X;queuecommand,"Update"),
    Texture= "flutterghost.png",
    UpdateCommand= function(self)
                local nX = math.random(100,540)
                local nY = math.random(240,400)
                
                self:accelerate(0.25)
                if nX >= self:GetX() then
                    self:zoomx(-1)
                else
                    self:zoomx(1)
                end
                
                self:decelerate(4)
                self:x(nX)
                self:y(nY)
                
                self:sleep(1)
                self:queuecommand('Update')
            end,
    },
    Def.Sprite{
      Name= "xtl_actor_jvk",
    FadeGhostsMessageCommand= cmd(stoptweening;sleep,1;linear,0.5;diffusealpha,0),
    InitCommand= cmd(draworder,202;x,SCREEN_RIGHT+128;y,SCREEN_CENTER_Y;diffusealpha,0.5;bob;effectmagnitude,0,30,0;effectperiod,3),
    OnCommand= cmd(),
    SecondGhostMessageCommand= cmd(sleep,1;decelerate,3.5;x,SCREEN_CENTER_X-100;queuecommand,"Update"),
    Texture= "ghostiepie.png",
    UpdateCommand= function(self)
                local nX = math.random(100,540)
                local nY = math.random(240,400)
                
                self:accelerate(0.25)
                if nX >= self:GetX() then
                    self:zoomx(-1)
                else
                    self:zoomx(1)
                end
                
                self:decelerate(5)
                self:x(nX)
                self:y(nY)
                
                self:sleep(1)
                self:queuecommand('Update')
            end,
    },
    Def.ActorFrame{
      Name= "xtl_actor_kvk",
    InitCommand= cmd(draworder,300;x,SCREEN_RIGHT-96;y,SCREEN_BOTTOM-80;zoom,0),
    OnCommand= cmd(sleep,153.3;zoom,1;decelerate,0.7745;addy,-400;accelerate,0.7745;addy,400;sleep,0;zoom,0),
      Def.ActorFrame{
        Name= "xtl_actor_lvk",
      InitCommand= cmd(),
      OnCommand= cmd(sleep,153.3;linear,1.549;addx,-440),
        Def.Sprite{
          Name= "xtl_actor_mvk",
        InitCommand= cmd(addx,48;rotationz,-90),
        Texture= "arrows/4th 4x4.png",
        },
        Def.Sprite{
          Name= "xtl_actor_nvk",
        InitCommand= cmd(draworder,300;addx,-48;rotationz,90),
        Texture= "arrows/4th 4x4.png",
        },
      },
    },
    Def.Sprite{
      Name= "xtl_actor_ovk",
    InitCommand= cmd(draworder,301;x,SCREEN_RIGHT-96;y,SCREEN_BOTTOM-80;diffusealpha,0),
    OnCommand= cmd(sleep,153.3;diffusealpha,1;decelerate,1;diffusealpha,0;addy,-80;addx,-40),
    Texture= "cloud.png",
    },
    Def.Sprite{
      Name= "xtl_actor_pvk",
    InitCommand= cmd(draworder,302;x,SCREEN_RIGHT-96-440;y,SCREEN_BOTTOM-80;diffusealpha,0),
    OnCommand= cmd(sleep,153.3+1.549;diffusealpha,1;decelerate,1;diffusealpha,0;addy,-80;addx,-40),
    Texture= "cloud.png",
    },
    Def.Sprite{
      Name= "xtl_actor_qvk",
      Frames= {
        {Frame= 0, Delay= 0.1},
        {Frame= 1, Delay= 0.1},
        {Frame= 2, Delay= 0.1},
        {Frame= 3, Delay= 0.1},
        {Frame= 4, Delay= 0.1},
        {Frame= 5, Delay= 0.1},
        {Frame= 6, Delay= 0.1},
    },
    InitCommand= cmd(draworder,400;x,SCREEN_LEFT-200;y,SCREEN_CENTER_Y-80;rotationy,180;bob;effectmagnitude,0,30,0;effectperiod,6),
    OnCommand= cmd(),
    RainbowDashMessageCommand= cmd(decelerate,7;x,SCREEN_CENTER_X;sleep,5;accelerate,5;x,SCREEN_RIGHT+200),
    Texture= "./phils_qurl 4x2.png",
    },
    Def.BitmapText{
      Name= "xtl_actor_rvk",
    Font= "_eurostile outline,",
    InitCommand= cmd(draworder,401;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y+60;diffuse,color('#a6ebff');cropright,1;faderight,0.1),
    OnCommand= cmd(),
    RainbowDashMessageCommand= function(self)
                local m = {
                    'Hey there, squirt. Looking good!',
                    'xX420 Pro MLG NoScope!!Xx',
                    'Keep it up, kid! Almost there!',
                    'Not much longer now, keep going!',
                    'Weird weather today, huh?',
                    'Have you seen Pinkie Pie lately?',
                    'Have you seen Rarity lately?',
                    'Have you seen Fluttershy lately?',
                }
                
                self:settext(m[math.random(1,table.getn(m))])
                self:sleep(6)
                self:linear(1)
                self:cropright(-0.1)
                self:sleep(4)
                self:linear(1)
                self:diffusealpha(0)
            end,
    Text= ",",
    },
    Def.Sprite{
      Name= "xtl_actor_svk",
    FactoryMessageCommand= function(self)
                _CQ.RainbowToggle = true
                self:queuecommand('Update')
            end,
    InitCommand= cmd(x,SCREEN_RIGHT+64;y,SCREEN_CENTER_Y;zoomy,4;diffusealpha,0.75),
    OnCommand= cmd(),
    Texture= "rainbow.png",
    UpdateCommand= function(self)
                self:linear(1)
                self:x(SCREEN_LEFT-64)
                self:sleep(0.02)
                if _CQ.RainbowToggle then
                    self:x(SCREEN_RIGHT+64)
                    self:queuecommand('Update')
                end
            end,
    },
  },
}