local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_wzk",
  Def.ActorFrame{
    Name= "xtl_actor_xzk",
  InitCommand= function()
			queen = {
				path = SONGMAN:FindSong(GAMESTATE:GetCurrentSong():GetDisplayFullTitle()):GetSongDir(),
				curscorep1 = 0,
				curscorep2 = 0,
				difficulty = '',
				curquestbegin = 1,
				curquestend = 1,
				questbeatsbegin = {36,81,126,171,208,253,302,347,392},
				questbeatsend = {60,105,150,187,232,277,326,371,416},
				
				questions = {
					easy = {
						'What is the original name of the boss course from In The Groove 1?',
						'What is the minimum score required to get a grade of \'S-\' ?',
						'Which of these songs is NOT by Nina?',
						'Which of these Single Expert charts does NOT have hands?',
						'Which of these songs does NOT have tempo stops?',
						'Which of these songs is the slowest?',
						'Which of these songs had a special fail screen?',
						'Which of these songs was NOT an unlockable from In The Groove 1?',
						'Which of these note types was introduced in In The Groove 2?'
					},
					medium = {
						'Which mode of play was introduced in In The Groove 2?',
						'Which song\'s Single Expert chart has the most notes of any song in both In The Groove 1 and 2?',
						'Which song was NOT part of In The Groove 2\'s boss course, Nightmare?',
						'Which of these songs is NOT by Sammi Morelli?',
						'Which of these courses is NOT from In The Groove 2?',
						'Which of these mods was not selectable in In The Groove 1?',
						'Which Disconnected song is NOT used in a marathon?',
						'Which song\'s Single Expert chart was NOT rated a 10 in In The Groove 1?',
						'Which of these charts did NOT get changed either between games or between patches?'
					},
					
					hard = {
						'Which of these Double Expert charts is NOT rated a 13?',
						'Which of these songs does NOT have the same rating for its Double Hard and Double Expert charts?',
						'Which of these songs is NOT by Machinae Supremacy?',
						'Which of these songs is from In The Groove 2?',
						'Which of these courses is a survival, and not a marathon?',
						'How many Disconnected songs are in In The Groove 1 and 2, total?',
						'Which song\'s expert chart was NOT an unlockable?',
						'Which of these mods exists but is NOT selectable In The Groove 2?',
						'Which of these songs does NOT have a slowdown?'
					},
					expert = {
						'Which of these songs is the fastest?',
						'Which of these marathons contains FIVE songs?',
						'Which of these Single Expert charts has holds?',
						'Which of these songs is NOT by Inspector K?',
						'The mod course \'Nightmare\' from In The Groove 2 had two mods active throughout the entire course. Which mods were they?',
						'Which of these songs does NOT have a gradual tempo change?',
						'Which of these Single Expert charts does NOT have rolls?',
						'Which of these courses does NOT have mods?',
						'Which of these songs does NOT have a Double Expert chart?'
					}
				},
					
				answers = {
					easy = {
						{'Pure Hell','Breaking Point','Nightmare','Inside Out'},
						{'87%','89%','91%','93%'},
						{'Pick Me Up & Tango','Life of a Butterfly','ROM-eo & Juli8','Charlene'},
						{'Know Your Enemy','Hybrid','Why Me','Amore'},
						{'Xuxa','Pandemonium','VerTex','Tension'},
						{'Zodiac','Dreams of Passion','I\'ll Get There Anyway','Perfect'},
						{'Pandemonium','Energizer','Bloodrush','Summer ~Speedy Mix~'},
						{'DJ Party','Anubis','Disconnected -Mobius-','July'},
						{'Rolls','Holds','Mines','Lifts'}
					},
					
					medium = {
						{'Dance','Battle','Marathon','Survival'},
						{'Hardcore of the North','Bloodrush','Pandemonium','Euphoria'},
						{'Bloodrush','Energizer','VerTex²','Summer ~Speedy Mix~'},
						{'I\'ll Get There Anyway','Let My Love Go Blind','Let Me Be The One','Perfect'},
						{'Driven','Wildside','Wings','Slower'},
						{'Dizzy','Bumpy','Flip','Tornado'},
						{'Disconnected','Disconnected -Hyper-','Disconnected -Mobius-','Disconnected Disco'},
						{'Hip Hop Jam','Disconnected -Hyper-','Zodiac','Mythology'},
						{'Hardcore Symphony (Single Expert)','Charlene (Single Expert)','Monolith (Single Expert)','VerTex² (Double Expert)'}
					},
					
					hard = {
						{'!','Pandemonium','Energizer','VerTex²'},
						{'Da Roots','Go 60 Go','I Think I Like That Sound','Xuxa'},
						{'High','Hybrid','Cryosleep','Bouff'},
						{'Birdie','Disconnected -Hyper-','Oasis','The Game'},
						{'Rock Out','Mirage','Universal','Fractious'},
						{'2','3','4','5'},
						{'Cryosleep','Robotix','!','Visible Noise'},
						{'Invert','Floored','Blink','Skippy'},
						{'Disconnected Mobius','Kagami','Touch Me','Utopia'}
					},
					
					expert = {
						{'Disconnected -Hyper-','Hip Hop Jam','No 1 Nation','Monolith'},
						{'Hot in the Sun','Keel Over','The Legend','Caddywhompus'},
						{'Determinator','Soapy Bubble','Mythology','Summer in Belize'},
						{'Delirium','Infection','Liquid Moon','Clockwork Genesis'},
						{'Dizzy, Reverse','Bumpy, Beat','Hide Targets, Hide Judgment','Drift, Float'},
						{'Da Roots','VerTex','Hardcore of the North','One False Move'},
						{'July -Euromix-','!','Amore','Wanna Do ~Hardhouse Mix~'},
						{'Just Dance','Sisters','Digital','The Legend'},
						{'Psalm Pilot','Life of a Butterfly','Hillbilly Hardcore','This is Rock & Roll'}
					},
				},
				
				questtime = 0,
				fgcurcommand = 1
			};
			
			function queen.RandomDiff()
				local curSong = GAMESTATE:GetCurrentSong();
				local vSteps = curSong:GetStepsByStepsType( STEPS_TYPE_DANCE_SINGLE )
				
				local r = math.random(1,table.getn(vSteps));
				
				if GAMESTATE:IsPlayerEnabled(PLAYER_1) then GAMESTATE:SetCurrentSteps(PLAYER_1,vSteps[r]); end
				if GAMESTATE:IsPlayerEnabled(PLAYER_2) then GAMESTATE:SetCurrentSteps(PLAYER_2,vSteps[r]); end
				
				SCREENMAN:SetNewScreen('ScreenGameplay');
			end
			
		end,
  },
  Def.Quad{
    Name= "xtl_actor_yzk",
  OnCommand= cmd(visible,true;sleep,1000),
  },
}