local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_zzk",
  Def.ActorFrame{
    Name= "xtl_actor_aal",
    Def.Quad{
      Name= "xtl_actor_bal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;ZoomToWidth,SCREEN_WIDTH;ZoomToHeight,SCREEN_HEIGHT;diffuse,color('#000000');sleep,1000),
    },
    Def.Quad{
      Name= "xtl_actor_cal",
    CheckScoreMessageCommand= cmd(sleep,1;queuecommand,"Hello"),
    HelloCommand= function()
				for i=1,2 do
					if GAMESTATE:IsHumanPlayer(i-1) then
						if math.abs((tonumber(queen['curscorep'..i])) - tonumber(string.sub(queen['scorep'..i]:GetText(),1,string.len(queen['scorep'..i]:GetText()) - 1))) < 0.01 then
							MESSAGEMAN:Broadcast('Player'..i..'OptOut')
						elseif tonumber(string.sub(queen['scorep'..i]:GetText(),1,string.len(queen['scorep'..i]:GetText()) - 1)) > tonumber(queen['curscorep'..i]) then
							MESSAGEMAN:Broadcast('Player'..i..'Correct')
						else
							MESSAGEMAN:Broadcast('Player'..i..'Incorrect')
						end
					end
				end
			end,
    InitCommand= cmd(visible,true),
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_dal",
  OnCommand= cmd(x,SCREEN_CENTER_X-160;y,SCREEN_CENTER_Y;zoom,0.5),
    Def.Sprite{
      Name= "xtl_actor_eal",
    OnCommand= cmd(diffusealpha,0),
    Player1CorrectMessageCommand= function(self) SOUND:PlayOnce(queen.path..'lua/right_l.ogg'); self:diffusealpha(1); self:linear(1); self:diffusealpha(0); end,
    Texture= "check",
    },
    Def.Sprite{
      Name= "xtl_actor_fal",
    OnCommand= cmd(diffusealpha,0),
    Player1IncorrectMessageCommand= function(self) SOUND:PlayOnce(queen.path..'lua/wrong_l.ogg'); self:diffusealpha(1); self:linear(1); self:diffusealpha(0); end,
    Texture= "x",
    },
    Def.BitmapText{
      Name= "xtl_actor_gal",
    Font= "Common Normal,",
    OnCommand= cmd(diffusealpha,0;zoom,4),
    Player1OptOutMessageCommand= cmd(diffusealpha,1;linear,1;diffusealpha,0),
    Text= "Opt::Out,",
    },
  },
  Def.ActorFrame{
    Name= "xtl_actor_hal",
  OnCommand= cmd(x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y;zoom,0.5),
    Def.Sprite{
      Name= "xtl_actor_ial",
    OnCommand= cmd(diffusealpha,0),
    Player2CorrectMessageCommand= function(self) SOUND:PlayOnce(queen.path..'lua/right_r.ogg'); self:diffusealpha(1); self:linear(1); self:diffusealpha(0); end,
    Texture= "check",
    },
    Def.Sprite{
      Name= "xtl_actor_jal",
    OnCommand= cmd(diffusealpha,0),
    Player2IncorrectMessageCommand= function(self) SOUND:PlayOnce(queen.path..'lua/wrong_r.ogg'); self:diffusealpha(1); self:linear(1); self:diffusealpha(0); end,
    Texture= "x",
    },
    Def.BitmapText{
      Name= "xtl_actor_kal",
    Font= "Common Normal,",
    OnCommand= cmd(diffusealpha,0;zoom,4),
    Player2OptOutMessageCommand= cmd(diffusealpha,1;linear,1;diffusealpha,0),
    Text= "Opt::Out,",
    },
  },
  Def.Quad{
    Name= "xtl_actor_lal",
  InitCommand= cmd(visible,true),
  OnCommand= function(self)
				self:queuecommand('Update');
			end,
  UpdateCommand= function(self)
			if GAMESTATE:GetSongBeat()>=2 and queen.fgcurcommand == 1 then
				queen.RandomDiff();
				queen.fgcurcommand = queen.fgcurcommand + 1;
			end
			
			--SCREENMAN:SystemMessage(tostring(queen.fgcurcommand));
			
			if GAMESTATE:GetSongBeat()>=3 and queen.difficulty == '' then
				local diff = {'easy','medium','hard','expert'};
				SCREENMAN:GetTopScreen():GetChild('Overlay'):hidden(1);
				SCREENMAN:GetTopScreen():GetChild('Underlay'):hidden(1);
				for i=1,2 do
					if GAMESTATE:IsHumanPlayer(i-1) then
						SCREENMAN:GetTopScreen():GetChild('PlayerP'..i):hidden(1);
						SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):hidden(1);
						queen['scorep'..i] = SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP'..i);
						queen.difficulty = diff[GAMESTATE:GetCurrentSteps(i-1):GetDifficulty()];
					end
				end
				queen.fgcurcommand = queen.fgcurcommand + 1;
			end
			
			if queen.curquestbegin <= table.getn(queen.questbeatsbegin) and GAMESTATE:GetSongBeat() >= queen.questbeatsbegin[queen.curquestbegin] then
				MESSAGEMAN:Broadcast('ShowQuestion');
				queen.questtime = (queen.questbeatsend[queen.curquestend] - queen.questbeatsbegin[queen.curquestbegin])*(0.48);
				queen.curquestbegin = queen.curquestbegin + 1;
				
				for i=1,2 do
					if queen['scorep'..i] then
						queen['curscorep'..i] = string.sub(queen['scorep'..i]:GetText(),1,string.len(queen['scorep'..i]:GetText()) - 1);
						--SCREENMAN:SystemMessage(tostring(queen['curscorep'..i]))
					end
				end
			end
			
			if queen.curquestend <= table.getn(queen.questbeatsend) and GAMESTATE:GetSongBeat() >= queen.questbeatsend[queen.curquestend] then
				MESSAGEMAN:Broadcast('HideText');
				MESSAGEMAN:Broadcast('CheckScore');
				queen.curquestend = queen.curquestend + 1;
			end
			
			queen.questtime = queen.questtime - 0.02;
			MESSAGEMAN:Broadcast('UpdateTime');
			
			
			
			self:sleep(0.02);
			self:queuecommand('Update');
		end,
  },
  Def.BitmapText{
    Name= "xtl_actor_mal",
  Font= "Common Normal,",
  OnCommand= cmd(visible,true;x,SCREEN_RIGHT-105;y,SCREEN_CENTER_Y + -235;horizalign,left;vertalign,top),
  Text= "test,",
  UpdateMetricsMessageCommand= function(self) self:settext(windeu_jm.time); end,
  },
  Def.BitmapText{
    Name= "xtl_actor_nal",
  Font= "Common Normal,",
  HideTextMessageCommand= cmd(linear,0.25;diffusealpha,0;sleep,0.01;cropright,1),
  OnCommand= cmd(wrapwidthpixels,600;horizalign,left;vertalign,top;cropright,1;x,SCREEN_LEFT+20;y,SCREEN_TOP+20),
  ShowQuestionMessageCommand= function(self) self:diffusealpha(1); self:settext(queen.questions[queen.difficulty][queen.curquestbegin]); self:linear(2); self:cropright(0); self:queuemessage('ShowAnswer'); end,
  Text= "question,",
  },
  Def.BitmapText{
    Name= "xtl_actor_oal",
  Font= "Common Normal,",
  HideTextMessageCommand= cmd(linear,0.25;diffusealpha,0;sleep,0.01;cropright,1),
  OnCommand= cmd(wrapwidthpixels,600;horizalign,left;cropright,1;x,SCREEN_LEFT+100;y,SCREEN_CENTER_Y-85),
  ShowAnswerMessageCommand= function(self) self:diffusealpha(1); self:settext('&LEFT; '..queen.answers[queen.difficulty][queen.curquestend][1]); self:linear(1); self:cropright(0);end,
  Text= "answer 1,",
  },
  Def.BitmapText{
    Name= "xtl_actor_pal",
  Font= "Common Normal,",
  HideTextMessageCommand= cmd(linear,0.25;diffusealpha,0;sleep,0.01;cropright,1),
  OnCommand= cmd(wrapwidthpixels,600;horizalign,left;cropright,1;x,SCREEN_LEFT+100;y,SCREEN_CENTER_Y-35),
  ShowAnswerMessageCommand= function(self) self:diffusealpha(1); self:settext('&DOWN; '..queen.answers[queen.difficulty][queen.curquestend][2]); self:linear(1); self:cropright(0);end,
  Text= "answer 2,",
  },
  Def.BitmapText{
    Name= "xtl_actor_qal",
  Font= "Common Normal,",
  HideTextMessageCommand= cmd(linear,0.25;diffusealpha,0;sleep,0.01;cropright,1),
  OnCommand= cmd(wrapwidthpixels,600;horizalign,left;cropright,1;x,SCREEN_LEFT+100;y,SCREEN_CENTER_Y+15),
  ShowAnswerMessageCommand= function(self) self:diffusealpha(1); self:settext('&UP; '..queen.answers[queen.difficulty][queen.curquestend][3]); self:linear(1); self:cropright(0);end,
  Text= "answer 3,",
  },
  Def.BitmapText{
    Name= "xtl_actor_ral",
  Font= "Common Normal,",
  HideTextMessageCommand= cmd(linear,0.25;diffusealpha,0;sleep,0.01;cropright,1),
  OnCommand= cmd(wrapwidthpixels,600;horizalign,left;cropright,1;x,SCREEN_LEFT+100;y,SCREEN_CENTER_Y+65),
  ShowAnswerMessageCommand= function(self) self:diffusealpha(1); self:settext('&RIGHT; '..queen.answers[queen.difficulty][queen.curquestend][4]); self:linear(1); self:cropright(0);end,
  Text= "answer 4,",
  },
  Def.BitmapText{
    Name= "xtl_actor_sal",
  Font= "Common Normal,",
  OnCommand= cmd(horizalign,right;vertalign,bottom;x,SCREEN_RIGHT-10;y,SCREEN_BOTTOM-25),
  Text= "time,",
  UpdateTimeMessageCommand= function(self) self:hidden(1); if queen.questtime > 0 then self:hidden(0); self:settext(string.format('%1.2f',queen.questtime)) end end,
  },
  Def.BitmapText{
    Name= "xtl_actor_tal",
  Font= "Common Normal,",
  OnCommand= cmd(wrapwidthpixels,600;cropright,1;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-50;sleep,1;linear,10;cropright,0;sleep,5;linear,1;diffusealpha,0),
  Text= "Welcome to ITG Trivia!::::If you know the answer to the question, hold down your response before time runs out. Hold down ONLY your response, and no other panels.::::Correct responses will yield score, incorrect responses will deduct score, and you can opt out of questions for no penalty.::::Good luck!,",
  },
}