local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_ual",
DIFFSTUFFCommand= function(self)
				local d1, d2, sTable;
                if GAMESTATE:IsPlayerEnabled(0) and GAMESTATE:IsPlayerEnabled(1) then
                    d1 = GAMESTATE:GetCurrentSteps(0):GetDifficulty();
                    d2 = GAMESTATE:GetCurrentSteps(1):GetDifficulty();
                    sTable = GAMESTATE:GetCurrentSong():GetStepsByStepsType( STEPS_TYPE_DANCE_SINGLE );
                    
                    if GAMESTATE:IsEventMode() and d1 == 4 and d2 == 4 then
                        local r1 = math.random(1,4);
                        local r2 = math.random(1,3);
                        if r2 >= r1 then
                            r2 = r2 + 1;
                        end
                        
                        GAMESTATE:SetCurrentSteps(0,sTable[r1]);
                        GAMESTATE:SetCurrentSteps(1,sTable[r2]);
                        SCREENMAN:SetNewScreen('ScreenGameplay');
                    end
                end
			end,
OnCommand= cmd(sleep,0.02;queuecommand,"DIFFSTUFF"),
  Def.Quad{
    Name= "xtl_actor_val",
  OnCommand= function(self)
            self:sleep(420); -- BLAZE IT
        end,
  },
  Def.Quad{
    Name= "xtl_actor_wal",
  InitCommand= function(self)
            n_obstacles = 10;
        
            obstacle_width = 64;
            obstacle_height = 100;
            obstacle_distance = 300;
            
            box_size = 32;
            
            obstacles = {};
            
            for i=1,n_obstacles do
                obstacles[i] = math.random(-160,160);
            end
            
            p1_done = not GAMESTATE:IsPlayerEnabled(0);
            p2_done = not GAMESTATE:IsPlayerEnabled(1);
            
            p2_x_offset = SCREEN_CENTER_X + obstacle_width / 2;
            
            function p1_reset()
                p1_box_x = 0;
                p1_box_y = SCREEN_CENTER_Y;
                p1_box_dy = 0;
                p1_screen_x = -40;
                p1_obstacle_idx = 1;
            end
            
            function p2_reset()
                p2_box_x = 0;
                p2_box_y = SCREEN_CENTER_Y;
                p2_box_dy = 0;
                p2_screen_x = -40;
                p2_obstacle_idx = 1;
            end
            
            p1_reset();
            p2_reset();
        end,
  OnCommand= function(self)
            if p1_done then
                MESSAGEMAN:Broadcast('P1Done');
            end
            
            if p2_done then
                MESSAGEMAN:Broadcast('P2Done');
            end
            self:queuecommand('Timer');
        end,
  StepP1MessageCommand= function(self)
            p1_box_dy = -7;
        end,
  StepP2MessageCommand= function(self)
            p2_box_dy = -7;
        end,
  TimerCommand= function(self)
            if not p1_done then
                -- p1 movement --
                
                p1_box_x = p1_box_x + 4;
                p1_box_y = p1_box_y + p1_box_dy;
                p1_box_dy = p1_box_dy + 0.5;
                p1_screen_x = p1_box_x - 40;
                
                local p1_obstacle_x = obstacle_distance*p1_obstacle_idx;
                if p1_obstacle_x - p1_screen_x < -obstacle_width/2 then
                    p1_obstacle_idx = p1_obstacle_idx + 1;
                    if p1_obstacle_idx > n_obstacles then
                        p1_done = true;
                        MESSAGEMAN:Broadcast('P1Done');
                    end
                    p1_obstacle_x = p1_obstacle_x + obstacle_distance;
                end
                
                -- p1 collision detection --
                if p1_box_y > SCREEN_BOTTOM-box_size/2 or p1_box_y < box_size/2 then
                    p1_reset();
                end
                
                if p1_obstacle_idx <= n_obstacles then
                    local p1_obstacle_y = SCREEN_CENTER_Y + obstacles[p1_obstacle_idx];
                    if math.abs(p1_box_x - p1_obstacle_x) < (box_size + obstacle_width) / 2 then
                        if math.abs(p1_box_y - p1_obstacle_y) > (obstacle_height - box_size) / 2 then
                            p1_reset();
                        end
                    end
                end
            end
            
            if not p2_done then
                -- p2 movement --
                
                p2_box_x = p2_box_x + 4;
                p2_box_y = p2_box_y + p2_box_dy;
                p2_box_dy = p2_box_dy + 0.5;
                p2_screen_x = p2_box_x - 40;
                
                local p2_obstacle_x = obstacle_distance*p2_obstacle_idx;
                if p2_obstacle_x - p2_screen_x < -obstacle_width/2 then
                    p2_obstacle_idx = p2_obstacle_idx + 1;
                    if p2_obstacle_idx > n_obstacles then
                        p2_done = true;
                        MESSAGEMAN:Broadcast('P2Done');
                    end
                    p2_obstacle_x = p2_obstacle_x + obstacle_distance;
                end
                
                -- p2 collision detection --
                if p2_box_y > SCREEN_BOTTOM-box_size/2 or p2_box_y < box_size/2 then
                    p2_reset();
                end
                
                if p2_obstacle_idx <= n_obstacles then
                    local p2_obstacle_y = SCREEN_CENTER_Y + obstacles[p2_obstacle_idx];
                    if math.abs(p2_box_x - p2_obstacle_x) < (box_size + obstacle_width) / 2 then
                        if math.abs(p2_box_y - p2_obstacle_y) > (obstacle_height - box_size) / 2 then
                            p2_reset();
                        end
                    end
                end
            end
            
            MESSAGEMAN:Broadcast('GameStep');
            self:sleep(0.03);
            self:queuecommand('Timer');
        end,
  },
  Def.Sprite{
    Name= "xtl_actor_xal",
  OnCommand= function(self)
            self:x(144);
            self:y(SCREEN_CENTER_Y);
        end,
  P1DoneMessageCommand= function(self)
            self:diffusealpha(0);
        end,
  Texture= "../img/blank.png",
  },
  Def.Sprite{
    Name= "xtl_actor_yal",
  OnCommand= function(self)
            self:x(144 + p2_x_offset);
            self:y(SCREEN_CENTER_Y);
        end,
  P2DoneMessageCommand= function(self)
            self:diffusealpha(0);
        end,
  Texture= "../img/blank.png",
  },
  Def.Sprite{
    Name= "xtl_actor_zal",
  GameStepMessageCommand= function(self)
            self:x(p1_box_x - p1_screen_x);
            self:y(p1_box_y);
        end,
  P1DoneMessageCommand= function(self)
            self:diffusealpha(0);
        end,
  Texture= "../img/box.png",
  },
  Def.Sprite{
    Name= "xtl_actor_abl",
  GameStepMessageCommand= function(self)
            self:x(p2_box_x - p2_screen_x + p2_x_offset);
            self:y(p2_box_y);
        end,
  P2DoneMessageCommand= function(self)
            self:diffusealpha(0);
        end,
  Texture= "../img/box.png",
  },
  Def.Sprite{
    Name= "xtl_actor_bbl",
  GameStepMessageCommand= function(self)
            if p1_obstacle_idx <= n_obstacles then
                self:y(obstacles[p1_obstacle_idx] - obstacle_height / 2);
            
                local x = obstacle_distance*p1_obstacle_idx - p1_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_cbl",
  GameStepMessageCommand= function(self)
            if p1_obstacle_idx <= n_obstacles then
                self:y(obstacles[p1_obstacle_idx] + 480 + obstacle_height / 2);
            
                local x = obstacle_distance*p1_obstacle_idx - p1_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_dbl",
  GameStepMessageCommand= function(self)
            local idx = p1_obstacle_idx+1;
            if idx <= n_obstacles then
                self:y(obstacles[idx] - obstacle_height / 2);
            
                local x = obstacle_distance*idx - p1_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ebl",
  GameStepMessageCommand= function(self)
            local idx = p1_obstacle_idx+1;
            if idx <= n_obstacles then
                self:y(obstacles[idx] + 480 + obstacle_height / 2);

                local x = obstacle_distance*idx - p1_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_fbl",
  GameStepMessageCommand= function(self)
            if p2_obstacle_idx <= n_obstacles then
                self:y(obstacles[p2_obstacle_idx] - obstacle_height / 2);
            
                local x = obstacle_distance*p2_obstacle_idx - p2_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x + p2_x_offset);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_gbl",
  GameStepMessageCommand= function(self)
            if p2_obstacle_idx <= n_obstacles then
                self:y(obstacles[p2_obstacle_idx] + 480 + obstacle_height / 2);
            
                local x = obstacle_distance*p2_obstacle_idx - p2_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x + p2_x_offset);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_hbl",
  GameStepMessageCommand= function(self)
            local idx = p2_obstacle_idx+1;
            if idx <= n_obstacles then
                self:y(obstacles[idx] - obstacle_height / 2);
            
                local x = obstacle_distance*idx - p2_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x + p2_x_offset);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ibl",
  GameStepMessageCommand= function(self)
            local idx = p2_obstacle_idx+1;
            if idx <= n_obstacles then
                self:y(obstacles[idx] + 480 + obstacle_height / 2);

                local x = obstacle_distance*idx - p2_screen_x;
                if -obstacle_width/2 < x and x < SCREEN_CENTER_X then
                    self:diffusealpha(1);
                    self:x(x + p2_x_offset);
                else
                    self:diffusealpha(0);
                end
            else
                self:diffusealpha(0);
            end
        end,
  Texture= "../img/obstacle.png",
  },
  Def.Sprite{
    Name= "xtl_actor_jbl",
  OnCommand= function(self)
            self:x(SCREEN_CENTER_X);
            self:y(SCREEN_CENTER_Y);
        end,
  Texture= "../img/obstacle.png",
  },
}