local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_mgt",
  Def.Quad{
    Name= "xtl_actor_ngt",
  OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;zoom,0;sleep,999),
  },
  Def.Quad{
    Name= "xtl_actor_ogt",
  OnCommand= function (self)
			
			fgcurcommand = 1;
			self:x(99999);
			self:y(240);
			self:queuecommand('Update')
			
		end,
  UpdateCommand= function (self)
			function RandomDiff() --Thanks WinDEU! (again)
				if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
					local curSong = GAMESTATE:GetCurrentSong();
					local vSteps = curSong:GetStepsByStepsType( STEPS_TYPE_DANCE_SINGLE )
				   
					local r1 = math.random(1,table.getn(vSteps));
					local r2 = math.random(1,table.getn(vSteps));
					while r1 == r2 do
						r2 = math.random(1,table.getn(vSteps)); -- ensure that the charts are different
					end
				   
					GAMESTATE:SetCurrentSteps(PLAYER_1,vSteps[r1]);
					GAMESTATE:SetCurrentSteps(PLAYER_2,vSteps[r2]);
				   
					SCREENMAN:SetNewScreen('ScreenGameplay');
				end
			end
			if GAMESTATE:GetSongBeat()>=-1 and fgcurcommand == 1 then
				RandomDiff();
				fgcurcommand = fgcurcommand + 1;
			end
		end,
  },
  Def.ActorFrame{
    Name= "xtl_actor_pgt",
  OnCommand= cmd(playcommand,"Start"),
  StartCommand= function(self)
		
			song = SONGMAN:FindSong(GAMESTATE:GetCurrentSong():GetDisplayFullTitle());
			path = song:GetSongDir();
			
			--if (GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2)) == false and SongSelectionScreen() ~= nil then
			--	SCREENMAN:SystemMessage('Both players must be enabled!')
			--	GAMESTATE:ApplyGameCommand('screen,'..SongSelectionScreen())
			--end
			
			--SOUND:PlayOnce(path .. 'animations/pacman/sounds/sound.ogg')
			
			te_pacman_p1 = {9999,9999,9999,9999,0,0,0,0} --x,y,dx,dy,powerup/dead,rot,tx,ty
			te_pacman_p2 = {9999,9999,9999,9999,0,0,0,0}
			
			te_pacman_items_x = {9999,9999,9999,9999,9999,9999,9999,9999}
			te_pacman_items_y = {9999,9999,9999,9999,9999,9999,9999,9999}
			te_pacman_items_type = {0,0,0,0,0,0,0,0}

			te_pacman_size = 40
			te_pacman_speed = 2
			
			te_pacman_scores = {0,0}
			te_pacman_invincible = {0,0}
			te_pacman_speeds = {te_pacman_speed,te_pacman_speed}
			
			--0-4: fruit, 5: speedup, 6: powerpill
			
			te_pacman_ghosts = {300,220,0,0,0,340,220,0,0,0} --x,y,dx,dy,rot
			te_pacman_recoil = {0,0}
			te_pacman_vulnerable = {0,0}
			te_pacman_bluetime = 0

			
			te_pacman_maze =
			{
				{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
				{1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1},
				{1,0,1,1,0,1,0,1,1,0,1,0,1,1,0,1},
				{1,0,1,0,0,0,0,0,0,0,0,0,0,1,0,1},
				{1,0,0,0,1,0,1,0,0,1,0,1,0,0,0,1},
				{1,0,1,0,1,0,1,0,0,1,0,1,0,1,0,1},
				{1,0,1,0,1,0,1,1,1,1,0,1,0,1,0,1},
				{1,0,0,0,1,0,0,0,0,0,0,1,0,0,0,1},
				{1,0,1,0,1,0,1,1,1,1,0,1,0,1,0,1},
				{1,0,1,0,0,0,0,1,1,0,0,0,0,1,0,1},
				{1,0,0,0,1,1,0,0,0,0,1,1,0,0,0,1},
				{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
			}
			
			te_pacman_start_measure = 0
			te_pacman_end_measure = 999
			te_pacman_active = 0
			
			function te_pacman_gettileloc(q)
				return (20 + (q-1)*40)
			end
			
			function te_pacman_getdist(a,b,c,d)
				return math.sqrt(math.pow(a-c,2)+math.pow(b-d,2))
			end
			
			function te_pacman_fakemod(a,b)
				local left = a
				while (left > b) do
					left = left - b
				end
				return left
			end
			
			function te_pacman_closesttile(x,y)
				local closesttile = 0
				local closestdistance = 999999
				for i=1,16,1 do
					for j=1,12,1 do
						if math.pow(te_pacman_gettileloc(i)-x,2) + math.pow(te_pacman_gettileloc(j)-y,2) < closestdistance then
							closesttile = i+((j-1)*16)
							closestdistance = math.pow(te_pacman_gettileloc(i)-x,2) + math.pow(te_pacman_gettileloc(j)-y,2)
						end
					end
				end
				return closesttile
			end
			
			function te_pacman_resetitem(i)
				te_pacman_items_x[i] = 9999
				te_pacman_items_y[i] = 9999
				te_pacman_items_type[i] = 0
			end
			
			function te_pacman_spawnitem(i,l) --item type, leave as -1 for random, location, -1 for random

				local pos = l
				if pos == -1 then
					local tries = 100
					local success = false
					while tries > 0 and success == false do
						pos = math.random(1,8)
						if te_pacman_items_x[pos] == 9999 then
							success = true
						end
						tries = tries - 1
					end
				end

				local tx = math.random(1,16)
				local ty = math.random(1,12)
				
				local success = false
				while success == false do
					tx = math.random(1,16)
					ty = math.random(1,12)
					if te_pacman_maze[ty][tx] == 0 and (te_pacman_p1[7] ~= tx or te_pacman_p1[8] ~= ty) and (te_pacman_p2[7] ~= tx or te_pacman_p2[8] ~= ty) and ((tx < 8 or tx > 9) or (ty < 5 or ty > 6)) then
						success = true
					end
				end
				
				te_pacman_maze[ty][tx] = 2
				
				if l > 0 then
					tx = te_pacman_fakemod(target,16)
					ty = math.ceil(target/16)
				end
				
				te_pacman_items_x[pos] = te_pacman_gettileloc(tx)
				te_pacman_items_y[pos] = te_pacman_gettileloc(ty)
				
				if i == -1 then
					te_pacman_items_type[pos] = math.random(0,5) --no powerpill on random
				else
					te_pacman_items_type[pos] = i
				end
			
			end

		end,
    Def.Quad{
      Name= "xtl_actor_qgt",
    OnCommand= cmd(playcommand,"Start";playcommand,"a"),
    StartCommand= function(self)
				self:zoom(0);
			end,
    StepP1MessageCommand= function(self)
				if te_pacman_active == 1 then
					te_pacman_p1[6] = te_pacman_p1[6] + 90
					if te_pacman_p1[6] == 360 then
						te_pacman_p1[6] = 0
						te_pacman_p1[3] = -te_pacman_speeds[1]
						te_pacman_p1[4] = 0
					end
					if te_pacman_p1[6] == 90 then
						te_pacman_p1[3] = 0
						te_pacman_p1[4] = -te_pacman_speeds[1]
					end
					if te_pacman_p1[6] == 180 then
						te_pacman_p1[3] = te_pacman_speeds[1]
						te_pacman_p1[4] = 0
					end
					if te_pacman_p1[6] == 270 then
						te_pacman_p1[3] = 0
						te_pacman_p1[4] = te_pacman_speeds[1]
					end					
					
					--important note: need the sticking into a tile
					local targeta = te_pacman_closesttile(te_pacman_p1[1],te_pacman_p1[2])
					te_pacman_p1[1] = te_pacman_gettileloc(te_pacman_fakemod(targeta,16))
					te_pacman_p1[2] = te_pacman_gettileloc(math.ceil(targeta/16))
				end
			end,
    StepP2MessageCommand= function(self)
				if te_pacman_active == 1 then
					te_pacman_p2[6] = te_pacman_p2[6] + 90
					if te_pacman_p2[6] == 360 then
						te_pacman_p2[6] = 0
						te_pacman_p2[3] = -te_pacman_speeds[2]
						te_pacman_p2[4] = 0
					end
					if te_pacman_p2[6] == 90 then
						te_pacman_p2[3] = 0
						te_pacman_p2[4] = -te_pacman_speeds[2]
					end
					if te_pacman_p2[6] == 180 then
						te_pacman_p2[3] = te_pacman_speeds[2]
						te_pacman_p2[4] = 0
					end
					if te_pacman_p2[6] == 270 then
						te_pacman_p2[3] = 0
						te_pacman_p2[4] = te_pacman_speeds[2]
					end					
					
					--important note: need the sticking into a tile
					local targetb = te_pacman_closesttile(te_pacman_p2[1],te_pacman_p2[2])
					te_pacman_p2[1] = te_pacman_gettileloc(te_pacman_fakemod(targetb,16))
					te_pacman_p2[2] = te_pacman_gettileloc(math.ceil(targetb/16))
				end
			end,
    aCommand= function(self)
			
				if GAMESTATE:GetSongBeat() >= te_pacman_start_measure and te_pacman_active == 0 then
					te_pacman_active = 1
					te_pacman_p1 = {te_pacman_gettileloc(7),te_pacman_gettileloc(10),-te_pacman_speeds[1],0,0,0,7,10} --x,y,dx,dy,powerup/dead, rot,tx,ty
					te_pacman_p2 = {te_pacman_gettileloc(10),te_pacman_gettileloc(10),te_pacman_speeds[2],0,0,180,10,10}
					
					for i=1,7 do
						te_pacman_spawnitem(-1,-1)
					end
					te_pacman_spawnitem(6,-1)
					
				end
				
				if GAMESTATE:GetSongBeat() >= te_pacman_end_measure and te_pacman_active == 1 then
					te_pacman_active = 2
				end				

				if te_pacman_active == 1 then
					--next step, motion and wall checking
					if te_pacman_p1[5] >= 0 then
						te_pacman_p1[1] = te_pacman_p1[1] + te_pacman_p1[3]
						te_pacman_p1[2] = te_pacman_p1[2] + te_pacman_p1[4]
					end	
					if te_pacman_p2[5] >= 0 then	
						te_pacman_p2[1] = te_pacman_p2[1] + te_pacman_p2[3]
						te_pacman_p2[2] = te_pacman_p2[2] + te_pacman_p2[4]	
					end
					--New process: set user tile to closest location
					--depending on direction,  go out to the next tile and check to see if it is a block, else bounce back to user's spot
					
					--P1
					local target = te_pacman_closesttile(te_pacman_p1[1],te_pacman_p1[2])
					
					te_pacman_p1[7] = te_pacman_fakemod(target,16)
					te_pacman_p1[8] = math.ceil(target/16)
					
					if te_pacman_p1[6] == 0 then
						if te_pacman_p1[1] < te_pacman_gettileloc(te_pacman_fakemod(target,16)) and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] == 1 then
							te_pacman_p1[1] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
						end
					end
					if te_pacman_p1[6] == 90 then
						if te_pacman_p1[2] < te_pacman_gettileloc(math.ceil(target/16)) and te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 then
							te_pacman_p1[2] = te_pacman_gettileloc(math.ceil(target/16)) 
						end
					end
					if te_pacman_p1[6] == 180 then
						if te_pacman_p1[1] > te_pacman_gettileloc(te_pacman_fakemod(target,16)) and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 then
							te_pacman_p1[1] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
						end
					end
					if te_pacman_p1[6] == 270 then
						if te_pacman_p1[2] > te_pacman_gettileloc(math.ceil(target/16)) and te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 then
							te_pacman_p1[2] = te_pacman_gettileloc(math.ceil(target/16)) 
						end
					end		

					--P2
					local target = te_pacman_closesttile(te_pacman_p2[1],te_pacman_p2[2])
					
					te_pacman_p2[8] = math.ceil(target/16)
					te_pacman_p2[7] = te_pacman_fakemod(target,16)					
					
					if te_pacman_p2[6] == 0 then
						if te_pacman_p2[1] < te_pacman_gettileloc(te_pacman_fakemod(target,16)) and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] == 1 then
							te_pacman_p2[1] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
						end
					end
					if te_pacman_p2[6] == 90 then
						if te_pacman_p2[2] < te_pacman_gettileloc(math.ceil(target/16)) and te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 then
							te_pacman_p2[2] = te_pacman_gettileloc(math.ceil(target/16)) 
						end
					end
					if te_pacman_p2[6] == 180 then
						if te_pacman_p2[1] > te_pacman_gettileloc(te_pacman_fakemod(target,16)) and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 then
							te_pacman_p2[1] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
						end
					end
					if te_pacman_p2[6] == 270 then
						if te_pacman_p2[2] > te_pacman_gettileloc(math.ceil(target/16)) and te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 then
							te_pacman_p2[2] = te_pacman_gettileloc(math.ceil(target/16)) 
						end
					end



					--ghosts
					for i=0,1 do
					
						local target = te_pacman_closesttile(te_pacman_ghosts[1+(5*i)],te_pacman_ghosts[2+(5*i)])
						te_pacman_recoil[i+1] = math.max(0,te_pacman_recoil[i+1]-1)
					
						te_pacman_ghosts[1+(5*i)] = te_pacman_ghosts[1+(5*i)] + te_pacman_ghosts[3+(5*i)]
						te_pacman_ghosts[2+(5*i)] = te_pacman_ghosts[2+(5*i)] + te_pacman_ghosts[4+(5*i)]
						local moved = false
						
							if moved == false and te_pacman_ghosts[5+(5*i)] == 0 then
								if te_pacman_ghosts[1+(5*i)] < te_pacman_gettileloc(te_pacman_fakemod(target,16)) and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] == 1 then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
								end
								if (te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 and te_pacman_ghosts[1+(5*i)] == te_pacman_gettileloc(te_pacman_fakemod(target,16))) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 90
									te_pacman_ghosts[3+(5*i)] = 0
									te_pacman_ghosts[4+(5*i)] = -1.33
									te_pacman_recoil[i+1] = 40
									moved = true
								end
								if moved == false and (te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] == 1 and te_pacman_ghosts[1+(5*i)] == te_pacman_gettileloc(te_pacman_fakemod(target,16))) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 270
									te_pacman_ghosts[3+(5*i)] = 0
									te_pacman_ghosts[4+(5*i)] = 1.33
									te_pacman_recoil[i+1] = 40
									moved = true
								end
							end
							if moved == false and te_pacman_ghosts[5+(5*i)] == 90 then
								if te_pacman_ghosts[2+(5*i)] < te_pacman_gettileloc(math.ceil(target/16)) and te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 then
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
								end
								if (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] == 1 and te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 and te_pacman_ghosts[2+(5*i)] == te_pacman_gettileloc(math.ceil(target/16))) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 0
									te_pacman_ghosts[3+(5*i)] = -1.33
									te_pacman_ghosts[4+(5*i)] = 0
									te_pacman_recoil[i+1] = 40
									moved = true
								end
								if moved == false and (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] == 1 and te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 and te_pacman_ghosts[2+(5*i)] == te_pacman_gettileloc(math.ceil(target/16))) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 180
									te_pacman_ghosts[3+(5*i)] = 1.33
									te_pacman_ghosts[4+(5*i)] = 0
									te_pacman_recoil[i+1] = 40
									moved = true
								end
							end
							if moved == false and te_pacman_ghosts[5+(5*i)] == 180 then
								if te_pacman_ghosts[1+(5*i)] > te_pacman_gettileloc(te_pacman_fakemod(target,16)) and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
								end
								if (te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 and te_pacman_ghosts[1+(5*i)] == te_pacman_gettileloc(te_pacman_fakemod(target,16)) ) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 90
									te_pacman_ghosts[3+(5*i)] = 0
									te_pacman_ghosts[4+(5*i)] = -1.33
									te_pacman_recoil[i+1] = 40
									moved = true
								end
								if moved == false and (te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 and te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 and te_pacman_ghosts[1+(5*i)] == te_pacman_gettileloc(te_pacman_fakemod(target,16)) ) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 270
									te_pacman_ghosts[3+(5*i)] = 0
									te_pacman_ghosts[4+(5*i)] = 1.33
									te_pacman_recoil[i+1] = 40
									moved = true
								end
							end
							if moved == false and te_pacman_ghosts[5+(5*i)] == 270 then
								if te_pacman_ghosts[2+(5*i)] > te_pacman_gettileloc(math.ceil(target/16)) and te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 then
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
								end
								if (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)-1] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 and te_pacman_maze[math.ceil(target/16)+1][te_pacman_fakemod(target,16)] == 1 and te_pacman_ghosts[2+(5*i)] == te_pacman_gettileloc(math.ceil(target/16))) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 0
									te_pacman_ghosts[3+(5*i)] = -1.33
									te_pacman_ghosts[4+(5*i)] = 0
									te_pacman_recoil[i+1] = 40
									moved = true
								end
								if moved == false and (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] ~= 1 and math.random(1,20) == 1 and te_pacman_recoil[i+1] == 0) or (te_pacman_maze[math.ceil(target/16)][te_pacman_fakemod(target,16)+1] == 1 and te_pacman_maze[math.ceil(target/16)-1][te_pacman_fakemod(target,16)] == 1 and te_pacman_ghosts[2+(5*i)] == te_pacman_gettileloc(math.ceil(target/16))) then
									te_pacman_ghosts[1+(5*i)] = te_pacman_gettileloc(te_pacman_fakemod(target,16)) 
									te_pacman_ghosts[2+(5*i)] = te_pacman_gettileloc(math.ceil(target/16)) 
									te_pacman_ghosts[5+(5*i)] = 180
									te_pacman_ghosts[3+(5*i)] = 1.33
									te_pacman_ghosts[4+(5*i)] = 0
									te_pacman_recoil[i+1] = 40
									moved = true
								end
							end

							--collisions with players
							if te_pacman_getdist(te_pacman_ghosts[1+(5*i)],te_pacman_ghosts[2+(5*i)],te_pacman_p1[1],te_pacman_p1[2]) < 10 then
								if te_pacman_vulnerable[i+1] == 1 then
									te_pacman_scores[1] = te_pacman_scores[1] + 100
									te_pacman_ghosts[1+(5*i)] = 300 + 40*i
									te_pacman_ghosts[2+(5*i)] = 220
									te_pacman_vulnerable[i+1] = 0
									SOUND:PlayOnce(path .. 'animations/pacman/sounds/ghost.ogg')
								elseif te_pacman_invincible[1] == 0 and te_pacman_p1[5] == 0 then
									te_pacman_scores[1] = math.floor(te_pacman_scores[1]/2)
									te_pacman_p1[5] = -90
									te_pacman_invincible[1] = 500
								SOUND:PlayOnce(path .. 'animations/pacman/sounds/dead.ogg')
								end
							end
							
							if te_pacman_getdist(te_pacman_ghosts[1+(5*i)],te_pacman_ghosts[2+(5*i)],te_pacman_p2[1],te_pacman_p2[2]) < 10 then
								if te_pacman_vulnerable[i+1] == 1 then
									te_pacman_scores[2] = te_pacman_scores[2] + 100
									te_pacman_ghosts[1+(5*i)] = 300 + 40*i
									te_pacman_ghosts[2+(5*i)] = 220
									te_pacman_vulnerable[i+1] = 0
									SOUND:PlayOnce(path .. 'animations/pacman/sounds/ghost.ogg')
								elseif te_pacman_invincible[2] == 0 and te_pacman_p2[5] == 0 then
									te_pacman_scores[2] = math.floor(te_pacman_scores[2]/2)
									te_pacman_p2[5] = -90
									te_pacman_invincible[2] = 500
									SOUND:PlayOnce(path .. 'animations/pacman/sounds/dead.ogg')
								end
							end
					
					end
					
					--collisions
					for i=1,8 do
						if te_pacman_getdist(te_pacman_items_x[i],te_pacman_items_y[i],te_pacman_p1[1],te_pacman_p1[2]) < 10 then
							te_pacman_maze[te_pacman_p1[8]][te_pacman_p1[7]] = 0
							SOUND:PlayOnce(path .. 'animations/pacman/sounds/eat.ogg')
							if te_pacman_items_type[i] < 5 then
								te_pacman_scores[1] = te_pacman_scores[1] + (10*(te_pacman_items_type[i]+1))
								te_pacman_resetitem(i)
								te_pacman_spawnitem(-1,-1)
							end
							if te_pacman_items_type[i] == 5 then
								te_pacman_speeds[1] = math.min(10,te_pacman_speeds[1] + 1)
								te_pacman_resetitem(i)
								te_pacman_spawnitem(-1,-1)
							end
							if te_pacman_items_type[i] == 6 then
								te_pacman_p1[5] = 420
								te_pacman_vulnerable = {1,1}
								te_pacman_resetitem(i)
								te_pacman_spawnitem(6,-1)
							end
						end
						if te_pacman_getdist(te_pacman_items_x[i],te_pacman_items_y[i],te_pacman_p2[1],te_pacman_p2[2]) < 10 then
							te_pacman_maze[te_pacman_p2[8]][te_pacman_p2[7]] = 0
							SOUND:PlayOnce(path .. 'animations/pacman/sounds/eat.ogg')
							if te_pacman_items_type[i] < 5 then
								te_pacman_scores[2] = te_pacman_scores[2] + (10*(te_pacman_items_type[i]+1))
								te_pacman_resetitem(i)
								te_pacman_spawnitem(-1,-1)
							end
							if te_pacman_items_type[i] == 5 then
								te_pacman_speeds[2] = math.min(10,te_pacman_speeds[2] + 1)
								te_pacman_resetitem(i)
								te_pacman_spawnitem(-1,-1)
							end
							if te_pacman_items_type[i] == 6 then
								te_pacman_p2[5] = 420
								te_pacman_vulnerable = {1,1}
								te_pacman_resetitem(i)
								te_pacman_spawnitem(6,-1)
							end
						end
					end
					
					if te_pacman_getdist(te_pacman_p2[1],te_pacman_p2[2],te_pacman_p1[1],te_pacman_p1[2]) < 10 then
						if te_pacman_p1[5] > 0 and te_pacman_p2[5] == 0 and te_pacman_invincible[2] == 0 then
							te_pacman_p2[5] = -90
							te_pacman_invincible[2] = 500
							SOUND:PlayOnce(path .. 'animations/pacman/sounds/dead.ogg')
							SOUND:PlayOnce(path .. 'animations/pacman/sounds/ghost.ogg')
							te_pacman_scores[1] = te_pacman_scores[1] + math.floor(te_pacman_scores[2]/3)
							te_pacman_scores[2] = te_pacman_scores[2] - math.floor(te_pacman_scores[2]/3)			
						end
						if te_pacman_p2[5] > 0 and te_pacman_p1[5] == 0 and te_pacman_invincible[1] == 0 then
							te_pacman_p1[5] = -90
							te_pacman_invincible[1] = 500
							SOUND:PlayOnce(path .. 'animations/pacman/sounds/dead.ogg')
							SOUND:PlayOnce(path .. 'animations/pacman/sounds/ghost.ogg')
							te_pacman_scores[2] = te_pacman_scores[2] + math.floor(te_pacman_scores[1]/3)
							te_pacman_scores[1] = te_pacman_scores[1] - math.floor(te_pacman_scores[1]/3)
						end
					end

					if te_pacman_invincible[1] > 0 then
						te_pacman_invincible[1] = math.max(0,te_pacman_invincible[1] - 1)
					end					
					if te_pacman_invincible[2] > 0 then
						te_pacman_invincible[2] = math.max(0,te_pacman_invincible[2] - 1)
					end
					
					if te_pacman_p1[5] > 0 then
						te_pacman_p1[5] = math.max(te_pacman_p1[5]-1,0)
						if te_pacman_p1[5] == 0 then
							te_pacman_vulnerable = {0,0}
						end
					else
						te_pacman_p1[5] = math.min(te_pacman_p1[5]+1,0)
						if te_pacman_p1[5] == -1 then
							te_pacman_p1[1] = te_pacman_gettileloc(7)
							te_pacman_p1[2] = te_pacman_gettileloc(10)
						end
					end
					if te_pacman_p2[5] > 0 then
						te_pacman_p2[5] = math.max(te_pacman_p2[5]-1,0)
						if te_pacman_p2[5] == 0 then
							te_pacman_vulnerable = {0,0}
						end
					else
						te_pacman_p2[5] = math.min(te_pacman_p2[5]+1,0)
						if te_pacman_p2[5] == -1 then
							te_pacman_p2[1] = te_pacman_gettileloc(10)
							te_pacman_p2[2] = te_pacman_gettileloc(10)
						end
					end
					
					te_pacman_bluetime = math.max(0,(math.max(te_pacman_p1[5],te_pacman_p2[5])))
					
				end
				
				self:sleep(1/60);
				self:queuecommand('a');			
			
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_rgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "black.png",
    aCommand= function(self)
				if te_pacman_active == 1 then
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_sgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "outside.png",
    aCommand= function(self)
				if te_pacman_active == 1 then
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_tgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[1] < 9999 then
					self:x(((te_pacman_items_x[1])))
					self:y(((te_pacman_items_y[1])))
					self:setstate(te_pacman_items_type[1])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_ugt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[2] < 9999 then
					self:x(((te_pacman_items_x[2])))
					self:y(((te_pacman_items_y[2])))
					self:setstate(te_pacman_items_type[2])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_vgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[3] < 9999 then
					self:x(((te_pacman_items_x[3])))
					self:y(((te_pacman_items_y[3])))
					self:setstate(te_pacman_items_type[3])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_wgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[4] < 9999 then
					self:x(((te_pacman_items_x[4])))
					self:y(((te_pacman_items_y[4])))
					self:setstate(te_pacman_items_type[4])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_xgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[5] < 9999 then
					self:x(((te_pacman_items_x[5])))
					self:y(((te_pacman_items_y[5])))
					self:setstate(te_pacman_items_type[5])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_ygt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[6] < 9999 then
					self:x(((te_pacman_items_x[6])))
					self:y(((te_pacman_items_y[6])))
					self:setstate(te_pacman_items_type[6])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_zgt",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[7] < 9999 then
					self:x(((te_pacman_items_x[7])))
					self:y(((te_pacman_items_y[7])))
					self:setstate(te_pacman_items_type[7])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_aht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "fruitsprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_items_x[8] < 9999 then
					self:x(((te_pacman_items_x[8])))
					self:y(((te_pacman_items_y[8])))
					self:setstate(te_pacman_items_type[8])
					self:diffusealpha(1)
					 self:hidden(0)
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_bht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "p1sprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_p1[5] <= 0 then
					
					self:hidden(0)
					self:x(te_pacman_p1[1])
					self:y(te_pacman_p1[2])
					self:rotationz(te_pacman_p1[6])
					
					if te_pacman_invincible[1] > 0 then
						self:diffusealpha(0.75)
					else
						self:diffusealpha(1)
					end
					
					if te_pacman_p1[5] > 0 then
						self:zoom(2)
					elseif te_pacman_p1[5] < 0 then 
						self:zoom(math.abs(te_pacman_p1[5]/90))
					else
						self:zoom(1)
					end
					
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_cht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "p2sprite",
    aCommand= function(self)
				if te_pacman_active == 1 then
					self:hidden(0)
					self:x(te_pacman_p2[1])
					self:y(te_pacman_p2[2])
					self:rotationz(te_pacman_p2[6])
					
					if te_pacman_invincible[2] > 0 then
						self:diffusealpha(0.75)
					else
						self:diffusealpha(1)
					end
					
					if te_pacman_p2[5] > 0 then
						self:zoom(2)
					elseif te_pacman_p2[5] < 0 then 
						self:zoom(math.abs(te_pacman_p2[5]/90))
					else
						self:zoom(1)
					end					
					
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_dht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "p1sprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_p1[5] > 0 then
					self:diffusealpha(1)
					self:hidden(0)
					self:x(te_pacman_p1[1])
					self:y(te_pacman_p1[2])
					self:rotationz(te_pacman_p1[6])
					
					if te_pacman_p1[5] > 0 then
						self:zoom(2)
					elseif te_pacman_p1[5] < 0 then 
						self:zoom(math.abs(te_pacman_p1[5]/90))
					else
						self:zoom(1)
					end
					
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.BitmapText{
      Name= "xtl_actor_eht",
    Command= cmd(x,SCREEN_CENTER_X + -240;y,SCREEN_CENTER_Y + -180;playcommand,"a"),
    Text= "0,",
    Texture= "_big blue glow",
    aCommand= function(self)
				
				if te_pacman_active == 1 then	
					self:diffusealpha(1);
					self:hidden(0)
					self:settext('P1: ' .. te_pacman_scores[1])
				else
					self:diffusealpha(0);	
					self:hidden(1)
				end					

				self:sleep(1/60);
				self:queuecommand('a');
				
			end,
    },
    Def.BitmapText{
      Name= "xtl_actor_fht",
    Command= cmd(x,SCREEN_CENTER_X + 240;y,SCREEN_CENTER_Y + -180;playcommand,"a"),
    Text= "0,",
    Texture= "_big blue glow",
    aCommand= function(self)
				
				if te_pacman_active == 1 then	
					self:diffusealpha(1);
					self:hidden(0)
					self:settext('P2: ' .. te_pacman_scores[2])
				else
					self:diffusealpha(0);	
					self:hidden(1)
				end					

				self:sleep(1/60);
				self:queuecommand('a');
				
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_ght",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "blinkysprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_ghosts[1] < 9999 and te_pacman_vulnerable[1] == 0 then
					self:x(te_pacman_ghosts[1])
					self:y(te_pacman_ghosts[2])
					self:diffusealpha(1)
					self:hidden(0)
					self:setstate(math.floor(te_pacman_ghosts[5]/90))
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_hht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "pinkysprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_ghosts[6] < 9999 and te_pacman_vulnerable[2] == 0 then
					self:x(te_pacman_ghosts[6])
					self:y(te_pacman_ghosts[7])
					self:diffusealpha(1)
					self:hidden(0)
					self:setstate(math.floor(te_pacman_ghosts[10]/90))
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_iht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "bluesprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_ghosts[1] < 9999 and te_pacman_vulnerable[1] == 1 then
					self:x(te_pacman_ghosts[1])
					self:y(te_pacman_ghosts[2])
					self:diffusealpha(1)
					self:hidden(0)
					
					if (te_pacman_bluetime > 0 and te_pacman_bluetime < 30) or (te_pacman_bluetime > 60 and te_pacman_bluetime < 90) or (te_pacman_bluetime > 120 and te_pacman_bluetime < 150) then
						self:setstate(1)
					else
						self:setstate(0)
					end
					
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
    Def.Sprite{
      Name= "xtl_actor_jht",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;playcommand,"a"),
    Texture= "bluesprite",
    aCommand= function(self)
				if te_pacman_active == 1 and te_pacman_ghosts[6] < 9999 and te_pacman_vulnerable[2] == 1 then
					self:x(te_pacman_ghosts[6])
					self:y(te_pacman_ghosts[7])
					self:diffusealpha(1)
					self:hidden(0)
					
					if (te_pacman_bluetime > 0 and te_pacman_bluetime < 30) or (te_pacman_bluetime > 60 and te_pacman_bluetime < 90) or (te_pacman_bluetime > 120 and te_pacman_bluetime < 150) then
						self:setstate(1)
					else
						self:setstate(0)
					end					
					
				else
					self:diffusealpha(0)
					 self:hidden(1)
				end
				self:sleep(1/60);
				self:queuecommand('a');						
			end,
    },
  },
}