local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_hit",
BeginCommand= function(self)
		self:queuecommand('Loop')
	end,
IncrementCommand= function(self)
		if moment < table.getn(dialog) then
			moment = moment + 1
		end
	end,
InitCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
LoopCommand= function(self)
		local beat = GAMESTATE:GetSongBeat()
		
		if beat > dialog[moment].Beat then
			-- update faces
			self:GetChild('Chino'):GetChild('Face'):playcommand('Update')
			self:GetChild('Mike'):GetChild('Face'):playcommand('Update')
			
			-- update speechbubble
			if dialog[moment].Text == '' then
				self:GetChild(dialog[moment].Talking):GetChild('SpeechBubble'):playcommand('Hide')
			else
				self:GetChild(dialog[moment].Talking):GetChild('SpeechBubble'):playcommand('Show')
			end
			
			-- update text
			self:GetChild(dialog[moment].Talking):GetChild('Text'):playcommand('Talk')
			
			self:playcommand('Increment')
		end
		
		if beat > 156 and not philActivated then
			self:GetChild('Phil'):queuecommand('TheresTheBoys')
			philActivated = true
		end
		
		if moment < table.getn(dialog) + 1 then
			self:sleep(1/10)
			self:queuecommand('Loop')
		end
	end,
OnCommand= function(self)
		path   = GAMESTATE:GetCurrentSong():GetSongDir()
		moment = 1
		philActivated = false
		dialog = {
			{
				Text = 'Why, what happened?',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 55	
			},
			{
				Text = 'Let\'s see..\nhow shall I put this...?',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAway.png',
				Beat = 57
			},
			{
				Text = '',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAway.png',
				Beat = 64
			},
			{
				Text = '',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAway.png',
				Beat = 64
			},
			{
				Text = 'Well, just put it!',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAway.png',
				Beat = 66
			},
			{
				Text = 'He took it out.',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 70
			},
			{
				Text = '',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 74
			},
			{
				Text = '',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 74
			},
			{
				Text = 'He what?',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 83
			},
			{
				Text = 'He took...',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 86
			},
			{
				Text = '',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 86
			},
			{
				Text = 'it out.',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 92
			},
			{
				Text = '...He took what out?',
				Talking = 'Mike',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 100
			},
			{
				Text = '',
				Talking = 'Chino',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 100
			},
			{
				Text = 'IT.',
				Talking = 'Chino',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 105
			},
			{
				Text = 'He took IT...',
				Talking = 'Mike',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 108
			},
			{
				Text = 'OUT?',
				Talking = 'Mike',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 110
			},
			{
				Text = 'Yes siree-bob!',
				Talking = 'Chino',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino3.png',
				Beat = 114
			},
			{
				Text = 'He couldn\'t!',
				Talking = 'Mike',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 119
			},
			{
				Text = 'He did!',
				Talking = 'Chino',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 121
			},
			{
				Text = 'Were you involved in\nsome sort of amourous...?',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino3.png',
				Beat = 123
			},
			{
				Text = 'Nooooooooooooo.',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 127
			},
			{
				Text = '',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 127
			},
			{
				Text = 'You mean he just...?',
				Talking = 'Mike',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 132
			},
			{
				Text = 'Yes!',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 134
			},
			{
				Text = 'Are you sure..?',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_EyebrowsLowered.png',
				Beat = 136
			},
			{
				Text = 'Oh, quite!',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino3.png',
				Beat = 139
			},
			{
				Text = '',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino3.png',
				Beat = 145
			},
			{
				Text = 'So you were talking...\nyou were having\npleasant conversation...\nand then all of a sudden...',
				Talking = 'Mike',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino3.png',
				Beat = 145
			},
			{
				Text = 'Yeah.',
				Talking = 'Chino',
				MikeFace = 'Mike2.png',
				ChinoFace = 'Chino2_LookingAt.png',
				Beat = 153
			},
			{
				Text = 'IT?',
				Talking = 'Mike',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 155
			},
			{
				Text = 'IT.',
				Talking = 'Chino',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 156
			},
			{
				Text = 'OUT?',
				Talking = 'Mike',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 157
			},
			{
				Text = 'OUT.',
				Talking = 'Chino',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 158
			},
			{
				Text = 'Well...\nI-I can\'t believe this!\nI know Phil...',
				Talking = 'Mike',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino3.png',
				Beat = 161
			},
			{
				Text = 'He-he\'s a good friend\nof mine! We play\nsoftball together!\nHow could this BE?',
				Talking = 'Mike',
				MikeFace = 'Mike2_EyebrowsRaised.png',
				ChinoFace = 'Chino3.png',
				Beat = 166
			},
			{
				Text = 'Oh, it be!',
				Talking = 'Chino',
				MikeFace = 'Mike3.png',
				ChinoFace = 'Chino3.png',
				Beat = 171
			}
		}
		self:queuecommand('Begin')
	end,
  Def.ActorFrame{
    Name= "Chino",
    Def.Sprite{
      Name= "Face",
    InitCommand= cmd(draworder,1;x,SCREEN_CENTER_X + -520;y,SCREEN_CENTER_Y + -140;sleep,66),
    Texture= "./imgs/Chino1.png",
    UpdateCommand= function(self)
				self:Load(path..'./imgs/'..dialog[moment].ChinoFace)
			end,
    },
    Def.ActorFrame{
      Name= "SpeechBubble",
    HideCommand= cmd(diffusealpha,0),
    InitCommand= cmd(draworder,2),
    ShowCommand= cmd(diffusealpha,1),
      Def.Quad{
        Name= "xtl_actor_iit",
      InitCommand= cmd(x,SCREEN_CENTER_X + -445;y,SCREEN_CENTER_Y + -320;zoomto,240,130;diffusealpha,0),
      },
      Def.Sprite{
        Name= "xtl_actor_jit",
      InitCommand= cmd(zoom,0.25;rotationy,180;x,SCREEN_CENTER_X + -420;y,SCREEN_CENTER_Y + -240;diffusealpha,0),
      Texture= "./imgs/tail.png",
      },
    },
    Def.BitmapText{
      Name= "Text",
    Font= "Common normal,",
    InitCommand= cmd(draworder,3;diffuse,color('#000000');x,SCREEN_CENTER_X + -445;y,SCREEN_CENTER_Y + -340;shadowlength,0),
    TalkCommand= function(self)
				self:settext(dialog[moment].Text)
			end,
    },
  },
  Def.ActorFrame{
    Name= "Mike",
    Def.Sprite{
      Name= "Face",
    InitCommand= cmd(draworder,1;x,SCREEN_CENTER_X + -120;y,SCREEN_CENTER_Y + -140;sleep,66),
    Texture= "./imgs/Mike1.png",
    UpdateCommand= function(self)
				self:Load(path..'./imgs/'..dialog[moment].MikeFace)
			end,
    },
    Def.ActorFrame{
      Name= "SpeechBubble",
    HideCommand= cmd(diffusealpha,0),
    InitCommand= cmd(draworder,2),
    ShowCommand= cmd(diffusealpha,1),
      Def.Quad{
        Name= "xtl_actor_kit",
      InitCommand= cmd(x,SCREEN_CENTER_X + -145;y,SCREEN_CENTER_Y + -390;zoomto,300,140;diffusealpha,0),
      },
      Def.Sprite{
        Name= "xtl_actor_lit",
      InitCommand= cmd(zoom,0.25;x,SCREEN_CENTER_X + -160;y,SCREEN_CENTER_Y + -288;diffusealpha,0),
      Texture= "./imgs/tail.png",
      },
    },
    Def.BitmapText{
      Name= "Text",
    Font= "Common normal,",
    InitCommand= cmd(draworder,3;diffuse,color('#000000');x,SCREEN_CENTER_X + -145;y,SCREEN_CENTER_Y + -410;shadowlength,0),
    TalkCommand= function(self)
				self:settext(dialog[moment].Text)
			end,
    },
  },
  Def.Sprite{
    Name= "Phil",
  InitCommand= cmd(),
  OnCommand= cmd(y,SCREEN_HEIGHT/2 + 133),
  Phil1Command= function(self)
			self:Load(path..'./imgs/phil4.png')
			self:sleep(0.3)
			self:queuecommand('Phil2')
		end,
  Phil2Command= function(self)
			self:Load(path..'./imgs/phil3.png')
			self:sleep(0.3)
			self:queuecommand('Phil3')
		end,
  Phil3Command= function(self)
			self:Load(path..'./imgs/phil1.png')
			self:sleep(0.3)
			self:queuecommand('Phil4')
		end,
  Phil4Command= function(self)
			self:Load(path..'./imgs/phil2.png')
			self:sleep(0.3)
			self:queuecommand('Phil5')
		end,
  Phil5Command= function(self)
			self:Load(path..'./imgs/phil1.png')
			self:sleep(0.3)
			self:queuecommand('Phil6')
		end,
  Phil6Command= function(self)
			self:Load(path..'./imgs/phil3.png')
			self:linear(3)
			self:y(SCREEN_HEIGHT/2+133)
		end,
  TheresTheBoysCommand= function(self)
			self:Load(path..'./imgs/phil3.png')
			self:linear(4)
			self:y(SCREEN_HEIGHT/2-100)
			self:queuecommand('Phil1')
		end,
  },
}