local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_bqk",
InitCommand= function(self)
	beat = 0;
	ball_roll_p1 = 0;
	ball_roll_p2 = 0;
	danceRight = 1;
	song_bpm = 90;
	gravity = 1;
	p1_jumping = 0;
	p1_falling = 0;
	p2_jumping = 0;
	p2_falling = 0;
	
	flashPoint = 0;
	
	jump_height = SCREEN_HEIGHT/5;
	p1_jump_ceiling = 0;
	p2_jump_ceiling = 0;
	p2_jump_available = 0;
	p1_jump_available = 0;
	flashPoint = 0;
	p1_X_inc = 1;
	p2_X_inc = 1;
	grass_x_locations = {}
	grass_y_locations = {}
	grass_existence = {}
	for i=0, 200 do
		grass_x_locations[i] = i*70;
		grass_y_locations[i] = SCREEN_CENTER_Y+35;
		grass_existence[i] = 1;
	end

	cloud_y_locations = {}
	cloud_x_locations = {}
	for i = 1, 200 do
		cloud_y_locations[i] = math.random(0, SCREEN_CENTER_Y)
		cloud_x_locations[i] = math.random(0, SCREEN_WIDTH)
	end
	
	tree_x_locations = {}
	tree_existence = {}
	for i = 1, 50 do
		tree_x_locations[i] = i*1000;
		tree_existence[i] = 1
	end
	
	
	p1_X = 100; 
	p2_X = 100;
	p2_Y = 100;
	p1_Y = 100; 
	if math.random(-100, 101) >= 0 then
		ballVelX = 1.5;
	else
		ballVelX = -1.5;
	end
	
	if math.random(-100, 101) >= 0 then
		ballVelY = 1.5;
	else
		ballVelY = -1.5;
	end
	oldBallVelY = -1;
	ballRot = 1;
	rotSpeed = 1;
	
	paddleRadius = 35;
	

	song_playing = 0

	global_timer = 0;
	
	if the_ending == 1 and the_end > 0 then
		the_end = 0
	end
	if the_end == nil then
		the_end =0
	end
	
	
	the_ending = 0
	
	p1ModAmount = 0;
	p2ModAmount = 0;
	
	end,
  Def.Quad{
    Name= "xtl_actor_cqk",
  ButtCommand= function(self)
	
		self:sleep(1);
		global_timer=global_timer+1;
		if global_timer < 144 and the_end == 0 then
			self:queuecommand('Butt');
		else
			self:queuecommand('Theend');
		end
		end,
  OnCommand= function(self)
	if the_end ==0 then
		self:queuecommand('Butt');
	end
	end,
  TheendCommand= function(self)
	
	if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) and the_end ==0 then
		
		huge_butts = GAMESTATE:GetCurrentSong():GetStepsByStepsType( STEPS_TYPE_DANCE_SINGLE )
		if p1_X > p2_X then
		GAMESTATE:SetCurrentSteps(PLAYER_1,huge_butts[3]);
		GAMESTATE:SetCurrentSteps(PLAYER_2,huge_butts[2]);
		elseif p2_X > p1_X then
		GAMESTATE:SetCurrentSteps(PLAYER_1,huge_butts[2]);
		GAMESTATE:SetCurrentSteps(PLAYER_2,huge_butts[3]);
		else
		GAMESTATE:SetCurrentSteps(PLAYER_1,huge_butts[4]);
		GAMESTATE:SetCurrentSteps(PLAYER_2,huge_butts[4]);
		end
		the_end = 1
		
		SCREENMAN:SetNewScreen('ScreenGameplay');
	else
	SCREENMAN:SetNewScreen(GetGameplayNextScreen())
	end
	end,
  },
  Def.Quad{
    Name= "xtl_actor_dqk",
  CountdownCommand= function(self)
	if the_end == 1 then
		the_ending = 1
		songname = GAMESTATE:GetCurrentSong():GetSongDir();
		if song_playing == 0 then
			SOUND:PlayOnce(songname..'/booties/music.ogg');
			song_playing = 1
		end
		countdown_timer = countdown_timer+1
		if countdown_timer >= 22 then
			the_end = 0;
			the_ending = 0;
			SCREENMAN:SetNewScreen(GetGameplayNextScreen())
		
		end
	end
	self:sleep(1);
	self:queuecommand('Countdown')

	end,
  OnCommand= function(self)
	countdown_timer = 0
	self:queuecommand('Countdown');
	end,
  },
  Def.Sprite{
    Name= "xtl_actor_eqk",
  InitCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,SCREEN_WIDTH),
  OnCommand= function(self)
if the_end == 1 then
	self:diffusealpha(0)
end
end,
  Texture= "sky.png",
  },
  Def.Sprite{
    Name= "xtl_actor_fqk",
  HotCommand= function(self) 	
		beat = GAMESTATE:GetSongBeat();
		if beat >= 76 and beat < 122 then
			song_bpm = 110
		elseif beat >= 122 then
			song_bpm = 90
		end
		if beat >= 56 then
			
			flashPoint = flashPoint + .1
			self:diffusealpha(flashPoint);
		end
		self:sleep(.066);
		self:queuecommand('Hot');
		end,
  InitCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,SCREEN_WIDTH;diffusealpha,0),
  OnCommand= function(self)
			self:queuecommand('Hot');
		end,
  Texture= "flashBack.png",
  },
  Def.Sprite{
    Name= "xtl_actor_gqk",
  BoomCommand= function(self)
		if red_fadeout <= 0 then
			self:sleep(.5)
			self:x(math.random(0, SCREEN_WIDTH))
			self:y(math.random(0, SCREEN_HEIGHT))
			red_fadeout = 1
		end
		if beat >= 76 then
			self:diffusealpha(red_fadeout/2)
			self:zoom(-(red_fadeout-2)*12*6)
			red_fadeout = red_fadeout-.02
		end
		self:sleep(.05);
		self:queuecommand('Boom')
		end,
  InitCommand= cmd(x,SCREEN_CENTER_X+100;y,SCREEN_CENTER_Y-100;diffusealpha,0),
  OnCommand= function(self)
		red_fadeout = 1;
			self:queuecommand('Boom');
		end,
  Texture= "red.png",
  },
  Def.Sprite{
    Name= "xtl_actor_hqk",
  BoomCommand= function(self)

		if beat >= 76 then
			if yellow_fadeout <= 0 then
				self:sleep(1)
				self:x(math.random(0, SCREEN_WIDTH))
				self:y(math.random(0, SCREEN_HEIGHT))
				yellow_fadeout = 1
			end
			self:diffusealpha(yellow_fadeout/2)
			self:zoom(-(yellow_fadeout-2)*12*6)
			yellow_fadeout = yellow_fadeout-.02
		end
		self:sleep(.066);
		self:queuecommand('Boom')
		end,
  InitCommand= cmd(x,SCREEN_CENTER_X-100;y,SCREEN_CENTER_Y+100;diffusealpha,0),
  OnCommand= function(self)
		yellow_fadeout = 1;
			self:queuecommand('Boom');
		end,
  Texture= "yellow.png",
  },
  Def.Sprite{
    Name= "xtl_actor_iqk",
  BoomCommand= function(self)
		if ball1_fadeout <= 0 then
			self:x(math.random(0, SCREEN_WIDTH))
			self:y(math.random(0, SCREEN_HEIGHT))
			ball1_fadeout = 1
		end
		if beat >= 96 then
			self:diffusealpha(ball1_fadeout)
			self:zoom(-(ball1_fadeout-1)*5)
			ball1_fadeout = ball1_fadeout-.01
		end
		self:sleep(.086);
		self:queuecommand('Boom')
		end,
  InitCommand= cmd(x,SCREEN_CENTER_X-100;y,SCREEN_CENTER_Y+100;diffusealpha,0),
  OnCommand= function(self)
		ball1_fadeout = 1;
			self:queuecommand('Boom');
		end,
  Texture= "ball1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_jqk",
  BoomCommand= function(self)
		if ball2_fadeout <= 0 then
			self:x(math.random(0, SCREEN_WIDTH))
			self:y(math.random(0, SCREEN_HEIGHT))
			ball2_fadeout = 1
		end
		if beat >= 96 then
			self:diffusealpha(ball2_fadeout)
			self:zoom(-(ball2_fadeout-1)*5)
			ball2_fadeout = ball2_fadeout-.01
		end
		self:sleep(.066);
		self:queuecommand('Boom')
		end,
  InitCommand= cmd(x,SCREEN_CENTER_X+100;y,SCREEN_CENTER_Y-100;diffusealpha,0),
  OnCommand= function(self)
		ball2_fadeout = 1;
			self:queuecommand('Boom');
		end,
  Texture= "ball2.png",
  },
  Def.Quad{
    Name= "xtl_actor_kqk",
  ;
	/>
= ,
  ;
	/>
		<Layer
		Type= Quad,
  <Layer
= ,
  OnCommand= cmd(diffusealpha,0;sleep,1000),
  StepP1MessageCommand= function(self)
			if p1_jump_available==1 then
				p1_jumping = 1;
				p1_jump_available = 0
				p1_jump_ceiling = p1_Y - jump_height;
			end
			end,
  StepP2MessageCommand= function(self)
			if p2_jump_available==1 then
				p2_jumping = 1;
				p2_jump_available = 0
				p2_jump_ceiling = p2_Y - jump_height;
			end
			end,
  },
  Def.Sprite{
    Name= "xtl_actor_lqk",
  InitCommand= cmd(x,grass_x_locations[1];y,grass_y_locations[1];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[1] = grass_x_locations[1]-1;
if grass_x_locations[1] <= -35 then
	grass_x_locations[1] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[1] = math.random(grass_y_locations[0]-30, grass_y_locations[0]+30);
	self:y(grass_y_locations[1])


	if grass_existence[0] == 0 then
	 grass_existence[1]=1;
	else
	grass_existence[1] = math.random(0, 3)
	end
	if grass_existence[1] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_mqk",
  InitCommand= cmd(x,grass_x_locations[2];y,grass_y_locations[2];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[2] = grass_x_locations[2]-1;
if grass_x_locations[2] <= -35 then
	grass_x_locations[2] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[2] = math.random(grass_y_locations[1]-30, grass_y_locations[1]+30);
	self:y(grass_y_locations[2])


	if grass_existence[1] == 0 then
	 grass_existence[2]=1;
	else
	grass_existence[2] = math.random(0, 3)
	end
	if grass_existence[2] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_nqk",
  InitCommand= cmd(x,grass_x_locations[3];y,grass_y_locations[3];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[3] = grass_x_locations[3]-1;
if grass_x_locations[3] <= -35 then
	grass_x_locations[3] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[3] = math.random(grass_y_locations[2]-30, grass_y_locations[2]+30);
	self:y(grass_y_locations[3])


	if grass_existence[2] == 0 then
	 grass_existence[3]=1;
	else
	grass_existence[3] = math.random(0, 3)
	end
	if grass_existence[3] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_oqk",
  InitCommand= cmd(x,grass_x_locations[4];y,grass_y_locations[4];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[4] = grass_x_locations[4]-1;
if grass_x_locations[4] <= -35 then
	grass_x_locations[4] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[4] = math.random(grass_y_locations[3]-30, grass_y_locations[3]+30);
	self:y(grass_y_locations[4])


	if grass_existence[3] == 0 then
	 grass_existence[4]=1;
	else
	grass_existence[4] = math.random(0, 3)
	end
	if grass_existence[4] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_pqk",
  InitCommand= cmd(x,grass_x_locations[5];y,grass_y_locations[5];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[5] = grass_x_locations[5]-1;
if grass_x_locations[5] <= -35 then
	grass_x_locations[5] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[5] = math.random(grass_y_locations[4]-30, grass_y_locations[4]+30);
	self:y(grass_y_locations[5])


	if grass_existence[4] == 0 then
	 grass_existence[5]=1;
	else
	grass_existence[5] = math.random(0, 3)
	end
	if grass_existence[5] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_qqk",
  InitCommand= cmd(x,grass_x_locations[6];y,grass_y_locations[6];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[6] = grass_x_locations[6]-1;
if grass_x_locations[6] <= -35 then
	grass_x_locations[6] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[6] = math.random(grass_y_locations[5]-30, grass_y_locations[5]+30);
	self:y(grass_y_locations[6])


	if grass_existence[5] == 0 then
	 grass_existence[6]=1;
	else
	grass_existence[6] = math.random(0, 3)
	end
	if grass_existence[6] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_rqk",
  InitCommand= cmd(x,grass_x_locations[7];y,grass_y_locations[7];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[7] = grass_x_locations[7]-1;
if grass_x_locations[7] <= -35 then
	grass_x_locations[7] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[7] = math.random(grass_y_locations[6]-30, grass_y_locations[6]+30);
	self:y(grass_y_locations[7])


	if grass_existence[6] == 0 then
	 grass_existence[7]=1;
	else
	grass_existence[7] = math.random(0, 3)
	end
	if grass_existence[7] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_sqk",
  InitCommand= cmd(x,grass_x_locations[8];y,grass_y_locations[8];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[8] = grass_x_locations[8]-1;
if grass_x_locations[8] <= -35 then
	grass_x_locations[8] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[8] = math.random(grass_y_locations[7]-30, grass_y_locations[7]+30);
	self:y(grass_y_locations[8])


	if grass_existence[7] == 0 then
	 grass_existence[8]=1;
	else
	grass_existence[8] = math.random(0, 3)
	end
	if grass_existence[8] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_tqk",
  InitCommand= cmd(x,grass_x_locations[9];y,grass_y_locations[9];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[9] = grass_x_locations[9]-1;
if grass_x_locations[9] <= -35 then
	grass_x_locations[9] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[9] = math.random(grass_y_locations[8]-30, grass_y_locations[8]+30);
	self:y(grass_y_locations[9])


	if grass_existence[8] == 0 then
	 grass_existence[9]=1;
	else
	grass_existence[9] = math.random(0, 3)
	end
	if grass_existence[9] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_uqk",
  InitCommand= cmd(x,grass_x_locations[10];y,grass_y_locations[10];zoom,1/2),
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	grass_x_locations[0]=grass_x_locations[11];
	grass_x_locations[10] = grass_x_locations[10]-1;
if grass_x_locations[10] <= -35 then
	grass_x_locations[10] = SCREEN_WIDTH+35;
	self:x(SCREEN_WIDTH+35);
	grass_y_locations[10] = math.random(grass_y_locations[9]-30, grass_y_locations[9]+30);
	self:y(grass_y_locations[10])


	if grass_existence[9] == 0 then
	 grass_existence[10]=1;
	else
	grass_existence[10] = math.random(0, 3)
	end
	if grass_existence[10] == 0 then
	self:diffusealpha(0)
	 else
	 self:diffusealpha(1)
	end
	end		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "carpet.png",
  },
  Def.Sprite{
    Name= "xtl_actor_vqk",
  BootyCommand= function(self)
		beat = GAMESTATE:GetSongBeat();
		
		
		ball_radius = 0;
		
		platform_x_radius = 60;
		
		platform_y_radius = 30;
		p2_X_inc = p2_X_inc + 1
		if p2_X_inc - math.floor(p2_X_inc/30)*30 == 0 then
			p2_X = p2_X + 1;
		end
		
		
	p2_falling = 1;
		for i=1, 11 do
			if grass_existence[i] > 0 then
				if (p2_X - ball_radius < grass_x_locations[i]+platform_x_radius and p2_X - ball_radius > grass_x_locations[i]-platform_x_radius) or (p2_X + ball_radius > grass_x_locations[i]+platform_x_radius and p2_X + ball_radius < grass_x_locations[i]+platform_x_radius) then
					if p2_Y + ball_radius <= grass_y_locations[i]-platform_y_radius+10 and p2_Y+ball_radius >= grass_y_locations[i]-platform_y_radius-2 then
						if p2_Y + ball_radius > grass_y_locations[i]-platform_y_radius then
							p2_Y = grass_y_locations[i]-platform_y_radius
						end
						p2_jump_available = 1;
						p2_falling = 0;
						

					end
				end
			end
		end

		
		if (p2_jumping == 1) then
			p2_Y = p2_Y-gravity*2;
		end
		
		if (p2_falling == 1) then
			p2_Y = p2_Y+gravity;
		end
		

		
		if p2_jumping == 1 and p2_Y <= p2_jump_ceiling then
			p2_jumping = 0;
			p2_jump_available = 0;
		end
			
		if(p2_Y > SCREEN_HEIGHT) then
			p2_X = p2_X - 100
			p2_Y = 0
			jump_available = 0;
			if p2_X < 35 
				then p2_X = 35
			end
		end
		
		if p2_X > SCREEN_WIDTH-35 then
			p2_X = SCREEN_WIDTH-35
		end
		self:x(p2_X);
		self:y(p2_Y);
		ball_roll_p2 = ball_roll_p2 + 2;
		self:rotationz(ball_roll_p2);

		self:sleep(90/song_bpm/360);
		self:queuecommand('Booty');
		end,
  InitCommand= cmd(x,p2_X;y,p2_Y;zoom,1/2),
  OnCommand= function(self)
			if the_end == 0 then 
			 self:queuecommand('Booty');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "ball2.png",
  },
  Def.Sprite{
    Name= "xtl_actor_wqk",
  BootyCommand= function(self)
		beat = GAMESTATE:GetSongBeat();
		
		
		ball_radius = 0;
		
		platform_x_radius = 60;
		
		platform_y_radius = 20;
		p1_X_inc = p1_X_inc + 1
		if p1_X_inc - math.floor(p1_X_inc/30)*30 == 0 then
			p1_X = p1_X + 1;
		end
		
		
	p1_falling = 1;
		for i=1, 11 do
			if grass_existence[i] > 0 then
				if (p1_X - ball_radius < grass_x_locations[i]+platform_x_radius and p1_X - ball_radius > grass_x_locations[i]-platform_x_radius) or (p1_X + ball_radius > grass_x_locations[i]+platform_x_radius and p1_X + ball_radius < grass_x_locations[i]+platform_x_radius) then
					if p1_Y + ball_radius <= grass_y_locations[i]-platform_y_radius+10 and p1_Y+ball_radius >= grass_y_locations[i]-platform_y_radius-2 then
						if p1_Y + ball_radius > grass_y_locations[i]-platform_y_radius then
							p1_Y = grass_y_locations[i]-platform_y_radius
						end
						p1_jump_available = 1;
						p1_falling = 0;
						

					end
				end
			end
		end

		
		if (p1_jumping == 1) then
			p1_Y = p1_Y-gravity*2;
		end
		
		if (p1_falling == 1) then
			p1_Y = p1_Y+gravity;
		end
		

		
		if p1_jumping == 1 and p1_Y <= p1_jump_ceiling then
			p1_jumping = 0;
			p1_jump_available = 0;
		end
			
		if(p1_Y > SCREEN_HEIGHT) then
			p1_X = p1_X - 100
			p1_Y = 0
			jump_available = 0;
			if p1_X < 35 
				then p1_X = 35
			end
		end
		
		if p1_X > SCREEN_WIDTH-35 then
			p1_X = SCREEN_WIDTH-35
		end
		self:x(p1_X);
		self:y(p1_Y);
		ball_roll_p1 = ball_roll_p1 + 2;
		self:rotationz(ball_roll_p1);

		self:sleep(90/song_bpm/360);
		self:queuecommand('Booty');
		end,
  InitCommand= cmd(x,p1_X;y,p1_Y;zoom,1/2),
  OnCommand= function(self)
			if the_end == 0 then
			 self:queuecommand('Booty');
			 else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "ball1.png",
  },
  Def.Sprite{
    Name= "xtl_actor_xqk",
  InitCOmmand= x,cloud_x_locations[1];y,cloud_y_locations[1];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[1] = cloud_x_locations[1]-(1 + math.random(-.5, .5));
if cloud_x_locations[1] <= -200 then
	cloud_x_locations[1] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[1] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[1]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_yqk",
  InitCOmmand= x,cloud_x_locations[2];y,cloud_y_locations[2];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[2] = cloud_x_locations[2]-(1 + math.random(-.5, .5));
if cloud_x_locations[2] <= -200 then
	cloud_x_locations[2] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[2] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[2]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_zqk",
  InitCOmmand= x,cloud_x_locations[3];y,cloud_y_locations[3];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[3] = cloud_x_locations[3]-(1 + math.random(-.5, .5));
if cloud_x_locations[3] <= -200 then
	cloud_x_locations[3] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[3] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[3]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ark",
  InitCOmmand= x,cloud_x_locations[4];y,cloud_y_locations[4];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[4] = cloud_x_locations[4]-(1 + math.random(-.5, .5));
if cloud_x_locations[4] <= -200 then
	cloud_x_locations[4] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[4] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[4]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_brk",
  InitCOmmand= x,cloud_x_locations[5];y,cloud_y_locations[5];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[5] = cloud_x_locations[5]-(1 + math.random(-.5, .5));
if cloud_x_locations[5] <= -200 then
	cloud_x_locations[5] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[5] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[5]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_crk",
  InitCOmmand= x,cloud_x_locations[6];y,cloud_y_locations[6];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[6] = cloud_x_locations[6]-(1 + math.random(-.5, .5));
if cloud_x_locations[6] <= -200 then
	cloud_x_locations[6] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[6] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[6]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_drk",
  InitCOmmand= x,cloud_x_locations[7];y,cloud_y_locations[7];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[7] = cloud_x_locations[7]-(1 + math.random(-.5, .5));
if cloud_x_locations[7] <= -200 then
	cloud_x_locations[7] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[7] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[7]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_erk",
  InitCOmmand= x,cloud_x_locations[8];y,cloud_y_locations[8];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[8] = cloud_x_locations[8]-(1 + math.random(-.5, .5));
if cloud_x_locations[8] <= -200 then
	cloud_x_locations[8] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[8] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[8]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_frk",
  InitCOmmand= x,cloud_x_locations[9];y,cloud_y_locations[9];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[9] = cloud_x_locations[9]-(1 + math.random(-.5, .5));
if cloud_x_locations[9] <= -200 then
	cloud_x_locations[9] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[9] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[9]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_grk",
  InitCOmmand= x,cloud_x_locations[10];y,cloud_y_locations[10];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[10] = cloud_x_locations[10]-(1 + math.random(-.5, .5));
if cloud_x_locations[10] <= -200 then
	cloud_x_locations[10] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[10] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[10]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_hrk",
  InitCOmmand= x,cloud_x_locations[11];y,cloud_y_locations[11];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[11] = cloud_x_locations[11]-(1 + math.random(-.5, .5));
if cloud_x_locations[11] <= -200 then
	cloud_x_locations[11] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[11] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[11]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_irk",
  InitCOmmand= x,cloud_x_locations[12];y,cloud_y_locations[12];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[12] = cloud_x_locations[12]-(1 + math.random(-.5, .5));
if cloud_x_locations[12] <= -200 then
	cloud_x_locations[12] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[12] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[12]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_jrk",
  InitCOmmand= x,cloud_x_locations[13];y,cloud_y_locations[13];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[13] = cloud_x_locations[13]-(1 + math.random(-.5, .5));
if cloud_x_locations[13] <= -200 then
	cloud_x_locations[13] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[13] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[13]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_krk",
  InitCOmmand= x,cloud_x_locations[14];y,cloud_y_locations[14];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[14] = cloud_x_locations[14]-(1 + math.random(-.5, .5));
if cloud_x_locations[14] <= -200 then
	cloud_x_locations[14] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[14] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[14]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_lrk",
  InitCOmmand= x,cloud_x_locations[15];y,cloud_y_locations[15];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[15] = cloud_x_locations[15]-(1 + math.random(-.5, .5));
if cloud_x_locations[15] <= -200 then
	cloud_x_locations[15] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[15] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[15]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_mrk",
  InitCOmmand= x,cloud_x_locations[16];y,cloud_y_locations[16];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[16] = cloud_x_locations[16]-(1 + math.random(-.5, .5));
if cloud_x_locations[16] <= -200 then
	cloud_x_locations[16] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[16] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[16]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_nrk",
  InitCOmmand= x,cloud_x_locations[17];y,cloud_y_locations[17];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[17] = cloud_x_locations[17]-(1 + math.random(-.5, .5));
if cloud_x_locations[17] <= -200 then
	cloud_x_locations[17] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[17] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[17]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_ork",
  InitCOmmand= x,cloud_x_locations[18];y,cloud_y_locations[18];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[18] = cloud_x_locations[18]-(1 + math.random(-.5, .5));
if cloud_x_locations[18] <= -200 then
	cloud_x_locations[18] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[18] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[18]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
  Def.Sprite{
    Name= "xtl_actor_prk",
  InitCOmmand= x,cloud_x_locations[19];y,cloud_y_locations[19];,
  MoveCommand= function(self)
		
		self:addx(-1);
		
		

	cloud_x_locations[19] = cloud_x_locations[19]-(1 + math.random(-.5, .5));
if cloud_x_locations[19] <= -200 then
	cloud_x_locations[19] = SCREEN_WIDTH;
	self:x(SCREEN_WIDTH+50)
	cloud_y_locations[19] = math.random(0, SCREEN_CENTER_Y-50);
	self:y(cloud_y_locations[19]);
	self:x(SCREEN_WIDTH+100);
	self:zoom(math.random(1,3));
end
		self:sleep(180/song_bpm/720);
		self:queuecommand('Move');
		end,
  OnCommand= function(self)
		if the_end == 0 then
			 self:queuecommand('Move');
			  else
			 self:diffusealpha(0)
			 end
			 end,
  Texture= "cloud.png",
  },
}