local xtl_cond_kbl_result= GAMESTATE:IsPlayerEnabled(PLAYER_1)

local xtl_cond_lbl_result= GAMESTATE:IsPlayerEnabled(PLAYER_2)

local function optional_actor(cond, actor)
	if cond then return actor end
	return Def.Actor{}
end

return Def.ActorFrame{
  Name= "xtl_actor_mbl",
EndSongCommand= function(self)
    MESSAGEMAN:Broadcast('StepP1');
    MESSAGEMAN:Broadcast('StepP2');
    self:sleep(4);
  end,
InitCommand= function(self)
    P1_CENTER = SCREEN_CENTER_X-160
    P2_CENTER = SCREEN_CENTER_X+160

    song_path = GAMESTATE:GetCurrentSong():GetSongDir();
    tempo = 195;
    song_duration = 130;
    aspect_scale = (SCREEN_WIDTH/SCREEN_HEIGHT)/(640/480);

    rate_mod = 1;
    beat_length = (60/(tempo * rate_mod));
    offset = 0
    tilt_angle = 8
    shift_amount = 10
  end,
OnCommand= function(self)
    self:queuecommand('Update');
  end,
UpdateCommand= function(self)
    -- Probably a little excessive but oh well
    self:SetDrawByZPosition(true);
    SCREENMAN:GetTopScreen():SetDrawByZPosition(true);
    SCREENMAN:GetTopScreen():GetChild('SongBackground'):z(-2000);
    SCREENMAN:GetTopScreen():GetChild('SongBackground'):diffuse(0,0,0,1); 
    SCREENMAN:GetTopScreen():GetChild('Underlay'):z(-2000);
    SCREENMAN:GetTopScreen():GetChild('Underlay'):diffuse(0,0,0,1); 
    SCREENMAN:GetTopScreen():GetChild('Overlay'):z(-2000);
    SCREENMAN:GetTopScreen():GetChild('Overlay'):diffuse(0,0,0,1); 

    -- Get the Music Rate and modify the beat length accordingly
    rate_mod = GetRateMod()
    beat_length = (60/(tempo * rate_mod));

    self:sleep(126);
    self:queuecommand('EndSong');
  end,
  optional_actor(xtl_cond_kbl_result,
  Def.ActorFrame{
    Name= "xtl_actor_nbl",
  InitCommand= cmd(queuecommand,"SetupPlayer"),
  SetupPlayerCommand= function(self)
      -- Get Player 1's Speed Mod
      local speed_mod = GetSpeedMod(1)
      p1_travel_time = (beat_length * 8)/(speed_mod);
      
      self:SetDrawByZPosition(true);

      local p1_playfield = SCREENMAN:GetTopScreen():GetChild('PlayerP1');

      if p1_playfield then
        GAMESTATE:ApplyGameCommand('mod, *10000 no mini', 1);

        p1_playfield:SetDrawByZPosition(true);
        p1_playfield:x(-10000);
        p1_playfield:y(360);
        p1_playfield:z(10);
        p1_playfield:visible(1);

        p1_playfield:GetChild('Judgment'):GetChild(''):Load(song_path .. 'animations/graphics/judgment 2x6.png')
        p1_playfield:GetChild('Judgment'):x(10000 + 160 + (SCREEN_CENTER_X-135-185));
        p1_playfield:GetChild('Combo'):visible(0);
      end

      local p1_life = SCREENMAN:GetTopScreen():GetChild('LifeP1');

      if p1_life then
          p1_life:zoomto(0.45, 114/p1_life:GetChild('Background'):GetWidth());
          p1_life:x(P1_CENTER + 80);
          p1_life:y(SCREEN_CENTER_Y-28);
          p1_life:z(1000);
          p1_life:rotationx(180);
          p1_life:rotationz(90);
          p1_life:diffusealpha(0);
      end

      if SCREENMAN:GetTopScreen():GetChild('ScoreP1') then
        SCREENMAN:GetTopScreen():GetChild('ScoreP1'):visible(0);
      end
    end,
    Def.ActorFrame{
      Name= "xtl_actor_obl",
    InitCommand= function(self)
          length = 40

          self:fov(90);
          self:x(P1_CENTER);
          self:y(160);
        end,
    P1LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*6.5/rate_mod;rotationz,-720+7;sleep,0;rotationz,7;linear,beat_length*1.5/rate_mod;rotationz,0),
    P1RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*6.5/rate_mod;rotationz,720-7;sleep,0;rotationz,-7;linear,beat_length*9.5/rate_mod;rotationz,0),
    P1SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P1SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    VanishX= P1_CENTER,
    VanishY= 150,
      Def.Sprite{
        Name= "xtl_actor_pbl",
      InitCommand= cmd(zoom,0.1;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;blend,"BlendMode_Add"),
      P1TurnOnMessageCommand= cmd(linear,beat_length/rate_mod;zoom,2.2;sleep,0;zoom,0.1),
      Texture= "graphics/warp_change.png",
      },
      Def.Sprite{
        Name= "xtl_actor_qbl",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 45;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) ); 
              self:croptop(0.01);         

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_top_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_rbl",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 90;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.05);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_mid_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_sbl",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 135;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.01);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_bot_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_tbl",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 225;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4);
            end,
      Texture= "graphics/tex_dome_no_bot.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ubl",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 270;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_mid.png",
      },
      Def.Sprite{
        Name= "xtl_actor_vbl",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 315;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_top.png",
      },
      Def.Sprite{
        Name= "xtl_actor_wbl",
      InitCommand= cmd(visible,1;zoom,0.38;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_xbl",
      InitCommand= cmd(visible,1;zoom,0.4;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ybl",
      InitCommand= cmd(visible,1;zoom,0.1;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_zbl",
      InitCommand= cmd(visible,1;zoom,0.2;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_acl",
      InitCommand= cmd(visible,1;zoom,0.38;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_bcl",
      InitCommand= cmd(visible,1;zoom,0.4;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ccl",
      InitCommand= cmd(visible,1;zoom,0.1;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_dcl",
      InitCommand= cmd(visible,1;zoom,0.2;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ecl",
      InitCommand= cmd(visible,1;zoom,1.2;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;z,-999;queuecommand,"Pulse"),
      P1TurnOffMessageCommand= cmd(visible,1),
      P1TurnOnMessageCommand= cmd(visible,0),
      PulseCommand= cmd(linear,beat_length/rate_mod;zoom,1.5;linear,beat_length/rate_mod;zoom,1.2;queuecommand,"Pulse"),
      Texture= "graphics/light_no.png",
      },
      Def.Sprite{
        Name= "xtl_actor_fcl",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 45;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) ); 
              self:croptop(0.01);         

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_top_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_gcl",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 90;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.05);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_mid_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_hcl",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 135;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.01);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_bot_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_icl",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 225;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4);
            end,
      Texture= "graphics/tex_dome_cl_bot.png",
      },
      Def.Sprite{
        Name= "xtl_actor_jcl",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 270;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_mid.png",
      },
      Def.Sprite{
        Name= "xtl_actor_kcl",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 315;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_top.png",
      },
      Def.Sprite{
        Name= "xtl_actor_lcl",
      InitCommand= cmd(visible,0;zoom,0.38;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_mcl",
      InitCommand= cmd(visible,0;zoom,0.4;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ncl",
      InitCommand= cmd(visible,0;zoom,0.1;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ocl",
      InitCommand= cmd(visible,0;zoom,0.2;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_pcl",
      InitCommand= cmd(visible,0;zoom,0.38;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_qcl",
      InitCommand= cmd(visible,0;zoom,0.4;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_rcl",
      InitCommand= cmd(visible,0;zoom,0.1;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_scl",
      InitCommand= cmd(visible,0;zoom,0.2;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_tcl",
      InitCommand= cmd(visible,0;zoom,1.2;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;z,-999;queuecommand,"Pulse"),
      P1TurnOffMessageCommand= cmd(visible,0),
      P1TurnOnMessageCommand= cmd(visible,1),
      PulseCommand= cmd(linear,beat_length/rate_mod;zoom,1.5;linear,beat_length/rate_mod;zoom,1.2;queuecommand,"Pulse"),
      Texture= "graphics/light_cl.png",
      },
    },
    Def.ActorFrame{
      Name= "xtl_actor_ucl",
    InitCommand= cmd(fov,90;x,P1_CENTER;y,SCREEN_CENTER_Y + -80),
    P1LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*4/rate_mod;rotationz,-375;sleep,0;rotationz,-15;
                                linear,beat_length*2.5/rate_mod;rotationz,7/rate_mod;linear,beat_length*1.5/rate_mod;rotationz,0),
    P1RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*4/rate_mod;rotationz,375;sleep,0;rotationz,15;
                                linear,beat_length*2.5/rate_mod;rotationz,-7;linear,beat_length*9.5/rate_mod;rotationz,0),
    P1SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P1SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    VanishX= P1_CENTER,
    VanishY= 150,
      Def.Sprite{
        Name= "xtl_actor_vcl",
      InitCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + 260;z,-999;zoom,4.1),
      Texture= "graphics/playfield.png",
      },
      Def.Sprite{
        Name= "xtl_actor_wcl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(14.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(19.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(19.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(24.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_adl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(28.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(29.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(33.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(34.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_edl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(36.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(58.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(60.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(60.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_idl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(67.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(68.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(68.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(72.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.461538 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.461538 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(73.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(80.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_odl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(86.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(88.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(108.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(110.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(110.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_udl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(121.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(19.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(24.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(26.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(29.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(29.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ael",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(33.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(33.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_del",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 4.923077 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 4.923077 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(87.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 1.230769 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 1.230769 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(89.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(96.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(102.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(108.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(109.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(111.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(16.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(17.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(18.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(20.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(23.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(25.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(28.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zel",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_afl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(30.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(33.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_efl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(35.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(36.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(38.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(39.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(40.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(41.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(43.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(44.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(45.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(48.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(49.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(50.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(51.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(52.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(57.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(60.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(61.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_agl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(62.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(65.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_egl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(67.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(70.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_igl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(77.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(78.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(80.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(82.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(83.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(84.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(86.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(87.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(88.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(89.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(91.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(92.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(93.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(94.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(96.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_chl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(97.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(98.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(99.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(102.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(104.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(105.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_khl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(107.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(108.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(109.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(110.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_phl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(114.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(115.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_shl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_thl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(119.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(120.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_whl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(121.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ail",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(15.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(16.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(16.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(17.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ril",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(17.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_til",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(18.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xil",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yil",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zil",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(20.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_djl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(21.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(21.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(25.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_njl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_akl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ckl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dkl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ekl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fkl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gkl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ikl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jkl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lkl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mkl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_okl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pkl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rkl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_skl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ukl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vkl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(32.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xkl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(36.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ykl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(36.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zkl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(36.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_all",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cll",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(37.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ell",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fll",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ill",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lll",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oll",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rll",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ull",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xll",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yll",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zll",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(42.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(42.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xml",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yml",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zml",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_anl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bnl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cnl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dnl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_enl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fnl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gnl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hnl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_inl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jnl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_knl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lnl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mnl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nnl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_onl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pnl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qnl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rnl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_snl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tnl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_unl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vnl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wnl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xnl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ynl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_znl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_col",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fol",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iol",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lol",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ool",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rol",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uol",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xol",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yol",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zol",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_apl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(51.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(51.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_epl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(52.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(53.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_npl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_opl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_spl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_upl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(60.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(61.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xql",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yql",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zql",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_arl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_brl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_crl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_drl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_erl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_frl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(64.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_grl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hrl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_irl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(64.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jrl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_krl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lrl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(66.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mrl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nrl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_orl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(67.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_prl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qrl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rrl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(68.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_srl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_trl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_url",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(69.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vrl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wrl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xrl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(70.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yrl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zrl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_asl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_csl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dsl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_esl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fsl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gsl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_isl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jsl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ksl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lsl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_msl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(74.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_osl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_psl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rsl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ssl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_usl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vsl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xsl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ysl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zsl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_atl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_btl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ctl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dtl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_etl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ftl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gtl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_htl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_itl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jtl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ktl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ltl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mtl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ntl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_otl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ptl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qtl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rtl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_stl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ttl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_utl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vtl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wtl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xtl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ytl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ztl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ful",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(87.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(88.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(90.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(90.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xul",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yul",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zul",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_avl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cvl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_evl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fvl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ivl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lvl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ovl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rvl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_svl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uvl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xvl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yvl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(95.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zvl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_awl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dwl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ewl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gwl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jwl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mwl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_owl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pwl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_swl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_twl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vwl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xwl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ywl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zwl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_axl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_exl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ixl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_txl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xxl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yxl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zxl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ayl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_byl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dyl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(108.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gyl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jyl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_myl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pyl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ryl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_syl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(116.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vyl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(116.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xyl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yyl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zyl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_azl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_czl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ezl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fzl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_izl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lzl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(121.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_szl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(121.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(121.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzl",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzl",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzl",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(123.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ham",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(14.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(14.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(14.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ram",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xam",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yam",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zam",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_abm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(17.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(19.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_obm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(21.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_acm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(22.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ccm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dcm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ecm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(23.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fcm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gcm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_icm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jcm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lcm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mcm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ncm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ocm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pcm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(26.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rcm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_scm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ucm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vcm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(28.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_adm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_edm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_idm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_odm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(33.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(33.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_udm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(33.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(33.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(33.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(33.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(33.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(33.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(33.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(34.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(34.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(34.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(34.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(34.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(34.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xem",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yem",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zem",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_afm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_efm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_agm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_egm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(43.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_igm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(43.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_chm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(47.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(48.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(49.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_khm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(51.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_phm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_shm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_thm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_whm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_him",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(57.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(58.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xim",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yim",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zim",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_djm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(61.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_njm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(64.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_akm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(64.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ckm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dkm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ekm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fkm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gkm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ikm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jkm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lkm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mkm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_okm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pkm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rkm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_skm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ukm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vkm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xkm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ykm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zkm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_alm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_blm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_clm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dlm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_elm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_flm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_glm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hlm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(73.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ilm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jlm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_klm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_llm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mlm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nlm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_olm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_plm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qlm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rlm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_slm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tlm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ulm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vlm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wlm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xlm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ylm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zlm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_amm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cmm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dmm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_emm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fmm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gmm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_imm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jmm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lmm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mmm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_omm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pmm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rmm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_smm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_umm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vmm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xmm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ymm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zmm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_anm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bnm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cnm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dnm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_enm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fnm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gnm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hnm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_inm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jnm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_knm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lnm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mnm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nnm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_onm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pnm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qnm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rnm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_snm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tnm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_unm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vnm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wnm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xnm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ynm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_znm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_com",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_som",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xom",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yom",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zom",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_apm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_epm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(94.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_npm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_opm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_spm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_upm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(98.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_arm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_brm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_crm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_drm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_erm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_frm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_grm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hrm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_irm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jrm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_krm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lrm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mrm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nrm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_orm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_prm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qrm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rrm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_srm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_trm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_urm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vrm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wrm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xrm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yrm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zrm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(108.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_asm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(109.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(109.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_csm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(109.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dsm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(110.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_esm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(110.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fsm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(110.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gsm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(110.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(110.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ism",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(110.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jsm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(110.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ksm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(110.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lsm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(110.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_msm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_osm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_psm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(112.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(112.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rsm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(112.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ssm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_usm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vsm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xsm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ysm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zsm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_atm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_btm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ctm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dtm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_etm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ftm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gtm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_htm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_itm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jtm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ktm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ltm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mtm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ntm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_otm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ptm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qtm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rtm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_stm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ttm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_utm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vtm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wtm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xtm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ytm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ztm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ium",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_num",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(119.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(121.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(121.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(121.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(121.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xum",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yum",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zum",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_avm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cvm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_evm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fvm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ivm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lvm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ovm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rvm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_svm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uvm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xvm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yvm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zvm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_awm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dwm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ewm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gwm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jwm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mwm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(17.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_owm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pwm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(17.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_swm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_twm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vwm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(19.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xwm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ywm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zwm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_axm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_exm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(21.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(21.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ixm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(22.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(23.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_txm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(23.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xxm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yxm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zxm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(26.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(26.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(28.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(28.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xym",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yym",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zym",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_azm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_czm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ezm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fzm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_izm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(31.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lzm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_szm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzm",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzm",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzm",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aan",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ban",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_can",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dan",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ean",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fan",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gan",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_han",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ian",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jan",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kan",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lan",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_man",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nan",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oan",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pan",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qan",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ran",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_san",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tan",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uan",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_van",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wan",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xan",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yan",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zan",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_abn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_obn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_acn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ccn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dcn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(47.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ecn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fcn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gcn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(47.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_icn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jcn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(48.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lcn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mcn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(49.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ncn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ocn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pcn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(50.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rcn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_scn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(50.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ucn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vcn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(51.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_adn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_edn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_idn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(57.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_odn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_udn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aen",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ben",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cen",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_den",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_een",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fen",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(61.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gen",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hen",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ien",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(61.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jen",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ken",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_len",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_men",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nen",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oen",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pen",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qen",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ren",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(63.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sen",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ten",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uen",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ven",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wen",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xen",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(64.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yen",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zen",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_afn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(65.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(65.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_efn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(66.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(68.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(68.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_agn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_egn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ign",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_chn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(73.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_khn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(73.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_phn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_shn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_thn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(75.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(75.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_whn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(75.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(75.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ain",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_din",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ein",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gin",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jin",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_min",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pin",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sin",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vin",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_win",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xin",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yin",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zin",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_djn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_njn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_akn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ckn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dkn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ekn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fkn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gkn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ikn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jkn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lkn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mkn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_okn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pkn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rkn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_skn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ukn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vkn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xkn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ykn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zkn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(94.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(94.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(95.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xln",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yln",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(95.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zln",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_amn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cmn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dmn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_emn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fmn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gmn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_imn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jmn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lmn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mmn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_omn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pmn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rmn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_smn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_umn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vmn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xmn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ymn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zmn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ann",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bnn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cnn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dnn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_enn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fnn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gnn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hnn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_inn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jnn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_knn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lnn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mnn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nnn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_onn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pnn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qnn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rnn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_snn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tnn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_unn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vnn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wnn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xnn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ynn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_znn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aon",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bon",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_con",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_don",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eon",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fon",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gon",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(108.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hon",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(109.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ion",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(109.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jon",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(109.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kon",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(109.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lon",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(109.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mon",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(109.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_non",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oon",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pon",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qon",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ron",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_son",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ton",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uon",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_von",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_won",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xon",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yon",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zon",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_apn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(112.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_epn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_npn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_opn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_spn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_upn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(120.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_arn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_brn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_crn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_drn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ern",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_frn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_grn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hrn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_irn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jrn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_krn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lrn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mrn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nrn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_orn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_prn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qrn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rrn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_srn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_trn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_urn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vrn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wrn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xrn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yrn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zrn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_asn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_csn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dsn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_esn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(15.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fsn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gsn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(16.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_isn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jsn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ksn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(17.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lsn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_msn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(18.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_osn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_psn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(18.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rsn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ssn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_usn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vsn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(20.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xsn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ysn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zsn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(21.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_atn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_btn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ctn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(22.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dtn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_etn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ftn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(23.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gtn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_htn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_itn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jtn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ktn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ltn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(25.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mtn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ntn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_otn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ptn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qtn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rtn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_stn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ttn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_utn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vtn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wtn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xtn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(27.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ytn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ztn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_run",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xun",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yun",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zun",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_avn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(34.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cvn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_evn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(37.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fvn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(37.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ivn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lvn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ovn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rvn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_svn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uvn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xvn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yvn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zvn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_awn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dwn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ewn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gwn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jwn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mwn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_own",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(42.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pwn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_swn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_twn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vwn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xwn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ywn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zwn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_axn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_exn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ixn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_txn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xxn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yxn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zxn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ayn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_byn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dyn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gyn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jyn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_myn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pyn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ryn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_syn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vyn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xyn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yyn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zyn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_azn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_czn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ezn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fzn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(51.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_izn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(53.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lzn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_szn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzn",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzn",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzn",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(61.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(61.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xao",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yao",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zao",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_abo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(65.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(65.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_obo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(71.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(73.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(73.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(74.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(75.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(75.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ico",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(75.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xco",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yco",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zco",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ado",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_edo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ido",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_odo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(86.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_udo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(86.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(86.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aeo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_beo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(88.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ceo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_deo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eeo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(89.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_feo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_geo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_heo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ieo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jeo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_keo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_leo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_meo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_neo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oeo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_peo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qeo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_reo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_seo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_teo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ueo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_veo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_weo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xeo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yeo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zeo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_afo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_efo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ago",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ego",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_igo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(108.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(111.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(112.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(112.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(112.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_who",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xho",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yho",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zho",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(113.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(113.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xio",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yio",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zio",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(116.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_djo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_njo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(120.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjo",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjo",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ako",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bko",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dko",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eko",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(53.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(54.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(66.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(93.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(96.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(97.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(98.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(99.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zko",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_alo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(113.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_blo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(117.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_clo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_elo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(120.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_flo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(123.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_glo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(124.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(12.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ilo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(46.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_klo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(48.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_llo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(51.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(52.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(54.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_olo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(54.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_plo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_slo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(92.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(94.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ulo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(96.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ylo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(99.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zlo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_amo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bmo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cmo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(118.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dmo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_emo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fmo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gmo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(124.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_imo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(46.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(48.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(49.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(51.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(52.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(52.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_omo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(54.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(54.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(55.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(66.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_smo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1RotateCW');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_umo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(92.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(94.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(96.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ymo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(96.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zmo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ano",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(98.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(99.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(100.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ino",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(118.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(120.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ono",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(124.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(48.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(52.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(54.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(65.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(92.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(94.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(96.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zno",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_boo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(100.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_coo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(112.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_doo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_foo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_goo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ioo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_joo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(123.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_koo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(124.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_loo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(46.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_moo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(47.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_noo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(50.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ooo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(54.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_poo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_roo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_soo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(76.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_too",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(93.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_voo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_woo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zoo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_apo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(118.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(123.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(124.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_epo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(53.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(54.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(66.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_npo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_opo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(76.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(93.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_spo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(96.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(97.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_upo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(98.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(99.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1RotateCCW');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(113.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(117.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(120.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(123.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqo",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P1SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p1_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(124.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(46.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(48.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(49.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(51.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(52.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(52.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(54.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(54.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(55.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(66.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(92.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(94.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(96.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(96.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(98.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(99.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(100.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ero",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(118.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(120.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(124.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(48.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(52.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(54.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(65.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(92.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(94.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(96.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zro",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(100.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(112.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(123.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(124.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(46.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(47.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(50.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(54.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(76.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(93.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(118.769231/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zso",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ato",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(123.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(124.615385/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(53.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(54.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ito",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(66.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(76.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(93.230769/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(96.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(97.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(98.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(99.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(113.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(117.692308/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zto",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_auo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_buo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(120.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cuo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(123.538462/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_duo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p1_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(124.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_euo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P1RightHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fuo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P1LeftHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(12.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_guo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 1.846154 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P1LeftHold6');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 1.846154 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_huo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 4.923077 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 4.923077 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iuo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P1RightHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_juo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 1.230769 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P1RightHold4');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 1.230769 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kuo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P1RightHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_luo",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p1_travel_time);
              self:addz(hold_height);
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p1_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p1_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p1_travel_time + offset);queuecommand,"Move"),
      },
    },
    Def.ActorFrame{
      Name= "xtl_actor_muo",
    InitCommand= cmd(fov,90;x,P1_CENTER;y,SCREEN_CENTER_Y + 70),
    P1LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,-15;accelerate,beat_length*3.75/rate_mod;rotationz,7;
                                linear,beat_length*1.5/rate_mod;rotationz,0),
    P1RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,15;accelerate,beat_length*3.75/rate_mod;rotationz,-7;
                                linear,beat_length*9.5/rate_mod;rotationz,0),
    P1SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P1SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
      Def.Sprite{
        Name= "xtl_actor_nuo",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;zoom,0;x,SCREEN_CENTER_X + -434;y,SCREEN_CENTER_Y + -203;linear,beat_length*10/rate_mod;zoom,1),
      Texture= "graphics/line_bg.png",
      WaitCommand= cmd(visible,0;cropleft,0.5;sleep,beat_length*16/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_ouo",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;zoom,0;x,SCREEN_CENTER_X + -206;y,SCREEN_CENTER_Y + -203;linear,beat_length*10/rate_mod;zoom,1),
      Texture= "graphics/line_bg.png",
      WaitCommand= cmd(visible,0;cropright,0.5;sleep,beat_length*16/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_puo",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;sleep,0;zoom,0.5;x,SCREEN_CENTER_X + -478;y,SCREEN_CENTER_Y + -203;texcoordvelocity,beat_length*rate_mod,0),
      Texture= "graphics/line_words",
      WaitCommand= cmd(visible,0;cropleft,0.5;sleep,beat_length*26/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_quo",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;sleep,0;zoom,0.5;x,SCREEN_CENTER_X + -162;y,SCREEN_CENTER_Y + -203;texcoordvelocity,-beat_length*rate_mod,0),
      Texture= "graphics/line_words",
      WaitCommand= cmd(visible,0;cropright,0.5;sleep,beat_length*26/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_ruo",
      InitCommand= cmd(zoom,0.36;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -205),
      Texture= "graphics/line.png",
      },
      Def.Sprite{
        Name= "xtl_actor_suo",
      InitCommand= cmd(zoom,0.32;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -162),
      P1LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;x,-shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P1LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;x,-shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P1LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;x,-shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P1RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;x,shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P1RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;x,shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P1RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;x,shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P1SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;x,-shift_amount;linear,beat_length/rate_mod;x,SCREEN_CENTER_X + -320),
      P1SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;x,shift_amount;linear,beat_length/rate_mod;x,SCREEN_CENTER_X + -320),
      Texture= "graphics/io_front.png",
      },
      Def.Sprite{
        Name= "xtl_actor_tuo",
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -140;cropleft,0.1;cropright,0.1),
      Texture= "graphics/io_main.png",
      },
    },
    Def.Sprite{
      Name= "xtl_actor_uuo",
    InitCommand= cmd(zoom,0.38;x,P1_CENTER;y,SCREEN_CENTER_Y + -130),
    Texture= "graphics/angle_01.png",
    },
    Def.Sprite{
      Name= "xtl_actor_vuo",
    InitCommand= cmd(zoom,0.38;x,P1_CENTER;y,SCREEN_CENTER_Y + -120),
    P1LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P1RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,-15;accelerate,beat_length*3.75/rate_mod;rotationz,7;
                                linear,beat_length*1.5/rate_mod;rotationz,0),
    P1RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,15;accelerate,beat_length*3.75/rate_mod;rotationz,-7;
                                linear,beat_length*9.5/rate_mod;rotationz,0),
    P1SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P1SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    Texture= "graphics/angle_02.png",
    },
    Def.ActorFrame{
      Name= "xtl_actor_wuo",
    InitCommand= function(self)
          p1_cur_score = 0;
          p1_prev_score = 0;

          p1_cur_combo = 0;
          p1_max_combo = 0;

          p1_is_on = false;
        end,
      Def.Quad{
        Name= "xtl_actor_xuo",
      OnCommand= cmd(queuecommand,"UpdateCombo"),
      UpdateComboCommand= function(self)

              if SCREENMAN:GetTopScreen():GetChild('ScoreP1'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP1') then
                p1_cur_score = tonumber( string.sub( SCREENMAN:GetTopScreen():GetChild('ScoreP1'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP1'):GetText(), 1, -2 )*100 );
              end

              -- Fantastics, Excellents, and Greats add to combo
              -- Decents do nothing (because they don't change score)
              -- Way Offs and Misses reset combo
              if (p1_cur_score - p1_prev_score) > 0 then
                p1_cur_combo = p1_cur_combo + 1;
                
                if p1_cur_combo > p1_max_combo then
                  p1_max_combo = p1_cur_combo;
                  MESSAGEMAN:Broadcast('P1UpdateMaxCombo');
                end

                MESSAGEMAN:Broadcast('P1UpdateCurCombo');

              elseif (p1_cur_score - p1_prev_score) < 0 then
                p1_cur_combo = 0;

                MESSAGEMAN:Broadcast('P1BrokeCombo');
                MESSAGEMAN:Broadcast('P1UpdateCurCombo');
              end

              p1_prev_score = p1_cur_score;

              if not p1_is_on then
                if p1_cur_combo >= 50 then
                  p1_is_on = true;
                  MESSAGEMAN:Broadcast('P1TurnOn');
                end
              end

              if p1_is_on then
                if p1_cur_combo < 50 then
                  p1_is_on = false;
                  MESSAGEMAN:Broadcast('P1TurnOff');
                end
              end

              self:sleep(0.05);
              self:queuecommand('UpdateCombo');            
            end,
      },
      Def.Sprite{
        Name= "xtl_actor_yuo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER-56;y,SCREEN_CENTER_Y-122),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_tempo = string.format('%03d', math.floor(tempo * rate_mod + 0.5));
              local digit = string.sub(str_tempo, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_zuo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER-51;y,SCREEN_CENTER_Y-122),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_tempo = string.format('%03d', math.floor(tempo * rate_mod + 0.5));
              local digit = string.sub(str_tempo, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_avo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER-46;y,SCREEN_CENTER_Y-122),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_tempo = string.format('%03d', math.floor(tempo * rate_mod + 0.5));
              local digit = string.sub(str_tempo, 3, 3);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_bvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.39;x,P1_CENTER-54;y,SCREEN_CENTER_Y-114),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_speed_mod = string.format('%02d', math.floor(GetSpeedMod(1) * 10 + 0.5));
              local digit = string.sub(str_speed_mod, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_cvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.39;x,P1_CENTER-45;y,SCREEN_CENTER_Y-114),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_speed_mod = string.format('%02d', math.floor(GetSpeedMod(1) * 10 + 0.5));
              local digit = string.sub(str_speed_mod, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_dvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P1_CENTER+47;y,SCREEN_CENTER_Y-113),
      P1UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p1_max_combo);
              local digit = string.sub(str_max_combo, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_evo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P1_CENTER+54;y,SCREEN_CENTER_Y-113),
      P1UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p1_max_combo);
              local digit = string.sub(str_max_combo, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_fvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P1_CENTER+61;y,SCREEN_CENTER_Y-113),
      P1UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p1_max_combo);
              local digit = string.sub(str_max_combo, 3, 3);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_gvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P1_CENTER+68;y,SCREEN_CENTER_Y-113),
      P1UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p1_max_combo);
              local digit = string.sub(str_max_combo, 4, 4);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_hvo",
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;zoom,0.38;x,P1_CENTER;y,SCREEN_CENTER_Y+30),
      P1BrokeComboMessageCommand= cmd(diffusecolor,1,1,1,1),
      Texture= "graphics/chain.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ivo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P1_CENTER-30;y,SCREEN_CENTER_Y+45),
      P1BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P1UpdateCurComboMessageCommand= function(self)
              if p1_cur_combo >= 1000 then
                local str_cur_combo = string.format('%04d', p1_cur_combo);
                local digit = string.sub(str_cur_combo, 1, 1);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_jvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P1_CENTER-10;y,SCREEN_CENTER_Y+45),
      P1BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P1UpdateCurComboMessageCommand= function(self)
              if p1_cur_combo >= 100 then
                local str_cur_combo = string.format('%04d', p1_cur_combo);
                local digit = string.sub(str_cur_combo, 2, 2);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_kvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P1_CENTER+10;y,SCREEN_CENTER_Y+45),
      P1BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P1UpdateCurComboMessageCommand= function(self)
              if p1_cur_combo >= 10 then
                local str_cur_combo = string.format('%04d', p1_cur_combo);
                local digit = string.sub(str_cur_combo, 3, 3);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_lvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P1_CENTER+30;y,SCREEN_CENTER_Y+45),
      P1BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P1UpdateCurComboMessageCommand= function(self)
              if p1_cur_combo ~= 0 then
                local str_cur_combo = string.format('%04d', p1_cur_combo);
                local digit = string.sub(str_cur_combo, 4, 4);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_mvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+50;y,SCREEN_CENTER_Y-129),
      P1UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              local digit = string.sub(str_score, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_nvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+61;y,SCREEN_CENTER_Y-129),
      P1UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              local digit = string.sub(str_score, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_ovo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+72;y,SCREEN_CENTER_Y-129),
      P1UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              local digit = string.sub(str_score, 3, 3);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_pvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+83;y,SCREEN_CENTER_Y-129),
      P1UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              local digit = string.sub(str_score, 4, 4);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_qvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+94;y,SCREEN_CENTER_Y-129),
      P1UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              local digit = string.sub(str_score, 5, 5);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_rvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+105;y,SCREEN_CENTER_Y-128;queuecommand,"RandScore"),
      RandScoreCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              if GAMESTATE:GetSongBeat() >= 40 then
                if GAMESTATE:GetSongBeat() <= 408 then
                  if string.sub(str_score, 1, 1) == '1' then
                    digit = '0';
                  else
                    digit = tostring(math.random(0,9));
                  end
                  self:setstate(tonumber(digit));
                end
              else
                digit = '0';
                self:setstate(tonumber(digit));
              end
              self:sleep(0.05);
              self:queuecommand('RandScore');
            end,
      Texture= "graphics/small_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_svo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+116;y,SCREEN_CENTER_Y-128;queuecommand,"RandScore"),
      RandScoreCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              if GAMESTATE:GetSongBeat() >= 40 then
                if GAMESTATE:GetSongBeat() <= 408 then
                  if string.sub(str_score, 1, 1) == '1' then
                    digit = '0';
                  else
                    digit = tostring(math.random(0,9));
                  end
                  self:setstate(tonumber(digit));
                end
              else
                digit = '0';
                self:setstate(tonumber(digit));
              end
              self:sleep(0.05);
              self:queuecommand('RandScore');
            end,
      Texture= "graphics/small_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_tvo",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P1_CENTER+127;y,SCREEN_CENTER_Y-128;queuecommand,"RandScore"),
      RandScoreCommand= function(self)
              local str_score = string.format('%05d', p1_cur_score);
              if GAMESTATE:GetSongBeat() >= 40 then
                if GAMESTATE:GetSongBeat() <= 408 then
                  if string.sub(str_score, 1, 1) == '1' then
                    digit = '0';
                  else
                    digit = tostring(math.random(0,9));
                  end
                  self:setstate(tonumber(digit));
                end
              else
                digit = '0';
                self:setstate(tonumber(digit));
              end
              self:sleep(0.05);
              self:queuecommand('RandScore');
            end,
      Texture= "graphics/small_score 10x1",
      },
    },
    Def.Sprite{
      Name= "xtl_actor_uvo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,19.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_vvo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,43.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_wvo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,45.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_xvo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,47.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_yvo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,48.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_zvo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,51.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_awo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,52.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_bwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,52.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_cwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,63.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_dwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,66.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ewo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,71.384615/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_fwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,72.615385/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_gwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,90.769231/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_hwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,92.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_iwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,93.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_jwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,94.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_kwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,95.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_lwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,96.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_mwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,97.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_nwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,98.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_owo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,109.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_pwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,110.615385/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_qwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,115.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_rwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,116.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_swo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,117.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_two",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,118.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_uwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,121.076923/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_vwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,122.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_wwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,9.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_xwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,32.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ywo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,44.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_zwo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,46.307692/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_axo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,48.769231/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_bxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,50.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_cxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,51.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_dxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,52.307692/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_exo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,61.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_fxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,72.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_gxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,73.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_hxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,89.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ixo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,92.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_jxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,93.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_kxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,94.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_lxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,95.384615/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_mxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,96.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_nxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,97.384615/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_oxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,98.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_pxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,110.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_qxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,114.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_rxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,115.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_sxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,117.076923/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_txo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,118.769231/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_uxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,120.615385/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_vxo",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P1_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,121.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_wxo",
    InitCommand= cmd(zoom,0.375;x,P1_CENTER;y,SCREEN_CENTER_Y + -197),
    Texture= "graphics/marquee.png",
    },
    Def.Sprite{
      Name= "xtl_actor_xxo",
    InitCommand= cmd(zoom,0.375;x,P1_CENTER+104;y,SCREEN_CENTER_Y-28),
    Texture= "graphics/life_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_yxo",
    InitCommand= cmd(zoom,0.375;x,P1_CENTER+88;y,SCREEN_CENTER_Y-127),
    Texture= "graphics/score_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_zxo",
    InitCommand= cmd(zoom,0.375;x,P1_CENTER-92;y,SCREEN_CENTER_Y-6),
    Texture= "graphics/player_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_ayo",
    InitCommand= cmd(zoom,0.375;x,P1_CENTER-88;y,SCREEN_CENTER_Y-127),
    Texture= "graphics/track_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_byo",
    InitCommand= cmd(zoom,0.375;x,P1_CENTER+102;y,SCREEN_CENTER_Y-112),
    Texture= "graphics/max_chain.png",
    },
  }),
  optional_actor(xtl_cond_lbl_result,
  Def.ActorFrame{
    Name= "xtl_actor_cyo",
  InitCommand= cmd(queuecommand,"SetupPlayer"),
  SetupPlayerCommand= function(self)
      -- Get Player 2's Speed Mod
      local speed_mod = GetSpeedMod(2)
      p2_travel_time = (beat_length * 8)/(speed_mod);
      
      self:SetDrawByZPosition(true);

      local p2_playfield = SCREENMAN:GetTopScreen():GetChild('PlayerP2');

      if p2_playfield then
        GAMESTATE:ApplyGameCommand('mod, *10000 no mini', 2);

        p2_playfield:SetDrawByZPosition(true);
        p2_playfield:x(SCREEN_WIDTH + 10000);
        p2_playfield:y(360);
        p2_playfield:z(10);
        p2_playfield:visible(1);

        p2_playfield:GetChild('Judgment'):GetChild(''):Load(song_path .. 'animations/graphics/judgment 2x6.png')
        p2_playfield:GetChild('Judgment'):x(-(10000 + 160 + (SCREEN_CENTER_X-135-185)));
        p2_playfield:GetChild('Combo'):visible(0);
      end

      local p2_life = SCREENMAN:GetTopScreen():GetChild('LifeP2');

      if p2_life then
          p2_life:zoomto(0.45, 114/p2_life:GetChild('Background'):GetWidth());
          p2_life:x(P2_CENTER + 80);
          p2_life:y(SCREEN_CENTER_Y-28);
          p2_life:z(1000);
          p2_life:rotationx(180);
          p2_life:rotationz(90);
          p2_life:diffusealpha(0);
      end

      if SCREENMAN:GetTopScreen():GetChild('ScoreP2') then
        SCREENMAN:GetTopScreen():GetChild('ScoreP2'):visible(0);
      end
    end,
    Def.ActorFrame{
      Name= "xtl_actor_dyo",
    InitCommand= function(self)
          length = 40

          self:fov(90);
          self:x(P2_CENTER);
          self:y(160);
        end,
    P2LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*6.5/rate_mod;rotationz,-720+7;sleep,0;rotationz,7;linear,beat_length*1.5/rate_mod;rotationz,0),
    P2RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*6.5/rate_mod;rotationz,720-7;sleep,0;rotationz,-7;linear,beat_length*9.5/rate_mod;rotationz,0),
    P2SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P2SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    VanishX= P2_CENTER,
    VanishY= 150,
      Def.Sprite{
        Name= "xtl_actor_eyo",
      InitCommand= cmd(zoom,0.1;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;blend,"BlendMode_Add"),
      P2TurnOnMessageCommand= cmd(linear,beat_length/rate_mod;zoom,2.2;sleep,0;zoom,0.1),
      Texture= "graphics/warp_change.png",
      },
      Def.Sprite{
        Name= "xtl_actor_fyo",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 45;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) ); 

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_top_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_gyo",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 90;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_mid_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_hyo",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 135;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_bot_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_iyo",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 225;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.01);         

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4);
            end,
      Texture= "graphics/tex_dome_no_bot.png",
      },
      Def.Sprite{
        Name= "xtl_actor_jyo",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 270;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.05);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_mid.png",
      },
      Def.Sprite{
        Name= "xtl_actor_kyo",
      InitCommand= cmd(visible,1;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      SetupCommand= function(self)
              local theta = 315;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.01);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_no_top.png",
      },
      Def.Sprite{
        Name= "xtl_actor_lyo",
      InitCommand= cmd(visible,1;zoom,0.38;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_myo",
      InitCommand= cmd(visible,1;zoom,0.4;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_nyo",
      InitCommand= cmd(visible,1;zoom,0.1;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_oyo",
      InitCommand= cmd(visible,1;zoom,0.2;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_pyo",
      InitCommand= cmd(visible,1;zoom,0.38;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_qyo",
      InitCommand= cmd(visible,1;zoom,0.4;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ryo",
      InitCommand= cmd(visible,1;zoom,0.1;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_syo",
      InitCommand= cmd(visible,1;zoom,0.2;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      Texture= "graphics/glow_green.png",
      },
      Def.Sprite{
        Name= "xtl_actor_tyo",
      InitCommand= cmd(visible,1;zoom,1.2;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;z,-999;queuecommand,"Pulse"),
      P2TurnOffMessageCommand= cmd(visible,1),
      P2TurnOnMessageCommand= cmd(visible,0),
      PulseCommand= cmd(linear,beat_length/rate_mod;zoom,1.5;linear,beat_length/rate_mod;zoom,1.2;queuecommand,"Pulse"),
      Texture= "graphics/light_no.png",
      },
      Def.Sprite{
        Name= "xtl_actor_uyo",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 45;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) ); 

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_top_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_vyo",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 90;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_mid_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_wyo",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 135;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_bot_r.png",
      },
      Def.Sprite{
        Name= "xtl_actor_xyo",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 225;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.01);         

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4);
            end,
      Texture= "graphics/tex_dome_cl_bot.png",
      },
      Def.Sprite{
        Name= "xtl_actor_yyo",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 270;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.05);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_mid.png",
      },
      Def.Sprite{
        Name= "xtl_actor_zyo",
      InitCommand= cmd(visible,0;queuecommand,"Setup"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      SetupCommand= function(self)
              local theta = 315;

              self:x(length * math.cos( math.rad(theta - 90) ) );
              self:y(length * math.sin( math.rad(theta - 90) ) );
              self:croptop(0.01);

              self:zoom(0.57);
              self:zoomz(aspect_scale);
              self:rotationx(90);
              self:rotationy(theta);
              self:rotationz(0);

              self:texcoordvelocity(0,beat_length*4*rate_mod);
            end,
      Texture= "graphics/tex_dome_cl_top.png",
      },
      Def.Sprite{
        Name= "xtl_actor_azo",
      InitCommand= cmd(visible,0;zoom,0.38;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_bzo",
      InitCommand= cmd(visible,0;zoom,0.4;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_czo",
      InitCommand= cmd(visible,0;zoom,0.1;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_dzo",
      InitCommand= cmd(visible,0;zoom,0.2;x,SCREEN_CENTER_X + -300;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_ezo",
      InitCommand= cmd(visible,0;zoom,0.38;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -250;z,50;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_fzo",
      InitCommand= cmd(visible,0;zoom,0.4;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -240;z,50;sleep,0.3;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_gzo",
      InitCommand= cmd(visible,0;zoom,0.1;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -253;z,50;sleep,0.05;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_hzo",
      InitCommand= cmd(visible,0;zoom,0.2;x,SCREEN_CENTER_X + -340;y,SCREEN_CENTER_Y + -260;z,50;sleep,0.2;queuecommand,"Move"),
      MoveCommand= cmd(linear,beat_length*1.5/rate_mod;z,280*aspect_scale;sleep,0;z,50;queuecommand,"Move"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      Texture= "graphics/glow_yellow.png",
      },
      Def.Sprite{
        Name= "xtl_actor_izo",
      InitCommand= cmd(visible,0;zoom,1.2;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;z,-999;queuecommand,"Pulse"),
      P2TurnOffMessageCommand= cmd(visible,0),
      P2TurnOnMessageCommand= cmd(visible,1),
      PulseCommand= cmd(linear,beat_length/rate_mod;zoom,1.5;linear,beat_length/rate_mod;zoom,1.2;queuecommand,"Pulse"),
      Texture= "graphics/light_cl.png",
      },
    },
    Def.ActorFrame{
      Name= "xtl_actor_jzo",
    InitCommand= cmd(fov,90;x,P2_CENTER;y,SCREEN_CENTER_Y + -80),
    P2LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*4/rate_mod;rotationz,-375;sleep,0;rotationz,-15;
                                linear,beat_length*2.5/rate_mod;rotationz,7/rate_mod;linear,beat_length*1.5/rate_mod;rotationz,0),
    P2RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*4/rate_mod;rotationz,375;sleep,0;rotationz,15;
                                linear,beat_length*2.5/rate_mod;rotationz,-7;linear,beat_length*9.5/rate_mod;rotationz,0),
    P2SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P2SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    VanishX= P2_CENTER,
    VanishY= 150,
      Def.Sprite{
        Name= "xtl_actor_kzo",
      InitCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + 260;z,-999;zoom,4.1),
      Texture= "graphics/playfield.png",
      },
      Def.Sprite{
        Name= "xtl_actor_lzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(14.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(19.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(19.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(24.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(28.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(29.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(33.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_szo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(34.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(36.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(58.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(60.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(60.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(67.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(68.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzo",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(68.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(72.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.461538 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.461538 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(73.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(80.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(86.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(88.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(108.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(110.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(110.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(-16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(121.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(19.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(24.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_map",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(26.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(29.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(29.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(33.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(33.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 4.923077 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 4.923077 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.923077 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(87.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 1.230769 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 1.230769 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(89.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(96.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(102.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(108.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(109.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zap",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(111.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_abp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(32, 1);
              self:zoomz(hold_height);
              self:x(16);
              self:y(90);
              self:rotationx(-90);
              self:z(-1000 - hold_height/2);
              self:visible(0);
              self:queuecommand('Wait');
            end,
      Texture= "graphics/hold.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(16.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(17.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(18.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(20.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(23.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(25.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(28.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_obp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(30.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(33.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(35.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(36.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(38.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(39.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(40.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(41.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(43.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_acp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(44.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(45.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ccp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(48.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ecp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(49.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(50.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(51.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(52.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_icp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(57.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ncp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(60.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ocp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(61.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(62.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(65.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_scp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(67.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ucp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(70.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_adp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(77.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(78.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(80.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_edp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(82.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(83.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(84.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_idp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(86.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(87.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(88.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(89.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(91.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(92.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_odp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(93.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(94.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(96.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(97.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(98.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(99.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_udp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(102.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(104.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(105.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(107.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(108.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(109.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(110.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(114.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(115.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(119.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(120.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(121.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,166;queuecommand,"Hide"),
      Texture= "graphics/measure_marker.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qep",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rep",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tep",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uep",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(15.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wep",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xep",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(16.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yep",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zep",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_afp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(16.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(17.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_efp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(17.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(18.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(20.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(21.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(21.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_agp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(25.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_egp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_igp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_chp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_khp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(32.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(36.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(36.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(36.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_php",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(37.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_shp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_thp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_whp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xip",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yip",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(42.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zip",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(42.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_djp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_njp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_akp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ckp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dkp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ekp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fkp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gkp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ikp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jkp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lkp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mkp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_okp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pkp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rkp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_skp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ukp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vkp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xkp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ykp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zkp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_alp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_blp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_clp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dlp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_elp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_flp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_glp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hlp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ilp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jlp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_klp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_llp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mlp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nlp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_olp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_plp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(51.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qlp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rlp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_slp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(51.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tlp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ulp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vlp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(52.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wlp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xlp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ylp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(53.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zlp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_amp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cmp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dmp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_emp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fmp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gmp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_imp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jmp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lmp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mmp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_omp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pmp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rmp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_smp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ump",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vmp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xmp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ymp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zmp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(60.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_anp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bnp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cnp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(61.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dnp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_enp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fnp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gnp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hnp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_inp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jnp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_knp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lnp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mnp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nnp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_onp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pnp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qnp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rnp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_snp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tnp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_unp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(64.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vnp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wnp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xnp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(64.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ynp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_znp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(66.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(67.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(68.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(69.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(70.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_top",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xop",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yop",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zop",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_app",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(74.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_epp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_npp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_opp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_spp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_upp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(87.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_arp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(88.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_brp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_crp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_drp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(90.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_erp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_frp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_grp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(90.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hrp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_irp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jrp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_krp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lrp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mrp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nrp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_orp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_prp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qrp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rrp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_srp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_trp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_urp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vrp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wrp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xrp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yrp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zrp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_asp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_csp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dsp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_esp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fsp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gsp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_isp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jsp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ksp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lsp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_msp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(95.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_osp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_psp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rsp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ssp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_usp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vsp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xsp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ysp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zsp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_atp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_btp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ctp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dtp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_etp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ftp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gtp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_htp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_itp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jtp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ktp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ltp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mtp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ntp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_otp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ptp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qtp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rtp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_stp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ttp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_utp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vtp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wtp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xtp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ytp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ztp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(108.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xup",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yup",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zup",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_avp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cvp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_evp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fvp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(116.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ivp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(116.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lvp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ovp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rvp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_svp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uvp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xvp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yvp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zvp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_awp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dwp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ewp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gwp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(121.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(121.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(121.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jwp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mwp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_owp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pwp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(123.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_swp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_twp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vwp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -345;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -379;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xwp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ywp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(14.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zwp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(14.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_axp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(14.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_exp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ixp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(17.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_txp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xxp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yxp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zxp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ayp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_byp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(19.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dyp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gyp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jyp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_myp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(21.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pyp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(22.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ryp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_syp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_typ",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(23.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vyp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xyp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yyp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zyp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_azp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_czp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ezp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fzp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(26.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_izp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lzp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(28.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_szp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzp",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzp",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzp",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aaq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_baq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_caq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_daq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eaq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_faq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gaq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_haq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(33.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iaq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(33.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jaq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(33.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kaq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(33.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_laq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(33.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_maq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(33.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_naq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(33.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oaq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(33.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_paq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(33.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qaq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(34.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_raq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(34.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_saq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(34.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_taq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(34.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uaq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(34.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vaq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(34.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_waq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xaq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yaq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zaq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_abq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_obq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_acq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ccq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dcq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ecq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fcq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gcq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_icq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jcq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lcq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mcq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ncq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ocq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pcq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rcq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_scq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ucq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(43.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vcq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(43.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_adq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_edq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_idq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_odq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(47.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_udq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(48.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(49.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aeq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_beq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(51.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ceq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_deq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eeq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_feq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_geq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_heq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ieq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jeq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_keq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_leq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_meq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_neq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oeq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_peq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qeq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_req",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_seq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_teq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(54.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ueq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_veq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_weq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xeq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yeq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zeq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_afq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(56.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_efq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(57.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(57.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(58.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(61.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_agq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_egq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_igq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(64.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(64.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_chq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_khq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_phq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_shq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_thq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_whq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(73.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aiq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_biq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ciq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_diq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eiq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fiq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_giq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hiq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iiq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jiq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kiq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_liq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_miq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_niq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oiq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_piq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qiq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_riq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_siq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tiq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uiq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_viq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wiq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xiq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yiq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ziq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_djq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_njq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_akq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ckq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dkq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ekq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fkq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gkq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ikq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jkq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lkq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mkq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_okq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pkq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rkq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_skq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ukq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vkq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xkq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ykq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zkq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_alq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_blq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_clq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dlq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_elq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_flq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_glq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hlq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ilq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jlq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_klq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_llq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mlq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nlq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_olq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_plq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qlq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rlq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_slq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tlq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ulq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vlq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wlq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xlq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ylq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zlq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_amq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(94.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cmq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dmq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_emq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fmq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gmq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_imq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jmq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lmq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mmq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(98.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_omq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pmq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rmq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_smq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_umq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vmq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xmq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ymq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zmq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_anq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bnq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cnq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dnq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_enq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fnq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gnq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hnq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_inq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jnq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_knq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lnq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mnq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nnq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_onq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pnq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qnq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rnq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_snq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tnq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_unq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vnq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wnq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xnq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ynq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_znq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aoq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_boq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_coq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_doq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eoq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_foq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_goq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hoq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ioq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_joq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_koq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_loq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_moq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_noq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ooq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(108.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_poq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(109.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qoq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(109.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_roq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(109.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_soq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(110.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_toq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(110.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uoq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(110.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_voq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(110.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_woq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(110.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xoq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(110.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yoq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(110.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zoq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(110.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_apq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(110.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_epq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(112.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(112.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(112.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_npq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_opq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_spq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_upq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_arq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_brq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_crq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(119.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_drq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_erq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_frq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_grq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(121.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hrq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(121.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_irq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(121.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jrq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_krq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(121.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lrq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mrq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nrq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_orq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_prq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qrq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rrq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_srq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_trq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_urq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vrq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wrq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xrq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yrq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zrq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_asq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_csq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dsq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_esq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fsq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gsq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_isq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jsq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ksq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -328;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lsq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -342;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_msq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -338;y,SCREEN_CENTER_Y + -114;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_osq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_psq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rsq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ssq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(15.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_usq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vsq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xsq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ysq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(16.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zsq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_atq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_btq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(17.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ctq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dtq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_etq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(17.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ftq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gtq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_htq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(18.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_itq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jtq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ktq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(19.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ltq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mtq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ntq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_otq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ptq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qtq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(20.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rtq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_stq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ttq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(21.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_utq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vtq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wtq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(21.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xtq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ytq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ztq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_auq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_buq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cuq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(22.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_duq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_euq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fuq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(23.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_guq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_huq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iuq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(23.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_juq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kuq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_luq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(24.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_muq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nuq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ouq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_puq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_quq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ruq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(25.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_suq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tuq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uuq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(26.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vuq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wuq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xuq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(26.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yuq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zuq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_avq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cvq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(27.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_evq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fvq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(28.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ivq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(28.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lvq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(29.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ovq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rvq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_svq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uvq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(30.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xvq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yvq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(31.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zvq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_awq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dwq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ewq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(32.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gwq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(32.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(32.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jwq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mwq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_owq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pwq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(37.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_swq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_twq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vwq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xwq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ywq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zwq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_axq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(38.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_exq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ixq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(39.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(40.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_txq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(41.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xxq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yxq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zxq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ayq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_byq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dyq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(42.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gyq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jyq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(44.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_myq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pyq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(45.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ryq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_syq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(47.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vyq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(47.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xyq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yyq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(48.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zyq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_azq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(49.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_czq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ezq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(50.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fzq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(50.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_izq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(51.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lzq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(52.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(52.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(52.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_szq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(53.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(55.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzq",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzq",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzq",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(57.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bar",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_car",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(58.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ear",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_far",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(58.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_har",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iar",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(59.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kar",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lar",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(59.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nar",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oar",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_par",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(60.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qar",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(60.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rar",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(60.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tar",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uar",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(61.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_var",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_war",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xar",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(61.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yar",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zar",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_abr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(63.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(64.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(64.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(64.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_obr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(65.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(65.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(66.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(66.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(66.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(66.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_acr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ccr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dcr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ecr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fcr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(67.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gcr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(67.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(67.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_icr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jcr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(68.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lcr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mcr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ncr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(68.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ocr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pcr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(68.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rcr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_scr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ucr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(69.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vcr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(69.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(69.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_adr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(70.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(70.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cdr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(70.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ddr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_edr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fdr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gdr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_idr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jdr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ldr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(71.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mdr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ndr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_odr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pdr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rdr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sdr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_udr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(72.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vdr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xdr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(73.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ydr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zdr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aer",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(73.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ber",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cer",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_der",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eer",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fer",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ger",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(74.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_her",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ier",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(75.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jer",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ker",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(75.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ler",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(75.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mer",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(75.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ner",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oer",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_per",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qer",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rer",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ser",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ter",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uer",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ver",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(81.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wer",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xer",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yer",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zer",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_afr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_efr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(82.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(83.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(84.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(85.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_agr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_egr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(86.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_igr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(87.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(87.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(87.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(88.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(89.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_chr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(90.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(90.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(90.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_khr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_phr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(91.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_shr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_thr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(92.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_whr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_air",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(93.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(94.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(94.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(95.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(95.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xir",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yir",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zir",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_djr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(103.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_njr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(104.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_akr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(105.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ckr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dkr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ekr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fkr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gkr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ikr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jkr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(106.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lkr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mkr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_okr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pkr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rkr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_skr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(107.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ukr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vkr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(108.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(109.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xkr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(109.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ykr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(109.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zkr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(109.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_alr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(109.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_blr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(109.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_clr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dlr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_elr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_flr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_glr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hlr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ilr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jlr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_klr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_llr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mlr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nlr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(111.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_olr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_plr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(112.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qlr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rlr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_slr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tlr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ulr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vlr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wlr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xlr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ylr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zlr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_amr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cmr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(113.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dmr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_emr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fmr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gmr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_imr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jmr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lmr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mmr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_omr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(114.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pmr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rmr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_smr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_umr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(115.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vmr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xmr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ymr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zmr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_anr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bnr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cnr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dnr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(116.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_enr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fnr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gnr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hnr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_inr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jnr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_knr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lnr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mnr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(120.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nnr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_onr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pnr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qnr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rnr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_snr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tnr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_unr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vnr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wnr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xnr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ynr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(122.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_znr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cor",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(123.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_for",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ior",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(124.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lor",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -312;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -305;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -302;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/down_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oor",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_por",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(14.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ror",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(15.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(15.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(15.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uor",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(16.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(16.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(16.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xor",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(17.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yor",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(17.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zor",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(17.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_apr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cpr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(18.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dpr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(18.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_epr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(18.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fpr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(18.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gpr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ipr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(19.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jpr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(20.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(20.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lpr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(20.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mpr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(21.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_npr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(21.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_opr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(21.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ppr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(22.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(22.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rpr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(22.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_spr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(23.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(23.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_upr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(23.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vpr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xpr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(24.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ypr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(25.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zpr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(25.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(25.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(26.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(26.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(26.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(27.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(27.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(27.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(27.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(28.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(28.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(28.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(29.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_arr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_brr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(30.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_crr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_drr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_err",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_frr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_grr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hrr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_irr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jrr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_krr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lrr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(31.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mrr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(31.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nrr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(31.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_orr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_prr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(34.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qrr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rrr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_srr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_trr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(37.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_urr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(37.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vrr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(37.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wrr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(37.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xrr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yrr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zrr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_asr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(38.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(38.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_csr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(38.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dsr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_esr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fsr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gsr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_isr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jsr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(39.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ksr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(39.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lsr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(39.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_msr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_osr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_psr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(40.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(40.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rsr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(40.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ssr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_usr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vsr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xsr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ysr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(41.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zsr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(41.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_atr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(41.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_btr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(42.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ctr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(42.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dtr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(42.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_etr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ftr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gtr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_htr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_itr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jtr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ktr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ltr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mtr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ntr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(43.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_otr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(43.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ptr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(43.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qtr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rtr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_str",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ttr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(44.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_utr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(44.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vtr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(44.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wtr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xtr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ytr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ztr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(45.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(45.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(45.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_iur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(46.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(46.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(46.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_our",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(47.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xur",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(48.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yur",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(48.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zur",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(48.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_avr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cvr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(49.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_evr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(49.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fvr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(49.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ivr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lvr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ovr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(50.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(50.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rvr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(50.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_svr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(51.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(51.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uvr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(51.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(53.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(53.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xvr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(53.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yvr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zvr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_awr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(56.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dwr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ewr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(57.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(57.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gwr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(57.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jwr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(58.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(58.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mwr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(58.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_owr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pwr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_swr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_twr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(59.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(59.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vwr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(59.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xwr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ywr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(61.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zwr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(61.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_axr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(61.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(61.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_exr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ixr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(62.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_txr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(63.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(63.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(63.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xxr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yxr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zxr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(65.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ayr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(65.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_byr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(65.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(65.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dyr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(71.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(71.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(71.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gyr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_iyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jyr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(72.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(72.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(72.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_myr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(73.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pyr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(73.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(73.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ryr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(73.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_syr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(74.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(74.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_uyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(74.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vyr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(75.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(75.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xyr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(75.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yyr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zyr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_azr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(81.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_czr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(81.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(81.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ezr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fzr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(82.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_izr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(82.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(82.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lzr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ozr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(83.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rzr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(83.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_szr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(83.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uzr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(84.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xzr",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(84.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yzr",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(84.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zzr",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cas",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(85.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_das",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(85.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(85.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fas",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_has",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(86.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ias",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(86.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_las",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(86.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(86.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(86.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_oas",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(88.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(88.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(88.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ras",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(89.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(89.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(89.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uas",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_was",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xas",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(91.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yas",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(91.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zas",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(91.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_abs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_cbs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_dbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(92.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ebs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(92.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fbs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(92.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_gbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ibs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(93.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(93.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_lbs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(93.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_obs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_rbs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_sbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(94.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ubs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_vbs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xbs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ybs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zbs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(95.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_acs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ccs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dcs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ecs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fcs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gcs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ics",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jcs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lcs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mcs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ncs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ocs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pcs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rcs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.615385/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_scs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.615385/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(103.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ucs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(103.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vcs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(103.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xcs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ycs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zcs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(104.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ads",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(104.846154/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(104.846154/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cds",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_eds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fds",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ids",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(105.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(105.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(105.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lds",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_nds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ods",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.384615/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.384615/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rds",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(106.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(106.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(106.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_uds",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_wds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_xds",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(107.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yds",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(107.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_zds",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(107.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_aes",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(108.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(108.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ces",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(108.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_des",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(111.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ees",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(111.692308/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_fes",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(111.692308/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ges",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(112.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(112.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ies",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(112.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_jes",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_les",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_mes",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_oes",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(113.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_pes",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(113.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(113.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_res",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(113.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ses",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(114.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(114.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ues",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(114.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ves",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_xes",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_yes",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zes",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.153846/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_afs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.153846/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_bfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cfs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.307692/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_dfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.307692/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_efs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ffs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_gfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_hfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ifs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_jfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_kfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(115.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lfs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(115.923077/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_mfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(115.923077/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_nfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(116.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ofs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(116.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_pfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(116.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_qfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rfs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_sfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(117.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_tfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ufs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.076923/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_vfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_wfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xfs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(119.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_yfs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_zfs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ags",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_bgs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_cgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(120.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dgs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(120.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_egs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(120.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_fgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ggs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_hgs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.000000/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_igs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jgs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.461538/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_kgs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.461538/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_lgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(122.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mgs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(122.769231/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_ngs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(122.769231/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ogs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pgs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_qgs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.230769/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_rgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.18;x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -150;z,-1000;visible,0;queuecommand,"Wait"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;z,168;queuecommand,"Hide"),
      Texture= "graphics/note.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sgs",
        Frames= {
          {Frame= 0, Delay= 0.03},
          {Frame= 1, Delay= 0.03},
          {Frame= 2, Delay= 0.03},
          {Frame= 3, Delay= 0.03},
          {Frame= 4, Delay= 0.03},
          {Frame= 5, Delay= 0.03},
          {Frame= 6, Delay= 0.03},
          {Frame= 7, Delay= 0.03},
          {Frame= 8, Delay= 0.03},
          {Frame= 9, Delay= 0.03},
          {Frame= 10, Delay= 0.03},
          {Frame= 11, Delay= 0.03},
          {Frame= 12, Delay= 0.03},
          {Frame= 13, Delay= 0.03},
          {Frame= 14, Delay= 0.03},
          {Frame= 15, Delay= 0.03},
          {Frame= 16, Delay= 0.03},
          {Frame= 17, Delay= 1},
      },
      HideCommand= cmd(visible,0),
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -268;y,SCREEN_CENTER_Y + -57;visible,0;queuecommand,"Wait"),
      ShowCommand= cmd(visible,1;setstate,0;sleep,0.51;queuecommand,"Hide"),
      Texture= "graphics/critical 6x3",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Show"),
      },
      Def.Sprite{
        Name= "xtl_actor_tgs",
      HideCommand= cmd(visible,0),
      HitCommand= cmd(visible,1;sleep,0.1;queuecommand,"Hide"),
      InitCommand= cmd(zoom,0.375;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -114;rotationy,180;visible,0;queuecommand,"Wait"),
      Texture= "graphics/left_hit.png",
      WaitCommand= cmd(sleep,(125.538462/rate_mod + offset);queuecommand,"Hit"),
      },
      Def.Sprite{
        Name= "xtl_actor_ugs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ygs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zgs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(53.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ahs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(54.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_chs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(66.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ehs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ghs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(93.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ihs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(96.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(97.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_khs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(98.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(99.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ohs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_phs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(113.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(117.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_shs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ths",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(120.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(123.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -363;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_start.png",
      WaitCommand= cmd(sleep,(124.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_whs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(12.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(46.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zhs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(48.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ais",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(51.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(52.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(54.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(54.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_his",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(92.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(94.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(96.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(99.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ois",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ris",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(118.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vis",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -277;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-955;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_start.png",
      WaitCommand= cmd(sleep,(124.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wis",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xis",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(46.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yis",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(48.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zis",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(49.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ajs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(51.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(52.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(52.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_djs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(54.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ejs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(54.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(55.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(66.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ijs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2RotateCW');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(92.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(94.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ljs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(96.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_njs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(96.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ojs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(98.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(99.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(100.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ujs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(118.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zjs",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(120.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(124.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(48.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(52.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(54.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(65.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(92.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(94.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(96.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(100.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(112.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(121.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(123.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zks",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/purple_sharp.png",
      WaitCommand= cmd(sleep,(124.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_als",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(46.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(47.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(50.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(54.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_els",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(76.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ils",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(93.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ols",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(118.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(123.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpLeft');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(124.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(53.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(54.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zls",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(66.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ams",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(75.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(76.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ems",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(93.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(96.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ims",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(97.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(98.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(99.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2RotateCCW');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(113.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(117.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(120.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ums",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(123.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vms",
      HideCommand= function(self)
              self:visible(0);
              MESSAGEMAN:Broadcast('P2SharpRight');
            end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= cmd(visible,1;linear,p2_travel_time;addz,1170;queuecommand,"Hide"),
      SetupCommand= cmd(zoomx,0.38;zoomz,0.56;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -150;rotationy,180;
                         rotationx,-90;z,-1002;visible,0;blend,"BlendMode_Add";queuecommand,"Wait"),
      Texture= "graphics/blue_sharp.png",
      WaitCommand= cmd(sleep,(124.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wms",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(46.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xms",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(48.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yms",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(49.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zms",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(51.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ans",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(52.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(52.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(54.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(54.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ens",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(55.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(66.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(74.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(92.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ins",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(94.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(95.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(96.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(96.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(97.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(98.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ons",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(98.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(99.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(100.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(100.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(112.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(116.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(117.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(118.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(119.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(120.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zns",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(123.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(124.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(46.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(48.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(52.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(54.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(65.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ios",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(92.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(94.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(96.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_los",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(97.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(98.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(99.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(100.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(112.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(117.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ros",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(118.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.615385 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(119.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(120.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(121.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(123.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(124.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(46.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zos",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(47.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(50.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(54.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(66.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(76.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(93.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(95.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ips",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(97.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(98.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(99.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(112.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(113.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(118.769231/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ops",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(119.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(123.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(-44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(124.615385/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(46.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(47.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(50.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ups",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(51.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(53.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(54.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(66.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(73.846154/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zps",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_aqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(75.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_bqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(76.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_cqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(93.230769/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_dqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(94.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_eqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(95.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_fqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(96.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_gqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(97.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_hqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(98.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_iqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(99.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_jqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(100.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_kqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(112.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_lqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(113.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_mqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(117.692308/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_nqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.307692 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(118.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_oqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(119.076923/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_pqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(120.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_qqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(120.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_rqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(123.538462/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_sqs",
      HideCommand= cmd(visible,0),
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:linear((lane_length + hold_height)/lane_length * p2_travel_time);
              self:addz(lane_length + hold_height);
              self:queuecommand('Hide');
              end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 0.153846 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(44);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(124.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_tqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P2RightHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(34.461538/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_uqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P2LeftHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(12.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_vqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 1.846154 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P2LeftHold6');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 1.846154 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(64.000000/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_wqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 4.923077 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 4.923077 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/purple_hold.png",
      WaitCommand= cmd(sleep,(76.307692/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_xqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P2RightHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(22.153846/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_yqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 1.230769 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P2RightHold4');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 1.230769 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(55.384615/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_zqs",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              MESSAGEMAN:Broadcast('P2RightHold8');
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(68.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
      Def.Sprite{
        Name= "xtl_actor_ars",
      HideCommand= cmd(visible,0),
      HitCommand= function(self)
              local lane_length = 1170;
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:linear(hold_height/lane_length * p2_travel_time);
              self:addz(hold_height);
              self:queuecommand('Hide');
              end,
      InitCommand= cmd(queuecommand,"Setup"),
      MoveCommand= function(self)
              self:visible(1);
              local lane_length = 1170
              self:linear(p2_travel_time);
              self:addz(lane_length);
              self:queuecommand('Hit');
             end,
      SetupCommand= function(self)
              local lane_length = 1170
              local hold_height = 2.461538 * lane_length / p2_travel_time / rate_mod;
              self:zoomto(18, 1);
              self:zoomz(hold_height);
              self:x(0);
              self:y(90-10);
              self:rotationx(-90);
              self:z(-983 - hold_height/2);
              self:skewx(-270);
              self:visible(0);
              self:blend('add');
              self:queuecommand('Wait');
            end,
      Texture= "graphics/blue_hold.png",
      WaitCommand= cmd(sleep,(100.923077/rate_mod - p2_travel_time + offset);queuecommand,"Move"),
      },
    },
    Def.ActorFrame{
      Name= "xtl_actor_brs",
    InitCommand= cmd(fov,90;x,P2_CENTER;y,SCREEN_CENTER_Y + 70),
    P2LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,-15;accelerate,beat_length*3.75/rate_mod;rotationz,7;
                                linear,beat_length*1.5/rate_mod;rotationz,0),
    P2RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,15;accelerate,beat_length*3.75/rate_mod;rotationz,-7;
                                linear,beat_length*9.5/rate_mod;rotationz,0),
    P2SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P2SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
      Def.Sprite{
        Name= "xtl_actor_crs",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;zoom,0;x,SCREEN_CENTER_X + -434;y,SCREEN_CENTER_Y + -203;linear,beat_length*10/rate_mod;zoom,1),
      Texture= "graphics/line_bg.png",
      WaitCommand= cmd(visible,0;cropleft,0.5;sleep,beat_length*16/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_drs",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;zoom,0;x,SCREEN_CENTER_X + -206;y,SCREEN_CENTER_Y + -203;linear,beat_length*10/rate_mod;zoom,1),
      Texture= "graphics/line_bg.png",
      WaitCommand= cmd(visible,0;cropright,0.5;sleep,beat_length*16/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_ers",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;sleep,0;zoom,0.5;x,SCREEN_CENTER_X + -478;y,SCREEN_CENTER_Y + -203;texcoordvelocity,beat_length*rate_mod,0),
      Texture= "graphics/line_words",
      WaitCommand= cmd(visible,0;cropleft,0.5;sleep,beat_length*26/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_frs",
      OnCommand= cmd(queuecommand,"Wait"),
      SetupCommand= cmd(visible,1;sleep,0;zoom,0.5;x,SCREEN_CENTER_X + -162;y,SCREEN_CENTER_Y + -203;texcoordvelocity,-beat_length*rate_mod,0),
      Texture= "graphics/line_words",
      WaitCommand= cmd(visible,0;cropright,0.5;sleep,beat_length*26/rate_mod;queuecommand,"Setup"),
      },
      Def.Sprite{
        Name= "xtl_actor_grs",
      InitCommand= cmd(zoom,0.36;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -205),
      Texture= "graphics/line.png",
      },
      Def.Sprite{
        Name= "xtl_actor_hrs",
      InitCommand= cmd(zoom,0.32;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -162),
      P2LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;x,-shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P2LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;x,-shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P2LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;x,-shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P2RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;x,shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P2RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;x,shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P2RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;x,shift_amount;linear,beat_length*2/rate_mod;x,SCREEN_CENTER_X + -320),
      P2SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;x,-shift_amount;linear,beat_length/rate_mod;x,SCREEN_CENTER_X + -320),
      P2SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;x,shift_amount;linear,beat_length/rate_mod;x,SCREEN_CENTER_X + -320),
      Texture= "graphics/io_front.png",
      },
      Def.Sprite{
        Name= "xtl_actor_irs",
      InitCommand= cmd(zoom,0.38;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -140;cropleft,0.1;cropright,0.1),
      Texture= "graphics/io_main.png",
      },
    },
    Def.Sprite{
      Name= "xtl_actor_jrs",
    InitCommand= cmd(zoom,0.38;x,P2_CENTER;y,SCREEN_CENTER_Y + -130),
    Texture= "graphics/angle_01.png",
    },
    Def.Sprite{
      Name= "xtl_actor_krs",
    InitCommand= cmd(zoom,0.38;x,P2_CENTER;y,SCREEN_CENTER_Y + -120),
    P2LeftHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2LeftHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,-tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold4MessageCommand= cmd(stoptweening;linear,beat_length*4/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold6MessageCommand= cmd(stoptweening;linear,beat_length*6/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RightHold8MessageCommand= cmd(stoptweening;linear,beat_length*8/rate_mod;rotationz,tilt_angle;linear,beat_length*2/rate_mod;rotationz,0),
    P2RotateCCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,-15;accelerate,beat_length*3.75/rate_mod;rotationz,7;
                                linear,beat_length*1.5/rate_mod;rotationz,0),
    P2RotateCWMessageCommand= cmd(stoptweening;decelerate,beat_length*2.75/rate_mod;rotationz,15;accelerate,beat_length*3.75/rate_mod;rotationz,-7;
                                linear,beat_length*9.5/rate_mod;rotationz,0),
    P2SharpLeftMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,-tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    P2SharpRightMessageCommand= cmd(stoptweening;linear,beat_length*0.125/rate_mod;rotationz,tilt_angle;linear,beat_length/rate_mod;rotationz,0),
    Texture= "graphics/angle_02.png",
    },
    Def.ActorFrame{
      Name= "xtl_actor_lrs",
    InitCommand= function(self)
          p2_cur_score = 0;
          p2_prev_score = 0;

          p2_cur_combo = 0;
          p2_max_combo = 0;

          p2_is_on = false;
        end,
      Def.Quad{
        Name= "xtl_actor_mrs",
      OnCommand= cmd(queuecommand,"UpdateCombo"),
      UpdateComboCommand= function(self)

              if SCREENMAN:GetTopScreen():GetChild('ScoreP2'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP2') then
                p2_cur_score = tonumber( string.sub( SCREENMAN:GetTopScreen():GetChild('ScoreP2'):GetChild('ScoreDisplayPercentage Percent'):GetChild('PercentP2'):GetText(), 1, -2 )*100 );
              end

              -- Fantastics, Excellents, and Greats add to combo
              -- Decents do nothing (because they don't change score)
              -- Way Offs and Misses reset combo
              if (p2_cur_score - p2_prev_score) > 0 then
                p2_cur_combo = p2_cur_combo + 1;
                
                if p2_cur_combo > p2_max_combo then
                  p2_max_combo = p2_cur_combo;
                  MESSAGEMAN:Broadcast('P2UpdateMaxCombo');
                end

                MESSAGEMAN:Broadcast('P2UpdateCurCombo');

              elseif (p2_cur_score - p2_prev_score) < 0 then
                p2_cur_combo = 0;

                MESSAGEMAN:Broadcast('P2BrokeCombo');
                MESSAGEMAN:Broadcast('P2UpdateCurCombo');
              end

              p2_prev_score = p2_cur_score;

              if not p2_is_on then
                if p2_cur_combo >= 50 then
                  p2_is_on = true;
                  MESSAGEMAN:Broadcast('P2TurnOn');
                end
              end

              if p2_is_on then
                if p2_cur_combo < 50 then
                  p2_is_on = false;
                  MESSAGEMAN:Broadcast('P2TurnOff');
                end
              end

              self:sleep(0.05);
              self:queuecommand('UpdateCombo');            
            end,
      },
      Def.Sprite{
        Name= "xtl_actor_nrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER-56;y,SCREEN_CENTER_Y-122),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_tempo = string.format('%03d', math.floor(tempo * rate_mod + 0.5));
              local digit = string.sub(str_tempo, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_ors",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER-51;y,SCREEN_CENTER_Y-122),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_tempo = string.format('%03d', math.floor(tempo * rate_mod + 0.5));
              local digit = string.sub(str_tempo, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_prs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER-46;y,SCREEN_CENTER_Y-122),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_tempo = string.format('%03d', math.floor(tempo * rate_mod + 0.5));
              local digit = string.sub(str_tempo, 3, 3);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_qrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.39;x,P2_CENTER-54;y,SCREEN_CENTER_Y-114),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_speed_mod = string.format('%02d', math.floor(GetSpeedMod(2) * 10 + 0.5));
              local digit = string.sub(str_speed_mod, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_rrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.39;x,P2_CENTER-45;y,SCREEN_CENTER_Y-114),
      OnCommand= cmd(queuecommand,"SetBPM"),
      SetBPMCommand= function(self)
              local str_speed_mod = string.format('%02d', math.floor(GetSpeedMod(2) * 10 + 0.5));
              local digit = string.sub(str_speed_mod, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_srs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P2_CENTER+47;y,SCREEN_CENTER_Y-113),
      P2UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p2_max_combo);
              local digit = string.sub(str_max_combo, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_trs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P2_CENTER+54;y,SCREEN_CENTER_Y-113),
      P2UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p2_max_combo);
              local digit = string.sub(str_max_combo, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_urs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P2_CENTER+61;y,SCREEN_CENTER_Y-113),
      P2UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p2_max_combo);
              local digit = string.sub(str_max_combo, 3, 3);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_vrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.42;x,P2_CENTER+68;y,SCREEN_CENTER_Y-113),
      P2UpdateMaxComboMessageCommand= function(self)
              local str_max_combo = string.format('%04d', p2_max_combo);
              local digit = string.sub(str_max_combo, 4, 4);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/numbers 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_wrs",
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;zoom,0.38;x,P2_CENTER;y,SCREEN_CENTER_Y+30),
      P2BrokeComboMessageCommand= cmd(diffusecolor,1,1,1,1),
      Texture= "graphics/chain.png",
      },
      Def.Sprite{
        Name= "xtl_actor_xrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P2_CENTER-30;y,SCREEN_CENTER_Y+45),
      P2BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P2UpdateCurComboMessageCommand= function(self)
              if p2_cur_combo >= 1000 then
                local str_cur_combo = string.format('%04d', p2_cur_combo);
                local digit = string.sub(str_cur_combo, 1, 1);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_yrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P2_CENTER-10;y,SCREEN_CENTER_Y+45),
      P2BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P2UpdateCurComboMessageCommand= function(self)
              if p2_cur_combo >= 100 then
                local str_cur_combo = string.format('%04d', p2_cur_combo);
                local digit = string.sub(str_cur_combo, 2, 2);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_zrs",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P2_CENTER+10;y,SCREEN_CENTER_Y+45),
      P2BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P2UpdateCurComboMessageCommand= function(self)
              if p2_cur_combo >= 10 then
                local str_cur_combo = string.format('%04d', p2_cur_combo);
                local digit = string.sub(str_cur_combo, 3, 3);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_ass",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
          {Frame= 10, Delay= 130},
      },
      InitCommand= cmd(diffuse,color('240/255'),240/255,150/255,1;setstate,10;zoom,0.42;x,P2_CENTER+30;y,SCREEN_CENTER_Y+45),
      P2BrokeComboMessageCommand= cmd(diffuse,color('1'),1,1,1;setstate,10),
      P2UpdateCurComboMessageCommand= function(self)
              if p2_cur_combo ~= 0 then
                local str_cur_combo = string.format('%04d', p2_cur_combo);
                local digit = string.sub(str_cur_combo, 4, 4);
                self:setstate(tonumber(digit));
              end
            end,
      Texture= "graphics/combo 11x1",
      },
      Def.Sprite{
        Name= "xtl_actor_bss",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+50;y,SCREEN_CENTER_Y-129),
      P2UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              local digit = string.sub(str_score, 1, 1);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_css",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+61;y,SCREEN_CENTER_Y-129),
      P2UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              local digit = string.sub(str_score, 2, 2);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_dss",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+72;y,SCREEN_CENTER_Y-129),
      P2UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              local digit = string.sub(str_score, 3, 3);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_ess",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+83;y,SCREEN_CENTER_Y-129),
      P2UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              local digit = string.sub(str_score, 4, 4);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_fss",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+94;y,SCREEN_CENTER_Y-129),
      P2UpdateCurComboMessageCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              local digit = string.sub(str_score, 5, 5);
              self:setstate(tonumber(digit));
            end,
      Texture= "graphics/big_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_gss",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+105;y,SCREEN_CENTER_Y-128;queuecommand,"RandScore"),
      RandScoreCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              if GAMESTATE:GetSongBeat() >= 40 then
                if GAMESTATE:GetSongBeat() <= 408 then
                  if string.sub(str_score, 1, 1) == '1' then
                    digit = '0';
                  else
                    digit = tostring(math.random(0,9));
                  end
                  self:setstate(tonumber(digit));
                end
              else
                digit = '0';
                self:setstate(tonumber(digit));
              end
              self:sleep(0.05);
              self:queuecommand('RandScore');
            end,
      Texture= "graphics/small_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_hss",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+116;y,SCREEN_CENTER_Y-128;queuecommand,"RandScore"),
      RandScoreCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              if GAMESTATE:GetSongBeat() >= 40 then
                if GAMESTATE:GetSongBeat() <= 408 then
                  if string.sub(str_score, 1, 1) == '1' then
                    digit = '0';
                  else
                    digit = tostring(math.random(0,9));
                  end
                  self:setstate(tonumber(digit));
                end
              else
                digit = '0';
                self:setstate(tonumber(digit));
              end
              self:sleep(0.05);
              self:queuecommand('RandScore');
            end,
      Texture= "graphics/small_score 10x1",
      },
      Def.Sprite{
        Name= "xtl_actor_iss",
        Frames= {
          {Frame= 0, Delay= 130},
          {Frame= 1, Delay= 130},
          {Frame= 2, Delay= 130},
          {Frame= 3, Delay= 130},
          {Frame= 4, Delay= 130},
          {Frame= 5, Delay= 130},
          {Frame= 6, Delay= 130},
          {Frame= 7, Delay= 130},
          {Frame= 8, Delay= 130},
          {Frame= 9, Delay= 130},
      },
      InitCommand= cmd(zoom,0.38;x,P2_CENTER+127;y,SCREEN_CENTER_Y-128;queuecommand,"RandScore"),
      RandScoreCommand= function(self)
              local str_score = string.format('%05d', p2_cur_score);
              if GAMESTATE:GetSongBeat() >= 40 then
                if GAMESTATE:GetSongBeat() <= 408 then
                  if string.sub(str_score, 1, 1) == '1' then
                    digit = '0';
                  else
                    digit = tostring(math.random(0,9));
                  end
                  self:setstate(tonumber(digit));
                end
              else
                digit = '0';
                self:setstate(tonumber(digit));
              end
              self:sleep(0.05);
              self:queuecommand('RandScore');
            end,
      Texture= "graphics/small_score 10x1",
      },
    },
    Def.Sprite{
      Name= "xtl_actor_jss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,19.692308/rate_mod;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_kss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,43.692308/rate_mod;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_lss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,19.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_mss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,43.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_nss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,45.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_oss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,47.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_pss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,48.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_qss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,51.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_rss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,52.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_sss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,52.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_tss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,63.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_uss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,66.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_vss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,71.384615/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_wss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,72.615385/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_xss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,90.769231/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_yss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,92.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_zss",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,93.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ats",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,94.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_bts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,95.692308/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_cts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,96.923077/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_dts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,97.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ets",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,98.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_fts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,109.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_gts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,110.615385/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_hts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,115.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_its",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,116.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_jts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,117.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_kts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,118.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_lts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,121.076923/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_mts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER-98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/left_indicator.png",
    WaitCommand= cmd(sleep,122.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_nts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,9.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ots",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,32.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_pts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,44.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_qts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,46.307692/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_rts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,48.769231/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_sts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,50.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_tts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,51.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_uts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,52.307692/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_vts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,61.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_wts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,72.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_xts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,73.846154/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_yts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,89.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_zts",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,92.000000/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_aus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,93.230769/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_bus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,94.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_cus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,95.384615/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_dus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,96.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_eus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,97.384615/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_fus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,98.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_gus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,110.153846/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_hus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,114.461538/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_ius",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,115.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_jus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,117.076923/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_kus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,118.769231/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_lus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,120.615385/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_mus",
    BlinkCommand= cmd(visible,1;linear,beat_length*0.5/rate_mod;diffusealpha,0.2;linear,beat_length*0.5/rate_mod;diffusealpha,1;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0.2;zoom,0.35;linear,beat_length*0.5/rate_mod;diffusealpha,1;zoom,0.38;
                    linear,beat_length*0.5/rate_mod;diffusealpha,0;queuecommand,"Hide"),
    HideCommand= cmd(visible,0),
    InitCommand= cmd(zoom,0.38;x,P2_CENTER+98;y,SCREEN_CENTER_Y + 70;diffusealpha,1;visible,0;queuecommand,"Wait"),
    Texture= "graphics/right_indicator.png",
    WaitCommand= cmd(sleep,121.538462/rate_mod + offset;queuecommand,"Blink"),
    },
    Def.Sprite{
      Name= "xtl_actor_nus",
    InitCommand= cmd(zoom,0.375;x,P2_CENTER;y,SCREEN_CENTER_Y + -197),
    Texture= "graphics/marquee.png",
    },
    Def.Sprite{
      Name= "xtl_actor_ous",
    InitCommand= cmd(zoom,0.375;x,P2_CENTER+104;y,SCREEN_CENTER_Y-28),
    Texture= "graphics/life_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_pus",
    InitCommand= cmd(zoom,0.375;x,P2_CENTER+88;y,SCREEN_CENTER_Y-127),
    Texture= "graphics/score_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_qus",
    InitCommand= cmd(zoom,0.375;x,P2_CENTER-92;y,SCREEN_CENTER_Y-6),
    Texture= "graphics/player_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_rus",
    InitCommand= cmd(zoom,0.375;x,P2_CENTER-88;y,SCREEN_CENTER_Y-127),
    Texture= "graphics/track_info.png",
    },
    Def.Sprite{
      Name= "xtl_actor_sus",
    InitCommand= cmd(zoom,0.375;x,P2_CENTER+102;y,SCREEN_CENTER_Y-112),
    Texture= "graphics/max_chain.png",
    },
  }),
  optional_actor(xtl_cond_kbl_result,
  Def.Quad{
    Name= "xtl_actor_tus",
  OnCommand= function(self)
      self:diffuse(0,0,0,1);
      self:zoomto(P1_CENTER-135, SCREEN_HEIGHT);
      self:x((P1_CENTER-135)/2);
      self:y(SCREEN_CENTER_Y);
      self:sleep(song_duration);
    end,
  }),
  optional_actor(xtl_cond_lbl_result,
  Def.Quad{
    Name= "xtl_actor_uus",
  OnCommand= function(self)
      self:diffuse(0,0,0,1);
      self:zoomto(P1_CENTER-135, SCREEN_HEIGHT);
      self:x(SCREEN_WIDTH - (P1_CENTER-135)/2);
      self:y(SCREEN_CENTER_Y);
      self:sleep(song_duration);
    end,
  }),
  Def.Quad{
    Name= "xtl_actor_vus",
  OnCommand= function(self)
      self:diffuse(0,0,0,1);
      if GAMESTATE:IsPlayerEnabled(PLAYER_1) and not GAMESTATE:IsPlayerEnabled(PLAYER_2) then
        self:zoomto(SCREEN_WIDTH-(P1_CENTER+135), SCREEN_HEIGHT);
        self:x((SCREEN_WIDTH-(P1_CENTER+135))/2 + P1_CENTER-135+270);
      elseif not GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:IsPlayerEnabled(PLAYER_2) then
        self:zoomto(SCREEN_WIDTH-(P1_CENTER+135), SCREEN_HEIGHT);
        self:x((SCREEN_WIDTH-(P1_CENTER+135))/2);
      else
        self:zoomto(50, SCREEN_HEIGHT);
        self:x(SCREEN_CENTER_X);
      end
      
      self:y(SCREEN_CENTER_Y);
      self:sleep(song_duration);
    end,
  },
  Def.Sprite{
    Name= "xtl_actor_wus",
  Texture= "Functions",
  },
  Def.Quad{
    Name= "xtl_actor_xus",
  OnCommand= cmd(sleep,song_duration),
  },
}